/* Runnable.c generated by valac 0.44.5, the Vala compiler
 * generated from Runnable.vala, do not modify */

/*
This file is part of GameHub.
Copyright (C) 2018-2019 Anatoliy Kashkin

GameHub is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

GameHub is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GameHub.  If not, see <https://www.gnu.org/licenses/>.
*/

#include <glib-object.h>
#include <glib.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <json-glib/json-glib.h>
#include <glib/gstdio.h>
#include <gobject/gvaluecollector.h>

#define GAME_HUB_DATA_TYPE_RUNNABLE (game_hub_data_runnable_get_type ())
#define GAME_HUB_DATA_RUNNABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnable))
#define GAME_HUB_DATA_RUNNABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnableClass))
#define GAME_HUB_DATA_IS_RUNNABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_RUNNABLE))
#define GAME_HUB_DATA_IS_RUNNABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_RUNNABLE))
#define GAME_HUB_DATA_RUNNABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnableClass))

typedef struct _GameHubDataRunnable GameHubDataRunnable;
typedef struct _GameHubDataRunnableClass GameHubDataRunnableClass;
typedef struct _GameHubDataRunnablePrivate GameHubDataRunnablePrivate;
typedef enum  {
	GAME_HUB_DATA_PLATFORM_LINUX,
	GAME_HUB_DATA_PLATFORM_WINDOWS,
	GAME_HUB_DATA_PLATFORM_MACOS,
	GAME_HUB_DATA_PLATFORM_EMULATED
} GameHubDataPlatform;

#define GAME_HUB_DATA_TYPE_PLATFORM (game_hub_data_platform_get_type ())
typedef enum  {
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_INTERACTIVE,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_AUTOMATIC,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_AUTOMATIC_DOWNLOAD
} GameHubDataRunnableInstallerInstallMode;

#define GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_INSTALL_MODE (game_hub_data_runnable_installer_install_mode_get_type ())

#define GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION (game_hub_data_runnable_runnable_action_get_type ())
#define GAME_HUB_DATA_RUNNABLE_RUNNABLE_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION, GameHubDataRunnableRunnableAction))
#define GAME_HUB_DATA_RUNNABLE_RUNNABLE_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION, GameHubDataRunnableRunnableActionClass))
#define GAME_HUB_DATA_RUNNABLE_IS_RUNNABLE_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION))
#define GAME_HUB_DATA_RUNNABLE_IS_RUNNABLE_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION))
#define GAME_HUB_DATA_RUNNABLE_RUNNABLE_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION, GameHubDataRunnableRunnableActionClass))

typedef struct _GameHubDataRunnableRunnableAction GameHubDataRunnableRunnableAction;
typedef struct _GameHubDataRunnableRunnableActionClass GameHubDataRunnableRunnableActionClass;
enum  {
	GAME_HUB_DATA_RUNNABLE_0_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_ID_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_ESCAPED_NAME_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_NORMALIZED_NAME_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_NAME_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_COMPAT_TOOL_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_COMPAT_TOOL_SETTINGS_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_ARGUMENTS_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_IS_RUNNING_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_PLATFORMS_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_EXECUTABLE_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_INSTALL_DIR_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_DEFAULT_INSTALL_DIR_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_ACTIONS_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_USE_COMPAT_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_NEEDS_COMPAT_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_FORCE_COMPAT_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_COMPAT_OPTIONS_SAVED_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_NUM_PROPERTIES
};
static GParamSpec* game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GAME_HUB_DATA_TYPE_COMPAT_TOOL (game_hub_data_compat_tool_get_type ())
#define GAME_HUB_DATA_COMPAT_TOOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_COMPAT_TOOL, GameHubDataCompatTool))
#define GAME_HUB_DATA_COMPAT_TOOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_COMPAT_TOOL, GameHubDataCompatToolClass))
#define GAME_HUB_DATA_IS_COMPAT_TOOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_COMPAT_TOOL))
#define GAME_HUB_DATA_IS_COMPAT_TOOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_COMPAT_TOOL))
#define GAME_HUB_DATA_COMPAT_TOOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_COMPAT_TOOL, GameHubDataCompatToolClass))

typedef struct _GameHubDataCompatTool GameHubDataCompatTool;
typedef struct _GameHubDataCompatToolClass GameHubDataCompatToolClass;
typedef struct _Block5Data Block5Data;

#define GAME_HUB_UI_DIALOGS_TYPE_COMPAT_RUN_DIALOG (game_hub_ui_dialogs_compat_run_dialog_get_type ())
#define GAME_HUB_UI_DIALOGS_COMPAT_RUN_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UI_DIALOGS_TYPE_COMPAT_RUN_DIALOG, GameHubUIDialogsCompatRunDialog))
#define GAME_HUB_UI_DIALOGS_COMPAT_RUN_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UI_DIALOGS_TYPE_COMPAT_RUN_DIALOG, GameHubUIDialogsCompatRunDialogClass))
#define GAME_HUB_UI_DIALOGS_IS_COMPAT_RUN_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UI_DIALOGS_TYPE_COMPAT_RUN_DIALOG))
#define GAME_HUB_UI_DIALOGS_IS_COMPAT_RUN_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UI_DIALOGS_TYPE_COMPAT_RUN_DIALOG))
#define GAME_HUB_UI_DIALOGS_COMPAT_RUN_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UI_DIALOGS_TYPE_COMPAT_RUN_DIALOG, GameHubUIDialogsCompatRunDialogClass))

typedef struct _GameHubUIDialogsCompatRunDialog GameHubUIDialogsCompatRunDialog;
typedef struct _GameHubUIDialogsCompatRunDialogClass GameHubUIDialogsCompatRunDialogClass;

#define GAME_HUB_DATA_TYPE_GAME (game_hub_data_game_get_type ())
#define GAME_HUB_DATA_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_GAME, GameHubDataGame))
#define GAME_HUB_DATA_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_GAME, GameHubDataGameClass))
#define GAME_HUB_DATA_IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_GAME))
#define GAME_HUB_DATA_IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_GAME))
#define GAME_HUB_DATA_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_GAME, GameHubDataGameClass))

typedef struct _GameHubDataGame GameHubDataGame;
typedef struct _GameHubDataGameClass GameHubDataGameClass;
typedef struct _GameHubDataRunnableRunWithCompatData GameHubDataRunnableRunWithCompatData;

#define GAME_HUB_UI_WINDOWS_TYPE_MAIN_WINDOW (game_hub_ui_windows_main_window_get_type ())
#define GAME_HUB_UI_WINDOWS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UI_WINDOWS_TYPE_MAIN_WINDOW, GameHubUIWindowsMainWindow))
#define GAME_HUB_UI_WINDOWS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UI_WINDOWS_TYPE_MAIN_WINDOW, GameHubUIWindowsMainWindowClass))
#define GAME_HUB_UI_WINDOWS_IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UI_WINDOWS_TYPE_MAIN_WINDOW))
#define GAME_HUB_UI_WINDOWS_IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UI_WINDOWS_TYPE_MAIN_WINDOW))
#define GAME_HUB_UI_WINDOWS_MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UI_WINDOWS_TYPE_MAIN_WINDOW, GameHubUIWindowsMainWindowClass))

typedef struct _GameHubUIWindowsMainWindow GameHubUIWindowsMainWindow;
typedef struct _GameHubUIWindowsMainWindowClass GameHubUIWindowsMainWindowClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME (game_hub_data_sources_gog_gog_game_get_type ())
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME, GameHubDataSourcesGOGGOGGame))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME, GameHubDataSourcesGOGGOGGameClass))
#define GAME_HUB_DATA_SOURCES_GOG_IS_GOG_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME))
#define GAME_HUB_DATA_SOURCES_GOG_IS_GOG_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_SOURCES_GOG_TYPE_GOG_GAME, GameHubDataSourcesGOGGOGGameClass))

typedef struct _GameHubDataSourcesGOGGOGGame GameHubDataSourcesGOGGOGGame;
typedef struct _GameHubDataSourcesGOGGOGGameClass GameHubDataSourcesGOGGOGGameClass;

#define GAME_HUB_DATA_SOURCES_HUMBLE_TYPE_HUMBLE_GAME (game_hub_data_sources_humble_humble_game_get_type ())
#define GAME_HUB_DATA_SOURCES_HUMBLE_HUMBLE_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_SOURCES_HUMBLE_TYPE_HUMBLE_GAME, GameHubDataSourcesHumbleHumbleGame))
#define GAME_HUB_DATA_SOURCES_HUMBLE_HUMBLE_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_SOURCES_HUMBLE_TYPE_HUMBLE_GAME, GameHubDataSourcesHumbleHumbleGameClass))
#define GAME_HUB_DATA_SOURCES_HUMBLE_IS_HUMBLE_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_SOURCES_HUMBLE_TYPE_HUMBLE_GAME))
#define GAME_HUB_DATA_SOURCES_HUMBLE_IS_HUMBLE_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_SOURCES_HUMBLE_TYPE_HUMBLE_GAME))
#define GAME_HUB_DATA_SOURCES_HUMBLE_HUMBLE_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_SOURCES_HUMBLE_TYPE_HUMBLE_GAME, GameHubDataSourcesHumbleHumbleGameClass))

typedef struct _GameHubDataSourcesHumbleHumbleGame GameHubDataSourcesHumbleHumbleGame;
typedef struct _GameHubDataSourcesHumbleHumbleGameClass GameHubDataSourcesHumbleHumbleGameClass;
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

#define GAME_HUB_DATA_SOURCES_STEAM_TYPE_STEAM_GAME (game_hub_data_sources_steam_steam_game_get_type ())
#define GAME_HUB_DATA_SOURCES_STEAM_STEAM_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_SOURCES_STEAM_TYPE_STEAM_GAME, GameHubDataSourcesSteamSteamGame))
#define GAME_HUB_DATA_SOURCES_STEAM_STEAM_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_SOURCES_STEAM_TYPE_STEAM_GAME, GameHubDataSourcesSteamSteamGameClass))
#define GAME_HUB_DATA_SOURCES_STEAM_IS_STEAM_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_SOURCES_STEAM_TYPE_STEAM_GAME))
#define GAME_HUB_DATA_SOURCES_STEAM_IS_STEAM_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_SOURCES_STEAM_TYPE_STEAM_GAME))
#define GAME_HUB_DATA_SOURCES_STEAM_STEAM_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_SOURCES_STEAM_TYPE_STEAM_GAME, GameHubDataSourcesSteamSteamGameClass))

typedef struct _GameHubDataSourcesSteamSteamGame GameHubDataSourcesSteamSteamGame;
typedef struct _GameHubDataSourcesSteamSteamGameClass GameHubDataSourcesSteamSteamGameClass;

#define GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER (game_hub_data_runnable_installer_get_type ())
#define GAME_HUB_DATA_RUNNABLE_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, GameHubDataRunnableInstaller))
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, GameHubDataRunnableInstallerClass))
#define GAME_HUB_DATA_RUNNABLE_IS_INSTALLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER))
#define GAME_HUB_DATA_RUNNABLE_IS_INSTALLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER))
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, GameHubDataRunnableInstallerClass))

typedef struct _GameHubDataRunnableInstaller GameHubDataRunnableInstaller;
typedef struct _GameHubDataRunnableInstallerClass GameHubDataRunnableInstallerClass;
typedef struct _GameHubDataRunnableInstallerPrivate GameHubDataRunnableInstallerPrivate;

#define GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_PART (game_hub_data_runnable_installer_part_get_type ())
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_PART(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_PART, GameHubDataRunnableInstallerPart))
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_PART, GameHubDataRunnableInstallerPartClass))
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_IS_PART(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_PART))
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_IS_PART_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_PART))
#define GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_PART, GameHubDataRunnableInstallerPartClass))

typedef struct _GameHubDataRunnableInstallerPart GameHubDataRunnableInstallerPart;
typedef struct _GameHubDataRunnableInstallerPartClass GameHubDataRunnableInstallerPartClass;
typedef enum  {
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_UNKNOWN,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_EXECUTABLE,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_EXECUTABLE,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_GOG_PART,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_ARCHIVE,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_NSIS_INSTALLER
} GameHubDataRunnableInstallerInstallerType;

#define GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_INSTALLER_TYPE (game_hub_data_runnable_installer_installer_type_get_type ())
#define _game_hub_data_runnable_installer_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_data_runnable_installer_unref (var), NULL)))
typedef struct _GameHubDataRunnableInstallerFetchPartsData GameHubDataRunnableInstallerFetchPartsData;
typedef struct _Block6Data Block6Data;
typedef struct _Block7Data Block7Data;
typedef enum  {
	GAME_HUB_DATA_GAME_STATE_UNINSTALLED,
	GAME_HUB_DATA_GAME_STATE_INSTALLED,
	GAME_HUB_DATA_GAME_STATE_DOWNLOADING,
	GAME_HUB_DATA_GAME_STATE_VERIFYING_INSTALLER_INTEGRITY,
	GAME_HUB_DATA_GAME_STATE_INSTALLING
} GameHubDataGameState;

#define GAME_HUB_DATA_GAME_TYPE_STATE (game_hub_data_game_state_get_type ())

#define GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD (game_hub_utils_downloader_download_get_type ())
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD, GameHubUtilsDownloaderDownload))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD, GameHubUtilsDownloaderDownloadClass))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD, GameHubUtilsDownloaderDownloadClass))

typedef struct _GameHubUtilsDownloaderDownload GameHubUtilsDownloaderDownload;
typedef struct _GameHubUtilsDownloaderDownloadClass GameHubUtilsDownloaderDownloadClass;

#define GAME_HUB_DATA_GAME_TYPE_STATUS (game_hub_data_game_status_get_type ())
#define GAME_HUB_DATA_GAME_STATUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_GAME_TYPE_STATUS, GameHubDataGameStatus))
#define GAME_HUB_DATA_GAME_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_GAME_TYPE_STATUS, GameHubDataGameStatusClass))
#define GAME_HUB_DATA_GAME_IS_STATUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_GAME_TYPE_STATUS))
#define GAME_HUB_DATA_GAME_IS_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_GAME_TYPE_STATUS))
#define GAME_HUB_DATA_GAME_STATUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_GAME_TYPE_STATUS, GameHubDataGameStatusClass))

typedef struct _GameHubDataGameStatus GameHubDataGameStatus;
typedef struct _GameHubDataGameStatusClass GameHubDataGameStatusClass;
#define _game_hub_data_game_status_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_data_game_status_unref (var), NULL)))
typedef struct _Block8Data Block8Data;

#define GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOADER (game_hub_utils_downloader_downloader_get_type ())
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOADER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOADER, GameHubUtilsDownloaderDownloader))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOADER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOADER, GameHubUtilsDownloaderDownloaderClass))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOADER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOADER))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOADER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOADER))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOADER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOADER, GameHubUtilsDownloaderDownloaderClass))

typedef struct _GameHubUtilsDownloaderDownloader GameHubUtilsDownloaderDownloader;
typedef struct _GameHubUtilsDownloaderDownloaderClass GameHubUtilsDownloaderDownloaderClass;
typedef struct _GameHubUtilsDownloaderDownloadPrivate GameHubUtilsDownloaderDownloadPrivate;

#define GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_STATUS (game_hub_utils_downloader_download_status_get_type ())
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_STATUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_STATUS, GameHubUtilsDownloaderDownloadStatus))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_STATUS, GameHubUtilsDownloaderDownloadStatusClass))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD_STATUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_STATUS))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD_STATUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_STATUS))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_STATUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_STATUS, GameHubUtilsDownloaderDownloadStatusClass))

typedef struct _GameHubUtilsDownloaderDownloadStatus GameHubUtilsDownloaderDownloadStatus;
typedef struct _GameHubUtilsDownloaderDownloadStatusClass GameHubUtilsDownloaderDownloadStatusClass;

#define GAME_HUB_DATA_TYPE_GAME_SOURCE (game_hub_data_game_source_get_type ())
#define GAME_HUB_DATA_GAME_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_TYPE_GAME_SOURCE, GameHubDataGameSource))
#define GAME_HUB_DATA_GAME_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_TYPE_GAME_SOURCE, GameHubDataGameSourceClass))
#define GAME_HUB_DATA_IS_GAME_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_TYPE_GAME_SOURCE))
#define GAME_HUB_DATA_IS_GAME_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_TYPE_GAME_SOURCE))
#define GAME_HUB_DATA_GAME_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_TYPE_GAME_SOURCE, GameHubDataGameSourceClass))

typedef struct _GameHubDataGameSource GameHubDataGameSource;
typedef struct _GameHubDataGameSourceClass GameHubDataGameSourceClass;

#define GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_INFO (game_hub_utils_downloader_download_info_get_type ())
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_INFO, GameHubUtilsDownloaderDownloadInfo))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_INFO, GameHubUtilsDownloaderDownloadInfoClass))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_INFO))
#define GAME_HUB_UTILS_DOWNLOADER_IS_DOWNLOAD_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_INFO))
#define GAME_HUB_UTILS_DOWNLOADER_DOWNLOAD_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_UTILS_DOWNLOADER_TYPE_DOWNLOAD_INFO, GameHubUtilsDownloaderDownloadInfoClass))

typedef struct _GameHubUtilsDownloaderDownloadInfo GameHubUtilsDownloaderDownloadInfo;
typedef struct _GameHubUtilsDownloaderDownloadInfoClass GameHubUtilsDownloaderDownloadInfoClass;
typedef GNotification* (*GameHubUtilsNotificationConfigureDelegate) (GNotification* notification, gpointer user_data);
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

#define GAME_HUB_DATA_COMPAT_TYPE_INNOEXTRACT (game_hub_data_compat_innoextract_get_type ())
#define GAME_HUB_DATA_COMPAT_INNOEXTRACT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_COMPAT_TYPE_INNOEXTRACT, GameHubDataCompatInnoextract))
#define GAME_HUB_DATA_COMPAT_INNOEXTRACT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_COMPAT_TYPE_INNOEXTRACT, GameHubDataCompatInnoextractClass))
#define GAME_HUB_DATA_COMPAT_IS_INNOEXTRACT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_COMPAT_TYPE_INNOEXTRACT))
#define GAME_HUB_DATA_COMPAT_IS_INNOEXTRACT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_COMPAT_TYPE_INNOEXTRACT))
#define GAME_HUB_DATA_COMPAT_INNOEXTRACT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_COMPAT_TYPE_INNOEXTRACT, GameHubDataCompatInnoextractClass))

typedef struct _GameHubDataCompatInnoextract GameHubDataCompatInnoextract;
typedef struct _GameHubDataCompatInnoextractClass GameHubDataCompatInnoextractClass;

#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_DLC (game_hub_data_sources_gog_gog_game_dlc_get_type ())
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DLC(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_DLC, GameHubDataSourcesGOGGOGGameDLC))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DLC_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_DLC, GameHubDataSourcesGOGGOGGameDLCClass))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_DLC(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_DLC))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_DLC_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_DLC))
#define GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_DLC_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_TYPE_DLC, GameHubDataSourcesGOGGOGGameDLCClass))

typedef struct _GameHubDataSourcesGOGGOGGameDLC GameHubDataSourcesGOGGOGGameDLC;
typedef struct _GameHubDataSourcesGOGGOGGameDLCClass GameHubDataSourcesGOGGOGGameDLCClass;
#define _game_hub_data_runnable_runnable_action_unref0(var) ((var == NULL) ? NULL : (var = (game_hub_data_runnable_runnable_action_unref (var), NULL)))
typedef struct _GameHubDataRunnableInstallerInstallData GameHubDataRunnableInstallerInstallData;
typedef struct _GameHubDataRunnableInstallerGuessTypeData GameHubDataRunnableInstallerGuessTypeData;
typedef struct _GameHubDataRunnableInstallerPartPrivate GameHubDataRunnableInstallerPartPrivate;
enum  {
	GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_0_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_ID_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_URL_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_SIZE_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_REMOTE_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_LOCAL_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_CHECKSUM_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_CHECKSUM_TYPE_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_CHECKSUM_TYPE_STRING_PROPERTY,
	GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_NUM_PROPERTIES
};
static GParamSpec* game_hub_data_runnable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_NUM_PROPERTIES];
typedef struct _GameHubDataRunnableParamSpecInstaller GameHubDataRunnableParamSpecInstaller;
typedef struct _GameHubDataRunnableRunnableActionPrivate GameHubDataRunnableRunnableActionPrivate;
typedef struct _GameHubDataRunnableRunnableActionInvokeData GameHubDataRunnableRunnableActionInvokeData;
typedef struct _GameHubDataRunnableParamSpecRunnableAction GameHubDataRunnableParamSpecRunnableAction;

struct _GameHubDataRunnable {
	GObject parent_instance;
	GameHubDataRunnablePrivate * priv;
};

struct _GameHubDataRunnableClass {
	GObjectClass parent_class;
	gboolean (*is_supported) (GameHubDataRunnable* self, GameHubDataPlatform* platform, gboolean with_compat);
	void (*install) (GameHubDataRunnable* self, GameHubDataRunnableInstallerInstallMode install_mode, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*install_finish) (GameHubDataRunnable* self, GAsyncResult* _res_);
	void (*run) (GameHubDataRunnable* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*run_finish) (GameHubDataRunnable* self, GAsyncResult* _res_);
	void (*run_with_compat) (GameHubDataRunnable* self, gboolean is_opened_from_menu, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*run_with_compat_finish) (GameHubDataRunnable* self, GAsyncResult* _res_);
	GtkFileChooser* (*setup_executable_chooser) (GameHubDataRunnable* self);
	void (*choose_executable) (GameHubDataRunnable* self, gboolean update);
	void (*set_chosen_executable) (GameHubDataRunnable* self, GFile* file, gboolean update);
	void (*save) (GameHubDataRunnable* self);
	void (*update_status) (GameHubDataRunnable* self);
	void (*import) (GameHubDataRunnable* self, gboolean update);
	GFile* (*get_executable) (GameHubDataRunnable* self);
	void (*set_executable) (GameHubDataRunnable* self, GFile* value);
	GFile* (*get_default_install_dir) (GameHubDataRunnable* self);
};

struct _GameHubDataRunnablePrivate {
	gchar* _id;
	gchar* _name;
	gchar* _escaped_name;
	gchar* _normalized_name;
	gchar* _compat_tool;
	gchar* _compat_tool_settings;
	gchar* _arguments;
	gboolean _is_running;
	GeeArrayList* _platforms;
	GFile* _install_dir;
	GeeArrayList* _actions;
};

struct _Block5Data {
	int _ref_count_;
	GameHubDataRunnable* self;
	gpointer _async_data_;
};

struct _GameHubDataRunnableRunWithCompatData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	GameHubDataRunnable* self;
	gboolean is_opened_from_menu;
	Block5Data* _data5_;
	gboolean _tmp0_;
	GameHubUIDialogsCompatRunDialog* dlg;
	GameHubUIDialogsCompatRunDialog* _tmp1_;
	GameHubUIDialogsCompatRunDialog* _tmp2_;
};

struct _GameHubDataRunnableInstaller {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubDataRunnableInstallerPrivate * priv;
};

struct _GameHubDataRunnableInstallerClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubDataRunnableInstaller *self);
	void (*fetch_parts) (GameHubDataRunnableInstaller* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*fetch_parts_finish) (GameHubDataRunnableInstaller* self, GAsyncResult* _res_);
	gchar* (*get_name) (GameHubDataRunnableInstaller* self);
};

struct _GameHubDataRunnableInstallerPrivate {
	gchar* _id;
	GameHubDataPlatform _platform;
	GeeArrayList* _parts;
	gint64 _full_size;
	gchar* _version;
};

struct _GameHubDataRunnableInstallerFetchPartsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	GameHubDataRunnableInstaller* self;
};

struct _Block6Data {
	int _ref_count_;
	GameHubDataRunnableInstaller* self;
	GameHubDataRunnable* runnable;
	gpointer _async_data_;
};

struct _Block7Data {
	int _ref_count_;
	Block6Data * _data6_;
	GameHubDataGame* game;
};

struct _Block8Data {
	int _ref_count_;
	Block7Data * _data7_;
	GameHubDataRunnableInstallerPart* part;
	GFile* file;
};

struct _GameHubUtilsDownloaderDownload {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubUtilsDownloaderDownloadPrivate * priv;
	GFile* remote;
	GFile* local;
	GFile* local_tmp;
	GameHubUtilsDownloaderDownloadStatus* _status;
};

struct _GameHubUtilsDownloaderDownloadClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubUtilsDownloaderDownload *self);
	void (*cancel) (GameHubUtilsDownloaderDownload* self);
};

struct _GameHubDataRunnableInstallerInstallData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	GameHubDataRunnableInstaller* self;
	GameHubDataRunnable* runnable;
	gboolean dl_only;
	GameHubDataCompatTool* tool;
	Block6Data* _data6_;
	Block7Data* _data7_;
	GameHubDataGame* _tmp0_;
	GameHubDataGame* _tmp1_;
	GameHubDataGame* _tmp2_;
	GameHubDataGame* _tmp3_;
	GameHubDataGameStatus* _tmp4_;
	GameHubDataGameStatus* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	GFile* runnable_install_dir;
	GFile* _tmp12_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	GeeArrayList* files;
	GeeArrayList* _tmp15_;
	guint p;
	GeeArrayList* _part_list;
	GeeArrayList* _tmp16_;
	GeeArrayList* _tmp17_;
	gint _part_size;
	GeeArrayList* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gint _part_index;
	Block8Data* _data8_;
	GeeArrayList* _tmp21_;
	gpointer _tmp22_;
	gulong ds_id;
	GameHubUtilsDownloaderDownloader* _tmp23_;
	GameHubUtilsDownloaderDownloader* _tmp24_;
	gulong _tmp25_;
	gulong _tmp26_;
	gchar* partDesc;
	GameHubDataRunnableInstallerPart* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	gchar* _tmp30_;
	GeeArrayList* _tmp31_;
	gint _tmp32_;
	gint _tmp33_;
	GeeArrayList* _tmp34_;
	gint _tmp35_;
	gint _tmp36_;
	GameHubDataRunnableInstallerPart* _tmp37_;
	const gchar* _tmp38_;
	const gchar* _tmp39_;
	gchar* _tmp40_;
	const gchar* _tmp41_;
	GameHubDataGame* _tmp42_;
	GameHubDataGame* _tmp43_;
	const gchar* _tmp44_;
	const gchar* _tmp45_;
	const gchar* _tmp46_;
	GameHubDataGame* _tmp47_;
	GameHubDataGame* _tmp48_;
	GameHubDataGameSource* _tmp49_;
	GameHubDataGameSource* _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	GameHubUtilsDownloaderDownloadInfo* info;
	const gchar* _tmp53_;
	const gchar* _tmp54_;
	const gchar* _tmp55_;
	GameHubUtilsDownloaderDownloadInfo* _tmp56_;
	GameHubDataRunnableInstallerPart* _tmp57_;
	GFile* _tmp58_;
	GFile* _tmp59_;
	GameHubDataRunnableInstallerPart* _tmp60_;
	GFile* _tmp61_;
	GFile* _tmp62_;
	GameHubUtilsDownloaderDownloadInfo* _tmp63_;
	GFile* _tmp64_;
	gboolean _tmp65_;
	GFile* _tmp66_;
	GFile* _tmp67_;
	gchar* file_checksum;
	GameHubDataRunnableInstallerPart* _tmp68_;
	const gchar* _tmp69_;
	const gchar* _tmp70_;
	GFile* _tmp71_;
	gchar* _tmp72_;
	gchar* _tmp73_;
	gchar* _tmp74_;
	gchar* _tmp75_;
	GameHubDataRunnableInstallerPart* _tmp76_;
	const gchar* _tmp77_;
	const gchar* _tmp78_;
	gchar* _tmp79_;
	gchar* _tmp80_;
	GameHubDataRunnableInstallerPart* _tmp81_;
	const gchar* _tmp82_;
	const gchar* _tmp83_;
	GameHubDataGame* _tmp84_;
	GameHubDataGame* _tmp85_;
	GameHubDataGame* _tmp86_;
	GameHubDataGameStatus* _tmp87_;
	GameHubDataGameStatus* _tmp88_;
	GFile* _tmp89_;
	GameHubDataRunnableInstallerPart* _tmp90_;
	GChecksumType _tmp91_;
	GChecksumType _tmp92_;
	gchar* _tmp93_;
	GameHubDataGame* _tmp94_;
	GameHubDataGame* _tmp95_;
	GameHubDataGame* _tmp96_;
	GameHubDataGameStatus* _tmp97_;
	GameHubDataGameStatus* _tmp98_;
	gboolean _tmp99_;
	gboolean _tmp100_;
	GameHubDataRunnableInstallerPart* _tmp101_;
	const gchar* _tmp102_;
	const gchar* _tmp103_;
	const gchar* _tmp104_;
	GameHubDataRunnableInstallerPart* _tmp105_;
	const gchar* _tmp106_;
	const gchar* _tmp107_;
	const gchar* _tmp108_;
	GeeArrayList* _tmp109_;
	GFile* _tmp110_;
	const gchar* _tmp111_;
	const gchar* _tmp112_;
	gchar* _tmp113_;
	gchar* _tmp114_;
	GFile* _tmp115_;
	gchar* _tmp116_;
	gchar* _tmp117_;
	gchar* _tmp118_;
	gchar* _tmp119_;
	GFile* _tmp120_;
	gchar* _tmp121_;
	gchar* _tmp122_;
	GameHubDataRunnableInstallerPart* _tmp123_;
	const gchar* _tmp124_;
	const gchar* _tmp125_;
	const gchar* _tmp126_;
	GameHubUtilsDownloaderDownloader* _tmp127_;
	GameHubUtilsDownloaderDownloader* _tmp128_;
	guint _tmp129_;
	GameHubDataGame* _tmp130_;
	GameHubDataGame* _tmp131_;
	GameHubDataGame* _tmp132_;
	GameHubDataGameStatus* _tmp133_;
	GameHubDataGameStatus* _tmp134_;
	gboolean _tmp135_;
	GeeArrayList* _tmp136_;
	gint _tmp137_;
	gint _tmp138_;
	guint f;
	gboolean windows_installer;
	gboolean nsis_installer;
	GeeArrayList* _file_list;
	GeeArrayList* _tmp139_;
	GeeArrayList* _tmp140_;
	gint _file_size;
	GeeArrayList* _tmp141_;
	gint _tmp142_;
	gint _tmp143_;
	gint _file_index;
	GFile* file;
	GeeArrayList* _tmp144_;
	gpointer _tmp145_;
	gchar* path;
	GFile* _tmp146_;
	gchar* _tmp147_;
	gchar* _tmp148_;
	gchar* _tmp149_;
	const gchar* _tmp150_;
	gchar* _tmp151_;
	gchar** _tmp152_;
	gchar** _tmp153_;
	gint _tmp153__length1;
	gchar* _tmp154_;
	gchar* _tmp155_;
	GFile* _tmp156_;
	GFile* _tmp157_;
	gchar* _tmp158_;
	gchar* _tmp159_;
	GFile* _tmp160_;
	GFile* _tmp161_;
	GameHubDataRunnableInstallerInstallerType type;
	GFile* _tmp162_;
	gboolean _tmp163_;
	GameHubDataRunnableInstallerInstallerType _tmp164_;
	gchar* desc;
	gchar* _tmp165_;
	gchar* _tmp166_;
	const gchar* _tmp167_;
	gchar* _tmp168_;
	gchar** _tmp169_;
	gchar** _tmp170_;
	gint _tmp170__length1;
	gchar* _tmp171_;
	gchar* _tmp172_;
	gboolean _tmp173_;
	gboolean _tmp174_;
	const gchar* _tmp175_;
	const gchar* _tmp176_;
	gint _tmp177_;
	gint _tmp178_;
	const gchar* _tmp179_;
	const gchar* _tmp180_;
	gchar** cmd;
	gint cmd_length1;
	gint _cmd_size_;
	GameHubDataRunnableInstallerInstallerType _tmp181_;
	const gchar* _tmp182_;
	gchar* _tmp183_;
	gchar* _tmp184_;
	gchar* _tmp185_;
	gchar* _tmp186_;
	gchar* _tmp187_;
	gchar* _tmp188_;
	gchar* _tmp189_;
	GFile* _tmp190_;
	GFile* _tmp191_;
	gchar* _tmp192_;
	gchar* _tmp193_;
	gchar* _tmp194_;
	gchar** _tmp195_;
	gchar* _tmp196_;
	const gchar* _tmp197_;
	gchar* _tmp198_;
	gchar* _tmp199_;
	GFile* _tmp200_;
	GFile* _tmp201_;
	gchar* _tmp202_;
	gchar** _tmp203_;
	gchar* _tmp204_;
	const gchar* _tmp205_;
	gchar* _tmp206_;
	gchar** _tmp207_;
	GameHubDataGame* _tmp208_;
	GameHubDataGame* _tmp209_;
	GameHubDataGame* _tmp210_;
	GameHubDataGameStatus* _tmp211_;
	GameHubDataGameStatus* _tmp212_;
	gchar** _tmp213_;
	gint _tmp213__length1;
	gchar** _tmp214_;
	gint _tmp214__length1;
	GameHubDataRunnableInstallerInstallerType _tmp215_;
	gboolean _tmp216_;
	GFile* _tmp217_;
	GameHubDataRunnableInstallerInstallerType _tmp218_;
	guint _tmp219_;
	GFile* _tmp220_;
	GFile* _tmp221_;
	gchar* _tmp222_;
	gchar* _tmp223_;
	gint dircount;
	gchar* dirname;
	GFileInfo* finfo;
	GFileEnumerator* enumerator;
	GFile* _tmp224_;
	GFile* _tmp225_;
	GFileEnumerator* _tmp226_;
	GFileInfo* _tmp227_;
	GFileEnumerator* _tmp228_;
	GFileInfo* _tmp229_;
	GFileInfo* _tmp230_;
	GFileInfo* _tmp231_;
	gboolean _tmp232_;
	GFileInfo* _tmp233_;
	GFileInfo* _tmp234_;
	const gchar* _tmp235_;
	gint _tmp236_;
	const gchar* _tmp237_;
	gboolean _tmp238_;
	const gchar* _tmp239_;
	GFileInfo* _tmp240_;
	const gchar* _tmp241_;
	gchar* _tmp242_;
	GFileInfo* _tmp243_;
	gboolean _tmp244_;
	const gchar* _tmp245_;
	GFile* _tmp246_;
	GFile* _tmp247_;
	const gchar* _tmp248_;
	gchar* _tmp249_;
	gchar* _tmp250_;
	gboolean _tmp251_;
	GameHubDataPlatform _tmp252_;
	GError* e;
	gboolean _tmp253_;
	gboolean _tmp254_;
	gboolean _tmp255_;
	GFile* _tmp256_;
	GFile* _tmp257_;
	GFile* _tmp258_;
	gboolean _tmp259_;
	GFile* _tmp260_;
	GFile* _tmp261_;
	GFile* _tmp262_;
	gboolean _tmp263_;
	GeeArrayList* _tmp264_;
	GeeArrayList* _tmp265_;
	GeeArrayList* _tmp266_;
	GeeArrayList* _tmp267_;
	gint _tmp268_;
	gint _tmp269_;
	GeeArrayList* _action_list;
	GeeArrayList* _tmp270_;
	GeeArrayList* _tmp271_;
	GeeArrayList* _tmp272_;
	gint _action_size;
	GeeArrayList* _tmp273_;
	gint _tmp274_;
	gint _tmp275_;
	gint _action_index;
	GameHubDataRunnableRunnableAction* action;
	GeeArrayList* _tmp276_;
	gpointer _tmp277_;
	GameHubDataRunnableRunnableAction* _tmp278_;
	gboolean _tmp279_;
	gboolean _tmp280_;
	gboolean _tmp281_;
	GameHubDataRunnableRunnableAction* _tmp282_;
	GFile* _tmp283_;
	GFile* _tmp284_;
	GameHubDataRunnableRunnableAction* _tmp285_;
	GFile* _tmp286_;
	GFile* _tmp287_;
	GameHubDataRunnableRunnableAction* _tmp288_;
	GFile* _tmp289_;
	GFile* _tmp290_;
	GameHubDataRunnableRunnableAction* _tmp291_;
	const gchar* _tmp292_;
	const gchar* _tmp293_;
	gboolean _tmp294_;
	gboolean _tmp295_;
	GFile* _tmp296_;
	GFile* _tmp297_;
	GFile* _tmp298_;
	gboolean _tmp299_;
	GFile* _tmp300_;
	GFile* _tmp301_;
	GFile* _tmp302_;
	GameHubDataGame* _tmp303_;
	GameHubDataGame* _tmp304_;
	const gchar* _tmp305_;
	const gchar* _tmp306_;
	gchar* _tmp307_;
	gchar* _tmp308_;
	gboolean _tmp309_;
	GameHubDataGame* _tmp310_;
	const gchar* _tmp311_;
	GameHubDataGame* _tmp312_;
	const gchar* _tmp313_;
	GFile* gh_marker;
	GFile* _tmp314_;
	GFile* _tmp315_;
	const gchar* _tmp316_;
	const gchar* _tmp317_;
	gchar* _tmp318_;
	gchar* _tmp319_;
	GFile* _tmp320_;
	GFile* _tmp321_;
	GFile* _tmp322_;
	GFile* _tmp323_;
	gchar* _tmp324_;
	gchar* _tmp325_;
	GError* _vala1_e;
	GError* _vala2_e;
	GError* _tmp326_;
	const gchar* _tmp327_;
	GError* _inner_error0_;
};

struct _GameHubDataRunnableInstallerGuessTypeData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	GFile* file;
	gboolean part;
	GameHubDataRunnableInstallerInstallerType result;
	GameHubDataRunnableInstallerInstallerType type;
	GFileInfo* finfo;
	GFileInfo* _tmp0_;
	gchar* mime;
	GFileInfo* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	GameHubDataRunnableInstallerInstallerType _tmp5_;
	gchar* info;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar** _tmp9_;
	gchar** _tmp10_;
	gint _tmp10__length1;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gboolean _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	const gchar* _tmp18_;
	gchar** _tmp19_;
	gchar** _tmp20_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gboolean _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	const gchar* _tmp29_;
	GameHubDataRunnableInstallerInstallerType _tmp30_;
	gchar** gog_part_ext;
	gchar* _tmp31_;
	gchar** _tmp32_;
	gint gog_part_ext_length1;
	gint _gog_part_ext_size_;
	gchar** exe_ext;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar** _tmp37_;
	gint exe_ext_length1;
	gint _exe_ext_size_;
	gchar** win_exe_ext;
	gchar* _tmp38_;
	gchar* _tmp39_;
	gchar** _tmp40_;
	gint win_exe_ext_length1;
	gint _win_exe_ext_size_;
	gchar** arc_ext;
	gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	gchar** _tmp50_;
	gint arc_ext_length1;
	gint _arc_ext_size_;
	gchar** _tmp51_;
	gint _tmp51__length1;
	gchar** ext_collection;
	gint ext_collection_length1;
	gint _ext_collection_size_;
	gint ext_it;
	gchar* _tmp52_;
	gchar* ext;
	gchar* _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
	const gchar* _tmp57_;
	const gchar* _tmp58_;
	gchar* _tmp59_;
	gchar* _tmp60_;
	gboolean _tmp61_;
	gchar** _tmp62_;
	gint _tmp62__length1;
	gchar** _vala1_ext_collection;
	gint _vala1_ext_collection_length1;
	gint __vala1_ext_collection_size_;
	gint _vala1_ext_it;
	gchar* _tmp63_;
	gchar* _vala1_ext;
	gchar* _tmp64_;
	gchar* _tmp65_;
	gchar* _tmp66_;
	gchar* _tmp67_;
	const gchar* _tmp68_;
	const gchar* _tmp69_;
	gchar* _tmp70_;
	gchar* _tmp71_;
	gboolean _tmp72_;
	gchar** _tmp73_;
	gint _tmp73__length1;
	gchar** _vala2_ext_collection;
	gint _vala2_ext_collection_length1;
	gint __vala2_ext_collection_size_;
	gint _vala2_ext_it;
	gchar* _tmp74_;
	gchar* _vala2_ext;
	gchar* _tmp75_;
	gchar* _tmp76_;
	gchar* _tmp77_;
	gchar* _tmp78_;
	const gchar* _tmp79_;
	const gchar* _tmp80_;
	gchar* _tmp81_;
	gchar* _tmp82_;
	gboolean _tmp83_;
	gchar** _tmp84_;
	gint _tmp84__length1;
	gchar** _vala3_ext_collection;
	gint _vala3_ext_collection_length1;
	gint __vala3_ext_collection_size_;
	gint _vala3_ext_it;
	gchar* _tmp85_;
	gchar* _vala3_ext;
	gchar* _tmp86_;
	gchar* _tmp87_;
	gchar* _tmp88_;
	gchar* _tmp89_;
	const gchar* _tmp90_;
	const gchar* _tmp91_;
	gchar* _tmp92_;
	gchar* _tmp93_;
	gboolean _tmp94_;
	GError* e;
	GError* _inner_error0_;
};

struct _GameHubDataRunnableInstallerPart {
	GObject parent_instance;
	GameHubDataRunnableInstallerPartPrivate * priv;
};

struct _GameHubDataRunnableInstallerPartClass {
	GObjectClass parent_class;
};

struct _GameHubDataRunnableInstallerPartPrivate {
	gchar* _id;
	gchar* _url;
	gint64 _size;
	GFile* _remote;
	GFile* _local;
	gchar* _checksum;
	GChecksumType _checksum_type;
};

struct _GameHubDataRunnableParamSpecInstaller {
	GParamSpec parent_instance;
};

struct _GameHubDataRunnableRunnableAction {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GameHubDataRunnableRunnableActionPrivate * priv;
};

struct _GameHubDataRunnableRunnableActionClass {
	GTypeClass parent_class;
	void (*finalize) (GameHubDataRunnableRunnableAction *self);
};

struct _GameHubDataRunnableRunnableActionPrivate {
	GameHubDataRunnable* _runnable;
	gboolean _is_primary;
	gboolean _is_hidden;
	gchar* _name;
	GFile* _file;
	GFile* _workdir;
	gchar* _args;
	GType** _compat_tools;
	gint _compat_tools_length1;
	gint __compat_tools_size_;
	gchar* _uri;
};

struct _GameHubDataRunnableRunnableActionInvokeData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	GameHubDataRunnableRunnableAction* self;
	GameHubDataCompatTool* tool;
	gboolean _tmp0_;
	GFile* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_;
	GameHubDataRunnable* _tmp5_;
	GameHubDataRunnable* _tmp6_;
};

struct _GameHubDataRunnableParamSpecRunnableAction {
	GParamSpec parent_instance;
};

static gint GameHubDataRunnable_private_offset;
static gpointer game_hub_data_runnable_parent_class = NULL;
extern GameHubDataCompatTool** game_hub_data_CompatTools;
extern gint game_hub_data_CompatTools_length1;
extern gboolean game_hub_data_RunnableIsLaunched;
extern gboolean game_hub_data_sources_steam_steam_IsAnyAppRunning;
extern GameHubUIWindowsMainWindow* game_hub_ui_windows_main_window_instance;
static gint GameHubDataRunnableInstaller_private_offset;
static gpointer game_hub_data_runnable_installer_parent_class = NULL;
static gchar* game_hub_data_runnable_installer_NSIS_INSTALLER_DESCRIPTION;
static gchar* game_hub_data_runnable_installer_NSIS_INSTALLER_DESCRIPTION = NULL;
static gint GameHubDataRunnableInstallerPart_private_offset;
static gpointer game_hub_data_runnable_installer_part_parent_class = NULL;
static gint GameHubDataRunnableRunnableAction_private_offset;
static gpointer game_hub_data_runnable_runnable_action_parent_class = NULL;
gboolean game_hub_data_RunnableIsLaunched = FALSE;

GType game_hub_data_runnable_get_type (void) G_GNUC_CONST;
GType game_hub_data_platform_get_type (void) G_GNUC_CONST;
GType game_hub_data_runnable_installer_install_mode_get_type (void) G_GNUC_CONST;
gpointer game_hub_data_runnable_runnable_action_ref (gpointer instance);
void game_hub_data_runnable_runnable_action_unref (gpointer instance);
GParamSpec* game_hub_data_runnable_param_spec_runnable_action (const gchar* name,
                                                               const gchar* nick,
                                                               const gchar* blurb,
                                                               GType object_type,
                                                               GParamFlags flags);
void game_hub_data_runnable_value_set_runnable_action (GValue* value,
                                                       gpointer v_object);
void game_hub_data_runnable_value_take_runnable_action (GValue* value,
                                                        gpointer v_object);
gpointer game_hub_data_runnable_value_get_runnable_action (const GValue* value);
GType game_hub_data_runnable_runnable_action_get_type (void) G_GNUC_CONST;
gboolean game_hub_data_runnable_is_supported (GameHubDataRunnable* self,
                                              GameHubDataPlatform* platform,
                                              gboolean with_compat);
static gboolean game_hub_data_runnable_real_is_supported (GameHubDataRunnable* self,
                                                   GameHubDataPlatform* platform,
                                                   gboolean with_compat);
#define GAME_HUB_DATA_PLATFORM_CURRENT GAME_HUB_DATA_PLATFORM_LINUX
GeeArrayList* game_hub_data_runnable_get_platforms (GameHubDataRunnable* self);
GType game_hub_data_compat_tool_get_type (void) G_GNUC_CONST;
gboolean game_hub_data_compat_tool_can_run (GameHubDataCompatTool* self,
                                            GameHubDataRunnable* runnable);
void game_hub_data_runnable_install (GameHubDataRunnable* self,
                                     GameHubDataRunnableInstallerInstallMode install_mode,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
void game_hub_data_runnable_install_finish (GameHubDataRunnable* self,
                                            GAsyncResult* _res_);
void game_hub_data_runnable_run (GameHubDataRunnable* self,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
void game_hub_data_runnable_run_finish (GameHubDataRunnable* self,
                                        GAsyncResult* _res_);
static void game_hub_data_runnable_real_run_with_compat_data_free (gpointer _data);
static void game_hub_data_runnable_real_run_with_compat_async_ready_wrapper (GObject *source_object,
                                                                      GAsyncResult *res,
                                                                      void *user_data);
static void game_hub_data_runnable_real_run_with_compat (GameHubDataRunnable* self,
                                                  gboolean is_opened_from_menu,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
void game_hub_data_runnable_run_with_compat (GameHubDataRunnable* self,
                                             gboolean is_opened_from_menu,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_);
void game_hub_data_runnable_run_with_compat_finish (GameHubDataRunnable* self,
                                                    GAsyncResult* _res_);
static gboolean game_hub_data_runnable_real_run_with_compat_co (GameHubDataRunnableRunWithCompatData* _data_);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
GType game_hub_ui_dialogs_compat_run_dialog_get_type (void) G_GNUC_CONST;
GType game_hub_data_game_get_type (void) G_GNUC_CONST;
GameHubUIDialogsCompatRunDialog* game_hub_ui_dialogs_compat_run_dialog_new (GameHubDataRunnable* game,
                                                                            gboolean is_opened_from_menu,
                                                                            GameHubDataGame* emulated_game,
                                                                            gboolean launch_in_game_dir);
GameHubUIDialogsCompatRunDialog* game_hub_ui_dialogs_compat_run_dialog_construct (GType object_type,
                                                                                  GameHubDataRunnable* game,
                                                                                  gboolean is_opened_from_menu,
                                                                                  GameHubDataGame* emulated_game,
                                                                                  gboolean launch_in_game_dir);
static void ___lambda67_ (Block5Data* _data5_);
static gboolean _game_hub_data_runnable_real_run_with_compat_co_gsource_func (gpointer self);
static void ____lambda67__gtk_widget_destroy (GtkWidget* _sender,
                                       gpointer self);
GtkFileChooser* game_hub_data_runnable_setup_executable_chooser (GameHubDataRunnable* self);
static GtkFileChooser* game_hub_data_runnable_real_setup_executable_chooser (GameHubDataRunnable* self);
GType game_hub_ui_windows_main_window_get_type (void) G_GNUC_CONST;
GFile* game_hub_data_runnable_get_executable (GameHubDataRunnable* self);
static gint game_hub_data_runnable_run_executable_chooser (GameHubDataRunnable* self,
                                                    GtkFileChooser* chooser);
void game_hub_data_runnable_choose_executable (GameHubDataRunnable* self,
                                               gboolean update);
static void game_hub_data_runnable_real_choose_executable (GameHubDataRunnable* self,
                                                    gboolean update);
void game_hub_data_runnable_set_chosen_executable (GameHubDataRunnable* self,
                                                   GFile* file,
                                                   gboolean update);
static void game_hub_data_runnable_real_set_chosen_executable (GameHubDataRunnable* self,
                                                        GFile* file,
                                                        gboolean update);
void game_hub_data_runnable_set_executable (GameHubDataRunnable* self,
                                            GFile* value);
gchar* game_hub_utils_run (gchar** cmd,
                           gint cmd_length1,
                           const gchar* dir,
                           gchar** env,
                           gint env_length1,
                           gboolean override_runtime,
                           gboolean capture_output,
                           gboolean log);
void game_hub_data_runnable_update_status (GameHubDataRunnable* self);
void game_hub_data_runnable_save (GameHubDataRunnable* self);
static void game_hub_data_runnable_real_save (GameHubDataRunnable* self);
static void game_hub_data_runnable_real_update_status (GameHubDataRunnable* self);
void game_hub_data_runnable_import (GameHubDataRunnable* self,
                                    gboolean update);
static void game_hub_data_runnable_real_import (GameHubDataRunnable* self,
                                         gboolean update);
GType game_hub_data_sources_gog_gog_game_get_type (void) G_GNUC_CONST;
gchar* game_hub_utils_fs_utils_paths_gog_get_Games (void);
GType game_hub_data_sources_humble_humble_game_get_type (void) G_GNUC_CONST;
gchar* game_hub_utils_fs_utils_paths_humble_get_Games (void);
void game_hub_data_runnable_set_install_dir (GameHubDataRunnable* self,
                                             GFile* value);
GFile* game_hub_utils_fs_utils_file (const gchar* path,
                                     const gchar* file,
                                     GeeHashMap* variables);
GFile* game_hub_data_runnable_get_install_dir (GameHubDataRunnable* self);
JsonObject* game_hub_data_runnable_get_compat_settings (GameHubDataRunnable* self,
                                                        GameHubDataCompatTool* tool);
const gchar* game_hub_data_runnable_get_compat_tool_settings (GameHubDataRunnable* self);
JsonNode* game_hub_utils_parser_parse_json (const gchar* json);
JsonObject* game_hub_utils_parser_json_object (JsonNode* root,
                                               gchar** keys,
                                               gint keys_length1);
const gchar* game_hub_data_compat_tool_get_id (GameHubDataCompatTool* self);
static void _vala_JsonNode_free (JsonNode* self);
void game_hub_data_runnable_set_compat_settings (GameHubDataRunnable* self,
                                                 GameHubDataCompatTool* tool,
                                                 JsonObject* settings);
void game_hub_data_runnable_set_compat_tool_settings (GameHubDataRunnable* self,
                                                      const gchar* value);
void game_hub_data_runnable_set_compat_options_saved (GameHubDataRunnable* self,
                                                      gboolean value);
gboolean* game_hub_data_runnable_get_compat_option_bool (GameHubDataRunnable* self,
                                                         const gchar* key);
static gboolean* _bool_dup (gboolean* self);
void game_hub_data_runnable_set_compat_option_bool (GameHubDataRunnable* self,
                                                    const gchar* key,
                                                    gboolean* value);
GameHubDataRunnable* game_hub_data_runnable_construct (GType object_type);
const gchar* game_hub_data_runnable_get_id (GameHubDataRunnable* self);
void game_hub_data_runnable_set_id (GameHubDataRunnable* self,
                                    const gchar* value);
const gchar* game_hub_data_runnable_get_escaped_name (GameHubDataRunnable* self);
void game_hub_data_runnable_set_escaped_name (GameHubDataRunnable* self,
                                              const gchar* value);
const gchar* game_hub_data_runnable_get_normalized_name (GameHubDataRunnable* self);
void game_hub_data_runnable_set_normalized_name (GameHubDataRunnable* self,
                                                 const gchar* value);
const gchar* game_hub_data_runnable_get_name (GameHubDataRunnable* self);
void game_hub_data_runnable_set_name (GameHubDataRunnable* self,
                                      const gchar* value);
gchar* game_hub_utils_strip_name (const gchar* name,
                                  const gchar* keep,
                                  gboolean move_the);
const gchar* game_hub_data_runnable_get_compat_tool (GameHubDataRunnable* self);
void game_hub_data_runnable_set_compat_tool (GameHubDataRunnable* self,
                                             const gchar* value);
const gchar* game_hub_data_runnable_get_arguments (GameHubDataRunnable* self);
void game_hub_data_runnable_set_arguments (GameHubDataRunnable* self,
                                           const gchar* value);
gboolean game_hub_data_runnable_get_is_running (GameHubDataRunnable* self);
void game_hub_data_runnable_set_is_running (GameHubDataRunnable* self,
                                            gboolean value);
void game_hub_data_runnable_set_platforms (GameHubDataRunnable* self,
                                           GeeArrayList* value);
GFile* game_hub_data_runnable_get_default_install_dir (GameHubDataRunnable* self);
GeeArrayList* game_hub_data_runnable_get_actions (GameHubDataRunnable* self);
void game_hub_data_runnable_set_actions (GameHubDataRunnable* self,
                                         GeeArrayList* value);
gboolean game_hub_data_runnable_get_use_compat (GameHubDataRunnable* self);
gboolean game_hub_data_runnable_get_needs_compat (GameHubDataRunnable* self);
gboolean game_hub_data_runnable_get_force_compat (GameHubDataRunnable* self);
GType game_hub_data_sources_steam_steam_game_get_type (void) G_GNUC_CONST;
static gboolean _bool_equal (const gboolean * s1,
                      const gboolean * s2);
void game_hub_data_runnable_set_force_compat (GameHubDataRunnable* self,
                                              gboolean value);
gboolean game_hub_data_runnable_get_compat_options_saved (GameHubDataRunnable* self);
gpointer game_hub_data_runnable_installer_ref (gpointer instance);
void game_hub_data_runnable_installer_unref (gpointer instance);
GParamSpec* game_hub_data_runnable_param_spec_installer (const gchar* name,
                                                         const gchar* nick,
                                                         const gchar* blurb,
                                                         GType object_type,
                                                         GParamFlags flags);
void game_hub_data_runnable_value_set_installer (GValue* value,
                                                 gpointer v_object);
void game_hub_data_runnable_value_take_installer (GValue* value,
                                                  gpointer v_object);
gpointer game_hub_data_runnable_value_get_installer (const GValue* value);
GType game_hub_data_runnable_installer_get_type (void) G_GNUC_CONST;
GType game_hub_data_runnable_installer_part_get_type (void) G_GNUC_CONST;
GType game_hub_data_runnable_installer_installer_type_get_type (void) G_GNUC_CONST;
GameHubDataRunnableInstallerInstallerType game_hub_data_runnable_installer_installer_type_from_mime (const gchar* type);
static void game_hub_data_runnable_installer_real_fetch_parts_data_free (gpointer _data);
static void game_hub_data_runnable_installer_real_fetch_parts_async_ready_wrapper (GObject *source_object,
                                                                            GAsyncResult *res,
                                                                            void *user_data);
static void game_hub_data_runnable_installer_real_fetch_parts (GameHubDataRunnableInstaller* self,
                                                        GAsyncReadyCallback _callback_,
                                                        gpointer _user_data_);
void game_hub_data_runnable_installer_fetch_parts (GameHubDataRunnableInstaller* self,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_);
void game_hub_data_runnable_installer_fetch_parts_finish (GameHubDataRunnableInstaller* self,
                                                          GAsyncResult* _res_);
static gboolean game_hub_data_runnable_installer_real_fetch_parts_co (GameHubDataRunnableInstallerFetchPartsData* _data_);
static void game_hub_data_runnable_installer_install_data_free (gpointer _data);
static void game_hub_data_runnable_installer_install_async_ready_wrapper (GObject *source_object,
                                                                   GAsyncResult *res,
                                                                   void *user_data);
void game_hub_data_runnable_installer_install (GameHubDataRunnableInstaller* self,
                                               GameHubDataRunnable* runnable,
                                               gboolean dl_only,
                                               GameHubDataCompatTool* tool,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
void game_hub_data_runnable_installer_install_finish (GameHubDataRunnableInstaller* self,
                                                      GAsyncResult* _res_);
static gboolean game_hub_data_runnable_installer_install_co (GameHubDataRunnableInstallerInstallData* _data_);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
GType game_hub_data_game_state_get_type (void) G_GNUC_CONST;
gpointer game_hub_utils_downloader_download_ref (gpointer instance);
void game_hub_utils_downloader_download_unref (gpointer instance);
GParamSpec* game_hub_utils_downloader_param_spec_download (const gchar* name,
                                                           const gchar* nick,
                                                           const gchar* blurb,
                                                           GType object_type,
                                                           GParamFlags flags);
void game_hub_utils_downloader_value_set_download (GValue* value,
                                                   gpointer v_object);
void game_hub_utils_downloader_value_take_download (GValue* value,
                                                    gpointer v_object);
gpointer game_hub_utils_downloader_value_get_download (const GValue* value);
GType game_hub_utils_downloader_download_get_type (void) G_GNUC_CONST;
GameHubDataGameStatus* game_hub_data_game_status_new (GameHubDataGameState state,
                                                      GameHubDataGame* game,
                                                      GameHubUtilsDownloaderDownload* download);
GameHubDataGameStatus* game_hub_data_game_status_construct (GType object_type,
                                                            GameHubDataGameState state,
                                                            GameHubDataGame* game,
                                                            GameHubUtilsDownloaderDownload* download);
gpointer game_hub_data_game_status_ref (gpointer instance);
void game_hub_data_game_status_unref (gpointer instance);
GParamSpec* game_hub_data_game_param_spec_status (const gchar* name,
                                                  const gchar* nick,
                                                  const gchar* blurb,
                                                  GType object_type,
                                                  GParamFlags flags);
void game_hub_data_game_value_set_status (GValue* value,
                                          gpointer v_object);
void game_hub_data_game_value_take_status (GValue* value,
                                           gpointer v_object);
gpointer game_hub_data_game_value_get_status (const GValue* value);
GType game_hub_data_game_status_get_type (void) G_GNUC_CONST;
void game_hub_data_game_set_status (GameHubDataGame* self,
                                    GameHubDataGameStatus* value);
GeeArrayList* game_hub_data_runnable_installer_get_parts (GameHubDataRunnableInstaller* self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
GType game_hub_utils_downloader_downloader_get_type (void) G_GNUC_CONST;
GameHubUtilsDownloaderDownloader* game_hub_utils_downloader_get_instance (void);
static void _____lambda17_ (Block8Data* _data8_,
                     GameHubUtilsDownloaderDownload* dl);
gpointer game_hub_utils_downloader_download_status_ref (gpointer instance);
void game_hub_utils_downloader_download_status_unref (gpointer instance);
GParamSpec* game_hub_utils_downloader_param_spec_download_status (const gchar* name,
                                                                  const gchar* nick,
                                                                  const gchar* blurb,
                                                                  GType object_type,
                                                                  GParamFlags flags);
void game_hub_utils_downloader_value_set_download_status (GValue* value,
                                                          gpointer v_object);
void game_hub_utils_downloader_value_take_download_status (GValue* value,
                                                           gpointer v_object);
gpointer game_hub_utils_downloader_value_get_download_status (const GValue* value);
GType game_hub_utils_downloader_download_status_get_type (void) G_GNUC_CONST;
GFile* game_hub_data_runnable_installer_part_get_remote (GameHubDataRunnableInstallerPart* self);
static void ___lambda18_ (Block8Data* _data8_,
                   GameHubUtilsDownloaderDownloadStatus* s);
GameHubDataGameStatus* game_hub_data_game_get_status (GameHubDataGame* self);
static void ____lambda18__game_hub_utils_downloader_download_status_change (GameHubUtilsDownloaderDownload* _sender,
                                                                     GameHubUtilsDownloaderDownloadStatus* status,
                                                                     gpointer self);
static void ______lambda17__game_hub_utils_downloader_downloader_download_started (GameHubUtilsDownloaderDownloader* _sender,
                                                                            GameHubUtilsDownloaderDownload* download,
                                                                            gpointer self);
const gchar* game_hub_data_runnable_installer_part_get_id (GameHubDataRunnableInstallerPart* self);
const gchar* game_hub_data_game_get_icon (GameHubDataGame* self);
gpointer game_hub_data_game_source_ref (gpointer instance);
void game_hub_data_game_source_unref (gpointer instance);
GParamSpec* game_hub_data_param_spec_game_source (const gchar* name,
                                                  const gchar* nick,
                                                  const gchar* blurb,
                                                  GType object_type,
                                                  GParamFlags flags);
void game_hub_data_value_set_game_source (GValue* value,
                                          gpointer v_object);
void game_hub_data_value_take_game_source (GValue* value,
                                           gpointer v_object);
gpointer game_hub_data_value_get_game_source (const GValue* value);
GType game_hub_data_game_source_get_type (void) G_GNUC_CONST;
GameHubDataGameSource* game_hub_data_game_get_source (GameHubDataGame* self);
const gchar* game_hub_data_game_source_get_icon (GameHubDataGameSource* self);
GType game_hub_utils_downloader_download_info_get_type (void) G_GNUC_CONST;
GameHubUtilsDownloaderDownloadInfo* game_hub_utils_downloader_download_info_new (const gchar* name,
                                                                                 const gchar* description,
                                                                                 const gchar* icon,
                                                                                 const gchar* icon_name,
                                                                                 const gchar* type_icon,
                                                                                 const gchar* type_icon_name);
GameHubUtilsDownloaderDownloadInfo* game_hub_utils_downloader_download_info_construct (GType object_type,
                                                                                       const gchar* name,
                                                                                       const gchar* description,
                                                                                       const gchar* icon,
                                                                                       const gchar* icon_name,
                                                                                       const gchar* type_icon,
                                                                                       const gchar* type_icon_name);
void game_hub_utils_downloader_download (GFile* remote,
                                         GFile* local,
                                         GameHubUtilsDownloaderDownloadInfo* info,
                                         gboolean preserve_filename,
                                         gboolean queue,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
GFile* game_hub_utils_downloader_download_finish (GAsyncResult* _res_,
                                                  GError** error);
GFile* game_hub_data_runnable_installer_part_get_local (GameHubDataRunnableInstallerPart* self);
static void game_hub_data_runnable_installer_install_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_);
const gchar* game_hub_data_runnable_installer_part_get_checksum (GameHubDataRunnableInstallerPart* self);
const gchar* game_hub_data_runnable_installer_part_get_checksum_type_string (GameHubDataRunnableInstallerPart* self);
void game_hub_utils_compute_file_checksum (GFile* file,
                                           GChecksumType type,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
gchar* game_hub_utils_compute_file_checksum_finish (GAsyncResult* _res_);
GChecksumType game_hub_data_runnable_installer_part_get_checksum_type (GameHubDataRunnableInstallerPart* self);
void game_hub_utils_notify (const gchar* title,
                            const gchar* body,
                            GNotificationPriority priority,
                            GameHubUtilsNotificationConfigureDelegate config,
                            gpointer config_target);
static GNotification* _______lambda23_ (Block8Data* _data8_,
                                 GNotification* n);
GFile* game_hub_utils_image_cache_local_file (const gchar* url,
                                              const gchar* prefix);
gchar* game_hub_data_game_get_full_id (GameHubDataGame* self);
#define GAME_HUB_APPLICATION_ACTION_PREFIX "app."
#define GAME_HUB_APPLICATION_ACTION_CORRUPTED_INSTALLER_PICK_ACTION "corrupted-installer.pick-action"
#define GAME_HUB_APPLICATION_ACTION_CORRUPTED_INSTALLER_SHOW "corrupted-installer.show"
#define GAME_HUB_APPLICATION_ACTION_CORRUPTED_INSTALLER_REMOVE "corrupted-installer.remove"
#define GAME_HUB_APPLICATION_ACTION_CORRUPTED_INSTALLER_BACKUP "corrupted-installer.backup"
static GNotification* ________lambda23__game_hub_utils_notification_configure_delegate (GNotification* notification,
                                                                                 gpointer self);
GFile* game_hub_utils_fs_utils_mkdir (const gchar* path,
                                      const gchar* file,
                                      GeeHashMap* variables);
void game_hub_data_runnable_installer_guess_type (GFile* file,
                                                  gboolean part,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
GameHubDataRunnableInstallerInstallerType game_hub_data_runnable_installer_guess_type_finish (GAsyncResult* _res_);
GType game_hub_data_compat_innoextract_get_type (void) G_GNUC_CONST;
void game_hub_utils_run_thread (gchar** cmd,
                                gint cmd_length1,
                                const gchar* dir,
                                gchar** env,
                                gint env_length1,
                                gboolean override_runtime,
                                gboolean capture_output,
                                gboolean log,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_);
gchar* game_hub_utils_run_thread_finish (GAsyncResult* _res_);
void game_hub_utils_run_async (gchar** cmd,
                               gint cmd_length1,
                               const gchar* dir,
                               gchar** env,
                               gint env_length1,
                               gboolean override_runtime,
                               gboolean wait,
                               gboolean log,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
void game_hub_utils_run_finish (GAsyncResult* _res_);
gboolean game_hub_data_compat_tool_can_install (GameHubDataCompatTool* self,
                                                GameHubDataRunnable* runnable);
void game_hub_data_compat_tool_install (GameHubDataCompatTool* self,
                                        GameHubDataRunnable* runnable,
                                        GFile* installer,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
void game_hub_data_compat_tool_install_finish (GameHubDataCompatTool* self,
                                               GAsyncResult* _res_);
void game_hub_utils_fs_utils_rm (const gchar* path,
                                 const gchar* file,
                                 const gchar* flags,
                                 GeeHashMap* variables);
#define GAME_HUB_UTILS_FS_UTILS_GAMEHUB_DIR "_gamehub"
GType game_hub_data_sources_gog_gog_game_dlc_get_type (void) G_GNUC_CONST;
void game_hub_utils_fs_utils_mv_up (GFile* path,
                                    const gchar* dirname);
GameHubDataPlatform game_hub_data_runnable_installer_get_platform (GameHubDataRunnableInstaller* self);
gboolean game_hub_data_runnable_runnable_action_get_is_primary (GameHubDataRunnableRunnableAction* self);
GFile* game_hub_data_runnable_runnable_action_get_file (GameHubDataRunnableRunnableAction* self);
const gchar* game_hub_data_runnable_runnable_action_get_args (GameHubDataRunnableRunnableAction* self);
static GNotification* _____lambda106_ (Block7Data* _data7_,
                                GNotification* n);
#define GAME_HUB_APPLICATION_ACTION_GAME_PROPERTIES "game.properties"
static GNotification* ______lambda106__game_hub_utils_notification_configure_delegate (GNotification* notification,
                                                                                gpointer self);
const gchar* game_hub_data_runnable_installer_get_version (GameHubDataRunnableInstaller* self);
void game_hub_data_game_save_version (GameHubDataGame* self,
                                      const gchar* ver);
static void game_hub_data_runnable_installer_guess_type_data_free (gpointer _data);
static void game_hub_data_runnable_installer_guess_type_async_ready_wrapper (GObject *source_object,
                                                                      GAsyncResult *res,
                                                                      void *user_data);
static gboolean game_hub_data_runnable_installer_guess_type_co (GameHubDataRunnableInstallerGuessTypeData* _data_);
static void game_hub_data_runnable_installer_guess_type_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_);
GameHubDataRunnableInstaller* game_hub_data_runnable_installer_construct (GType object_type);
const gchar* game_hub_data_runnable_installer_get_id (GameHubDataRunnableInstaller* self);
void game_hub_data_runnable_installer_set_id (GameHubDataRunnableInstaller* self,
                                              const gchar* value);
void game_hub_data_runnable_installer_set_platform (GameHubDataRunnableInstaller* self,
                                                    GameHubDataPlatform value);
void game_hub_data_runnable_installer_set_parts (GameHubDataRunnableInstaller* self,
                                                 GeeArrayList* value);
gint64 game_hub_data_runnable_installer_get_full_size (GameHubDataRunnableInstaller* self);
void game_hub_data_runnable_installer_set_full_size (GameHubDataRunnableInstaller* self,
                                                     gint64 value);
void game_hub_data_runnable_installer_set_version (GameHubDataRunnableInstaller* self,
                                                   const gchar* value);
gchar* game_hub_data_runnable_installer_get_name (GameHubDataRunnableInstaller* self);
GameHubDataRunnableInstallerPart* game_hub_data_runnable_installer_part_new (const gchar* id,
                                                                             const gchar* url,
                                                                             gint64 size,
                                                                             GFile* remote,
                                                                             GFile* local,
                                                                             const gchar* checksum,
                                                                             GChecksumType checksum_type);
GameHubDataRunnableInstallerPart* game_hub_data_runnable_installer_part_construct (GType object_type,
                                                                                   const gchar* id,
                                                                                   const gchar* url,
                                                                                   gint64 size,
                                                                                   GFile* remote,
                                                                                   GFile* local,
                                                                                   const gchar* checksum,
                                                                                   GChecksumType checksum_type);
void game_hub_data_runnable_installer_part_set_id (GameHubDataRunnableInstallerPart* self,
                                                   const gchar* value);
const gchar* game_hub_data_runnable_installer_part_get_url (GameHubDataRunnableInstallerPart* self);
void game_hub_data_runnable_installer_part_set_url (GameHubDataRunnableInstallerPart* self,
                                                    const gchar* value);
gint64 game_hub_data_runnable_installer_part_get_size (GameHubDataRunnableInstallerPart* self);
void game_hub_data_runnable_installer_part_set_size (GameHubDataRunnableInstallerPart* self,
                                                     gint64 value);
void game_hub_data_runnable_installer_part_set_remote (GameHubDataRunnableInstallerPart* self,
                                                       GFile* value);
void game_hub_data_runnable_installer_part_set_local (GameHubDataRunnableInstallerPart* self,
                                                      GFile* value);
void game_hub_data_runnable_installer_part_set_checksum (GameHubDataRunnableInstallerPart* self,
                                                         const gchar* value);
void game_hub_data_runnable_installer_part_set_checksum_type (GameHubDataRunnableInstallerPart* self,
                                                              GChecksumType value);
static void game_hub_data_runnable_installer_part_finalize (GObject * obj);
static void _vala_game_hub_data_runnable_installer_part_get_property (GObject * object,
                                                               guint property_id,
                                                               GValue * value,
                                                               GParamSpec * pspec);
static void _vala_game_hub_data_runnable_installer_part_set_property (GObject * object,
                                                               guint property_id,
                                                               const GValue * value,
                                                               GParamSpec * pspec);
static void game_hub_data_runnable_installer_finalize (GameHubDataRunnableInstaller * obj);
gboolean game_hub_data_runnable_runnable_action_is_available (GameHubDataRunnableRunnableAction* self,
                                                              GameHubDataCompatTool* tool);
const gchar* game_hub_data_runnable_runnable_action_get_uri (GameHubDataRunnableRunnableAction* self);
GType** game_hub_data_runnable_runnable_action_get_compat_tools (GameHubDataRunnableRunnableAction* self,
                                                                 gint* result_length1);
static GType* _g_type_dup (GType* self);
static void game_hub_data_runnable_runnable_action_invoke_data_free (gpointer _data);
static void game_hub_data_runnable_runnable_action_invoke_async_ready_wrapper (GObject *source_object,
                                                                        GAsyncResult *res,
                                                                        void *user_data);
void game_hub_data_runnable_runnable_action_invoke (GameHubDataRunnableRunnableAction* self,
                                                    GameHubDataCompatTool* tool,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_);
void game_hub_data_runnable_runnable_action_invoke_finish (GameHubDataRunnableRunnableAction* self,
                                                           GAsyncResult* _res_);
static gboolean game_hub_data_runnable_runnable_action_invoke_co (GameHubDataRunnableRunnableActionInvokeData* _data_);
void game_hub_utils_open_uri (const gchar* uri);
gboolean game_hub_data_compat_tool_can_run_action (GameHubDataCompatTool* self,
                                                   GameHubDataRunnable* runnable,
                                                   GameHubDataRunnableRunnableAction* action);
GameHubDataRunnable* game_hub_data_runnable_runnable_action_get_runnable (GameHubDataRunnableRunnableAction* self);
void game_hub_data_compat_tool_run_action (GameHubDataCompatTool* self,
                                           GameHubDataRunnable* runnable,
                                           GameHubDataRunnableRunnableAction* action,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
void game_hub_data_compat_tool_run_action_finish (GameHubDataCompatTool* self,
                                                  GAsyncResult* _res_);
static void game_hub_data_runnable_runnable_action_invoke_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_);
GameHubDataRunnableRunnableAction* game_hub_data_runnable_runnable_action_construct (GType object_type);
void game_hub_data_runnable_runnable_action_set_runnable (GameHubDataRunnableRunnableAction* self,
                                                          GameHubDataRunnable* value);
void game_hub_data_runnable_runnable_action_set_is_primary (GameHubDataRunnableRunnableAction* self,
                                                            gboolean value);
gboolean game_hub_data_runnable_runnable_action_get_is_hidden (GameHubDataRunnableRunnableAction* self);
void game_hub_data_runnable_runnable_action_set_is_hidden (GameHubDataRunnableRunnableAction* self,
                                                           gboolean value);
const gchar* game_hub_data_runnable_runnable_action_get_name (GameHubDataRunnableRunnableAction* self);
void game_hub_data_runnable_runnable_action_set_name (GameHubDataRunnableRunnableAction* self,
                                                      const gchar* value);
void game_hub_data_runnable_runnable_action_set_file (GameHubDataRunnableRunnableAction* self,
                                                      GFile* value);
GFile* game_hub_data_runnable_runnable_action_get_workdir (GameHubDataRunnableRunnableAction* self);
void game_hub_data_runnable_runnable_action_set_workdir (GameHubDataRunnableRunnableAction* self,
                                                         GFile* value);
void game_hub_data_runnable_runnable_action_set_args (GameHubDataRunnableRunnableAction* self,
                                                      const gchar* value);
void game_hub_data_runnable_runnable_action_set_compat_tools (GameHubDataRunnableRunnableAction* self,
                                                              GType** value,
                                                              gint value_length1);
static GType** _vala_array_dup4 (GType** self,
                          int length);
void game_hub_data_runnable_runnable_action_set_uri (GameHubDataRunnableRunnableAction* self,
                                                     const gchar* value);
static void game_hub_data_runnable_runnable_action_finalize (GameHubDataRunnableRunnableAction * obj);
static void game_hub_data_runnable_finalize (GObject * obj);
static void _vala_game_hub_data_runnable_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_game_hub_data_runnable_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
gchar* game_hub_data_platform_id (GameHubDataPlatform self);
gchar* game_hub_data_platform_name (GameHubDataPlatform self);
gchar* game_hub_data_platform_icon (GameHubDataPlatform self);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

const GameHubDataPlatform GAME_HUB_DATA_PLATFORM_PLATFORMS[4] = {GAME_HUB_DATA_PLATFORM_LINUX, GAME_HUB_DATA_PLATFORM_WINDOWS, GAME_HUB_DATA_PLATFORM_MACOS, GAME_HUB_DATA_PLATFORM_EMULATED};

static inline gpointer
game_hub_data_runnable_get_instance_private (GameHubDataRunnable* self)
{
	return G_STRUCT_MEMBER_P (self, GameHubDataRunnable_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 62 "../src/data/Runnable.vala"
	return self ? g_object_ref (self) : NULL;
#line 1643 "Runnable.c"
}

static gboolean
game_hub_data_runnable_real_is_supported (GameHubDataRunnable* self,
                                          GameHubDataPlatform* platform,
                                          gboolean with_compat)
{
	gboolean result = FALSE;
	GameHubDataPlatform* _tmp0_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	GeeArrayList* _tmp4_;
	GameHubDataCompatTool** _tmp9_;
	gint _tmp9__length1;
#line 59 "../src/data/Runnable.vala"
	_tmp0_ = platform;
#line 59 "../src/data/Runnable.vala"
	if (_tmp0_ == NULL) {
#line 1662 "Runnable.c"
		GameHubDataPlatform _tmp1_;
#line 59 "../src/data/Runnable.vala"
		_tmp1_ = GAME_HUB_DATA_PLATFORM_CURRENT;
#line 59 "../src/data/Runnable.vala"
		_tmp0_ = &_tmp1_;
#line 1668 "Runnable.c"
	}
#line 59 "../src/data/Runnable.vala"
	platform = _tmp0_;
#line 60 "../src/data/Runnable.vala"
	_tmp4_ = self->priv->_platforms;
#line 60 "../src/data/Runnable.vala"
	if (_tmp4_ == NULL) {
#line 60 "../src/data/Runnable.vala"
		_tmp3_ = TRUE;
#line 1678 "Runnable.c"
	} else {
		GeeArrayList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 60 "../src/data/Runnable.vala"
		_tmp5_ = self->priv->_platforms;
#line 60 "../src/data/Runnable.vala"
		_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 60 "../src/data/Runnable.vala"
		_tmp7_ = _tmp6_;
#line 60 "../src/data/Runnable.vala"
		_tmp3_ = _tmp7_ == 0;
#line 1691 "Runnable.c"
	}
#line 60 "../src/data/Runnable.vala"
	if (_tmp3_) {
#line 60 "../src/data/Runnable.vala"
		_tmp2_ = TRUE;
#line 1697 "Runnable.c"
	} else {
		GeeArrayList* _tmp8_;
#line 60 "../src/data/Runnable.vala"
		_tmp8_ = self->priv->_platforms;
#line 60 "../src/data/Runnable.vala"
		_tmp2_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp8_, (gpointer) ((gintptr) (*platform)));
#line 1704 "Runnable.c"
	}
#line 60 "../src/data/Runnable.vala"
	if (_tmp2_) {
#line 60 "../src/data/Runnable.vala"
		result = TRUE;
#line 60 "../src/data/Runnable.vala"
		return result;
#line 1712 "Runnable.c"
	}
#line 61 "../src/data/Runnable.vala"
	if (!with_compat) {
#line 61 "../src/data/Runnable.vala"
		result = FALSE;
#line 61 "../src/data/Runnable.vala"
		return result;
#line 1720 "Runnable.c"
	}
#line 62 "../src/data/Runnable.vala"
	_tmp9_ = game_hub_data_CompatTools;
#line 62 "../src/data/Runnable.vala"
	_tmp9__length1 = game_hub_data_CompatTools_length1;
#line 1726 "Runnable.c"
	{
		GameHubDataCompatTool** tool_collection = NULL;
		gint tool_collection_length1 = 0;
		gint _tool_collection_size_ = 0;
		gint tool_it = 0;
#line 62 "../src/data/Runnable.vala"
		tool_collection = _tmp9_;
#line 62 "../src/data/Runnable.vala"
		tool_collection_length1 = _tmp9__length1;
#line 62 "../src/data/Runnable.vala"
		for (tool_it = 0; tool_it < tool_collection_length1; tool_it = tool_it + 1) {
#line 1738 "Runnable.c"
			GameHubDataCompatTool* _tmp10_;
			GameHubDataCompatTool* tool = NULL;
#line 62 "../src/data/Runnable.vala"
			_tmp10_ = _g_object_ref0 (tool_collection[tool_it]);
#line 62 "../src/data/Runnable.vala"
			tool = _tmp10_;
#line 1745 "Runnable.c"
			{
				GameHubDataCompatTool* _tmp11_;
#line 64 "../src/data/Runnable.vala"
				_tmp11_ = tool;
#line 64 "../src/data/Runnable.vala"
				if (game_hub_data_compat_tool_can_run (_tmp11_, self)) {
#line 64 "../src/data/Runnable.vala"
					result = TRUE;
#line 64 "../src/data/Runnable.vala"
					_g_object_unref0 (tool);
#line 64 "../src/data/Runnable.vala"
					return result;
#line 1758 "Runnable.c"
				}
#line 62 "../src/data/Runnable.vala"
				_g_object_unref0 (tool);
#line 1762 "Runnable.c"
			}
		}
	}
#line 66 "../src/data/Runnable.vala"
	result = FALSE;
#line 66 "../src/data/Runnable.vala"
	return result;
#line 1770 "Runnable.c"
}

gboolean
game_hub_data_runnable_is_supported (GameHubDataRunnable* self,
                                     GameHubDataPlatform* platform,
                                     gboolean with_compat)
{
#line 57 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 57 "../src/data/Runnable.vala"
	return GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->is_supported (self, platform, with_compat);
#line 1782 "Runnable.c"
}

void
game_hub_data_runnable_install (GameHubDataRunnable* self,
                                GameHubDataRunnableInstallerInstallMode install_mode,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
#line 27 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->install (self, install_mode, _callback_, _user_data_);
#line 1793 "Runnable.c"
}

void
game_hub_data_runnable_install_finish (GameHubDataRunnable* self,
                                       GAsyncResult* _res_)
{
#line 27 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->install_finish (self, _res_);
#line 1802 "Runnable.c"
}

void
game_hub_data_runnable_run (GameHubDataRunnable* self,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
#line 27 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->run (self, _callback_, _user_data_);
#line 1812 "Runnable.c"
}

void
game_hub_data_runnable_run_finish (GameHubDataRunnable* self,
                                   GAsyncResult* _res_)
{
#line 27 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->run_finish (self, _res_);
#line 1821 "Runnable.c"
}

static void
game_hub_data_runnable_real_run_with_compat_data_free (gpointer _data)
{
	GameHubDataRunnableRunWithCompatData* _data_;
	_data_ = _data;
#line 27 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->self);
#line 27 "../src/data/Runnable.vala"
	g_slice_free (GameHubDataRunnableRunWithCompatData, _data_);
#line 1833 "Runnable.c"
}

static void
game_hub_data_runnable_real_run_with_compat_async_ready_wrapper (GObject *source_object,
                                                                 GAsyncResult *res,
                                                                 void *user_data)
{
	GameHubDataRunnableRunWithCompatData* _task_data_;
#line 27 "../src/data/Runnable.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 27 "../src/data/Runnable.vala"
	if (_task_data_->_callback_ != NULL) {
#line 27 "../src/data/Runnable.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 1848 "Runnable.c"
	}
#line 27 "../src/data/Runnable.vala"
	_task_data_->_task_complete_ = TRUE;
#line 1852 "Runnable.c"
}

static void
game_hub_data_runnable_real_run_with_compat (GameHubDataRunnable* self,
                                             gboolean is_opened_from_menu,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_)
{
	GameHubDataRunnableRunWithCompatData* _data_;
	GameHubDataRunnable* _tmp0_;
#line 27 "../src/data/Runnable.vala"
	_data_ = g_slice_new0 (GameHubDataRunnableRunWithCompatData);
#line 27 "../src/data/Runnable.vala"
	_data_->_callback_ = _callback_;
#line 27 "../src/data/Runnable.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, game_hub_data_runnable_real_run_with_compat_async_ready_wrapper, _user_data_);
#line 27 "../src/data/Runnable.vala"
	if (_callback_ == NULL) {
#line 27 "../src/data/Runnable.vala"
		_data_->_task_complete_ = TRUE;
#line 1873 "Runnable.c"
	}
#line 27 "../src/data/Runnable.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_runnable_real_run_with_compat_data_free);
#line 27 "../src/data/Runnable.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 27 "../src/data/Runnable.vala"
	_data_->self = _tmp0_;
#line 27 "../src/data/Runnable.vala"
	_data_->is_opened_from_menu = is_opened_from_menu;
#line 27 "../src/data/Runnable.vala"
	game_hub_data_runnable_real_run_with_compat_co (_data_);
#line 1885 "Runnable.c"
}

static void
game_hub_data_runnable_real_run_with_compat_finish (GameHubDataRunnable* self,
                                                    GAsyncResult* _res_)
{
	GameHubDataRunnableRunWithCompatData* _data_;
#line 27 "../src/data/Runnable.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1895 "Runnable.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 78 "../src/data/Runnable.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 78 "../src/data/Runnable.vala"
	return _data5_;
#line 1905 "Runnable.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 78 "../src/data/Runnable.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 1915 "Runnable.c"
		GameHubDataRunnable* self;
#line 78 "../src/data/Runnable.vala"
		self = _data5_->self;
#line 78 "../src/data/Runnable.vala"
		_g_object_unref0 (self);
#line 78 "../src/data/Runnable.vala"
		g_slice_free (Block5Data, _data5_);
#line 1923 "Runnable.c"
	}
}

static gboolean
_game_hub_data_runnable_real_run_with_compat_co_gsource_func (gpointer self)
{
	gboolean result;
	result = game_hub_data_runnable_real_run_with_compat_co (self);
#line 84 "../src/data/Runnable.vala"
	return result;
#line 1934 "Runnable.c"
}

static void
___lambda67_ (Block5Data* _data5_)
{
	GameHubDataRunnable* self;
#line 83 "../src/data/Runnable.vala"
	self = _data5_->self;
#line 84 "../src/data/Runnable.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _game_hub_data_runnable_real_run_with_compat_co_gsource_func, _data5_->_async_data_, NULL);
#line 1945 "Runnable.c"
}

static void
____lambda67__gtk_widget_destroy (GtkWidget* _sender,
                                  gpointer self)
{
#line 83 "../src/data/Runnable.vala"
	___lambda67_ (self);
#line 1954 "Runnable.c"
}

static gboolean
game_hub_data_runnable_real_run_with_compat_co (GameHubDataRunnableRunWithCompatData* _data_)
{
#line 78 "../src/data/Runnable.vala"
	switch (_data_->_state_) {
#line 78 "../src/data/Runnable.vala"
		case 0:
#line 1964 "Runnable.c"
		goto _state_0;
#line 78 "../src/data/Runnable.vala"
		case 1:
#line 1968 "Runnable.c"
		goto _state_1;
		default:
#line 78 "../src/data/Runnable.vala"
		g_assert_not_reached ();
#line 1973 "Runnable.c"
	}
	_state_0:
#line 78 "../src/data/Runnable.vala"
	_data_->_data5_ = g_slice_new0 (Block5Data);
#line 78 "../src/data/Runnable.vala"
	_data_->_data5_->_ref_count_ = 1;
#line 78 "../src/data/Runnable.vala"
	_data_->_data5_->self = g_object_ref (_data_->self);
#line 78 "../src/data/Runnable.vala"
	_data_->_data5_->_async_data_ = _data_;
#line 80 "../src/data/Runnable.vala"
	if (!game_hub_data_RunnableIsLaunched) {
#line 80 "../src/data/Runnable.vala"
		_data_->_tmp0_ = !game_hub_data_sources_steam_steam_IsAnyAppRunning;
#line 1988 "Runnable.c"
	} else {
#line 80 "../src/data/Runnable.vala"
		_data_->_tmp0_ = FALSE;
#line 1992 "Runnable.c"
	}
#line 80 "../src/data/Runnable.vala"
	if (_data_->_tmp0_) {
#line 82 "../src/data/Runnable.vala"
		_data_->_tmp1_ = game_hub_ui_dialogs_compat_run_dialog_new (_data_->self, _data_->is_opened_from_menu, NULL, FALSE);
#line 82 "../src/data/Runnable.vala"
		g_object_ref_sink (_data_->_tmp1_);
#line 82 "../src/data/Runnable.vala"
		_data_->dlg = _data_->_tmp1_;
#line 83 "../src/data/Runnable.vala"
		_data_->_tmp2_ = _data_->dlg;
#line 83 "../src/data/Runnable.vala"
		g_signal_connect_data ((GtkWidget*) _data_->_tmp2_, "destroy", (GCallback) ____lambda67__gtk_widget_destroy, block5_data_ref (_data_->_data5_), (GClosureNotify) block5_data_unref, 0);
#line 86 "../src/data/Runnable.vala"
		_data_->_state_ = 1;
#line 86 "../src/data/Runnable.vala"
		return FALSE;
#line 2010 "Runnable.c"
		_state_1:
		;
#line 80 "../src/data/Runnable.vala"
		_g_object_unref0 (_data_->dlg);
#line 2015 "Runnable.c"
	}
#line 78 "../src/data/Runnable.vala"
	block5_data_unref (_data_->_data5_);
#line 78 "../src/data/Runnable.vala"
	_data_->_data5_ = NULL;
#line 78 "../src/data/Runnable.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 78 "../src/data/Runnable.vala"
	if (_data_->_state_ != 0) {
#line 78 "../src/data/Runnable.vala"
		while (!_data_->_task_complete_) {
#line 78 "../src/data/Runnable.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2029 "Runnable.c"
		}
	}
#line 78 "../src/data/Runnable.vala"
	g_object_unref (_data_->_async_result);
#line 78 "../src/data/Runnable.vala"
	return FALSE;
#line 2036 "Runnable.c"
}

void
game_hub_data_runnable_run_with_compat (GameHubDataRunnable* self,
                                        gboolean is_opened_from_menu,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_)
{
#line 27 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->run_with_compat (self, is_opened_from_menu, _callback_, _user_data_);
#line 2047 "Runnable.c"
}

void
game_hub_data_runnable_run_with_compat_finish (GameHubDataRunnable* self,
                                               GAsyncResult* _res_)
{
#line 27 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->run_with_compat_finish (self, _res_);
#line 2056 "Runnable.c"
}

static GtkFileChooser*
game_hub_data_runnable_real_setup_executable_chooser (GameHubDataRunnable* self)
{
	GtkFileChooser* result = NULL;
	GtkFileChooserNative* chooser = NULL;
	GameHubUIWindowsMainWindow* _tmp0_;
	GtkFileChooserNative* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 93 "../src/data/Runnable.vala"
	_tmp0_ = game_hub_ui_windows_main_window_instance;
#line 93 "../src/data/Runnable.vala"
	_tmp1_ = gtk_file_chooser_native_new (_ ("Select executable"), (GtkWindow*) _tmp0_, GTK_FILE_CHOOSER_ACTION_OPEN, _ ("Select"), _ ("Cancel"));
#line 93 "../src/data/Runnable.vala"
	chooser = _tmp1_;
#line 2073 "Runnable.c"
	{
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
#line 100 "../src/data/Runnable.vala"
		_tmp2_ = game_hub_data_runnable_get_executable (self);
#line 100 "../src/data/Runnable.vala"
		_tmp3_ = _tmp2_;
#line 100 "../src/data/Runnable.vala"
		_tmp4_ = _tmp3_;
#line 100 "../src/data/Runnable.vala"
		gtk_file_chooser_set_file ((GtkFileChooser*) chooser, _tmp4_, &_inner_error0_);
#line 100 "../src/data/Runnable.vala"
		_g_object_unref0 (_tmp4_);
#line 100 "../src/data/Runnable.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2090 "Runnable.c"
			goto __catch3_g_error;
		}
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 98 "../src/data/Runnable.vala"
		e = _inner_error0_;
#line 98 "../src/data/Runnable.vala"
		_inner_error0_ = NULL;
#line 104 "../src/data/Runnable.vala"
		_tmp5_ = e;
#line 104 "../src/data/Runnable.vala"
		_tmp6_ = _tmp5_->message;
#line 104 "../src/data/Runnable.vala"
		g_warning ("Runnable.vala:104: %s", _tmp6_);
#line 98 "../src/data/Runnable.vala"
		_g_error_free0 (e);
#line 2112 "Runnable.c"
	}
	__finally3:
#line 98 "../src/data/Runnable.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 98 "../src/data/Runnable.vala"
		_g_object_unref0 (chooser);
#line 98 "../src/data/Runnable.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 98 "../src/data/Runnable.vala"
		g_clear_error (&_inner_error0_);
#line 98 "../src/data/Runnable.vala"
		return NULL;
#line 2125 "Runnable.c"
	}
#line 107 "../src/data/Runnable.vala"
	result = (GtkFileChooser*) chooser;
#line 107 "../src/data/Runnable.vala"
	return result;
#line 2131 "Runnable.c"
}

GtkFileChooser*
game_hub_data_runnable_setup_executable_chooser (GameHubDataRunnable* self)
{
#line 90 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 90 "../src/data/Runnable.vala"
	return GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->setup_executable_chooser (self);
#line 2141 "Runnable.c"
}

static gint
game_hub_data_runnable_run_executable_chooser (GameHubDataRunnable* self,
                                               GtkFileChooser* chooser)
{
	gint result = 0;
#line 110 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 110 "../src/data/Runnable.vala"
	g_return_val_if_fail (chooser != NULL, 0);
#line 113 "../src/data/Runnable.vala"
	result = gtk_native_dialog_run ((GtkNativeDialog*) (G_TYPE_CHECK_INSTANCE_TYPE (chooser, gtk_file_chooser_native_get_type ()) ? ((GtkFileChooserNative*) chooser) : NULL));
#line 113 "../src/data/Runnable.vala"
	return result;
#line 2157 "Runnable.c"
}

static void
game_hub_data_runnable_real_choose_executable (GameHubDataRunnable* self,
                                               gboolean update)
{
	GtkFileChooser* chooser = NULL;
	GtkFileChooser* _tmp0_;
	GtkFileChooser* _tmp1_;
#line 121 "../src/data/Runnable.vala"
	_tmp0_ = game_hub_data_runnable_setup_executable_chooser (self);
#line 121 "../src/data/Runnable.vala"
	chooser = _tmp0_;
#line 123 "../src/data/Runnable.vala"
	_tmp1_ = chooser;
#line 123 "../src/data/Runnable.vala"
	if (game_hub_data_runnable_run_executable_chooser (self, _tmp1_) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 2175 "Runnable.c"
		GtkFileChooser* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
#line 125 "../src/data/Runnable.vala"
		_tmp2_ = chooser;
#line 125 "../src/data/Runnable.vala"
		_tmp3_ = gtk_file_chooser_get_file (_tmp2_);
#line 125 "../src/data/Runnable.vala"
		_tmp4_ = _tmp3_;
#line 125 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_chosen_executable (self, _tmp4_, update);
#line 125 "../src/data/Runnable.vala"
		_g_object_unref0 (_tmp4_);
#line 2189 "Runnable.c"
	}
#line 119 "../src/data/Runnable.vala"
	_g_object_unref0 (chooser);
#line 2193 "Runnable.c"
}

void
game_hub_data_runnable_choose_executable (GameHubDataRunnable* self,
                                          gboolean update)
{
#line 119 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 119 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->choose_executable (self, update);
#line 2204 "Runnable.c"
}

static void
game_hub_data_runnable_real_set_chosen_executable (GameHubDataRunnable* self,
                                                   GFile* file,
                                                   gboolean update)
{
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	gboolean _tmp4_;
#line 131 "../src/data/Runnable.vala"
	game_hub_data_runnable_set_executable (self, file);
#line 132 "../src/data/Runnable.vala"
	_tmp1_ = game_hub_data_runnable_get_executable (self);
#line 132 "../src/data/Runnable.vala"
	_tmp2_ = _tmp1_;
#line 132 "../src/data/Runnable.vala"
	_tmp3_ = _tmp2_;
#line 132 "../src/data/Runnable.vala"
	_tmp4_ = _tmp3_ != NULL;
#line 132 "../src/data/Runnable.vala"
	_g_object_unref0 (_tmp3_);
#line 132 "../src/data/Runnable.vala"
	if (_tmp4_) {
#line 2231 "Runnable.c"
		GFile* _tmp5_;
		GFile* _tmp6_;
		GFile* _tmp7_;
#line 132 "../src/data/Runnable.vala"
		_tmp5_ = game_hub_data_runnable_get_executable (self);
#line 132 "../src/data/Runnable.vala"
		_tmp6_ = _tmp5_;
#line 132 "../src/data/Runnable.vala"
		_tmp7_ = _tmp6_;
#line 132 "../src/data/Runnable.vala"
		_tmp0_ = g_file_query_exists (_tmp7_, NULL);
#line 132 "../src/data/Runnable.vala"
		_g_object_unref0 (_tmp7_);
#line 2245 "Runnable.c"
	} else {
#line 132 "../src/data/Runnable.vala"
		_tmp0_ = FALSE;
#line 2249 "Runnable.c"
	}
#line 132 "../src/data/Runnable.vala"
	if (_tmp0_) {
#line 2253 "Runnable.c"
		gchar* _tmp8_;
		gchar* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
		GFile* _tmp12_;
		gchar* _tmp13_;
		gchar** _tmp14_;
		gchar** _tmp15_;
		gint _tmp15__length1;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 134 "../src/data/Runnable.vala"
		_tmp8_ = g_strdup ("chmod");
#line 134 "../src/data/Runnable.vala"
		_tmp9_ = g_strdup ("+x");
#line 134 "../src/data/Runnable.vala"
		_tmp10_ = game_hub_data_runnable_get_executable (self);
#line 134 "../src/data/Runnable.vala"
		_tmp11_ = _tmp10_;
#line 134 "../src/data/Runnable.vala"
		_tmp12_ = _tmp11_;
#line 134 "../src/data/Runnable.vala"
		_tmp13_ = g_file_get_path (_tmp12_);
#line 134 "../src/data/Runnable.vala"
		_tmp14_ = g_new0 (gchar*, 3 + 1);
#line 134 "../src/data/Runnable.vala"
		_tmp14_[0] = _tmp8_;
#line 134 "../src/data/Runnable.vala"
		_tmp14_[1] = _tmp9_;
#line 134 "../src/data/Runnable.vala"
		_tmp14_[2] = _tmp13_;
#line 134 "../src/data/Runnable.vala"
		_tmp15_ = _tmp14_;
#line 134 "../src/data/Runnable.vala"
		_tmp15__length1 = 3;
#line 134 "../src/data/Runnable.vala"
		_tmp16_ = game_hub_utils_run (_tmp15_, (gint) 3, NULL, NULL, (gint) 0, FALSE, FALSE, TRUE);
#line 134 "../src/data/Runnable.vala"
		_tmp17_ = _tmp16_;
#line 134 "../src/data/Runnable.vala"
		_g_free0 (_tmp17_);
#line 134 "../src/data/Runnable.vala"
		_tmp15_ = (_vala_array_free (_tmp15_, _tmp15__length1, (GDestroyNotify) g_free), NULL);
#line 134 "../src/data/Runnable.vala"
		_g_object_unref0 (_tmp12_);
#line 2299 "Runnable.c"
	}
#line 137 "../src/data/Runnable.vala"
	if (update) {
#line 139 "../src/data/Runnable.vala"
		game_hub_data_runnable_update_status (self);
#line 140 "../src/data/Runnable.vala"
		game_hub_data_runnable_save (self);
#line 2307 "Runnable.c"
	}
}

void
game_hub_data_runnable_set_chosen_executable (GameHubDataRunnable* self,
                                              GFile* file,
                                              gboolean update)
{
#line 129 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 129 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->set_chosen_executable (self, file, update);
#line 2320 "Runnable.c"
}

static void
game_hub_data_runnable_real_save (GameHubDataRunnable* self)
{
}

void
game_hub_data_runnable_save (GameHubDataRunnable* self)
{
#line 144 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 144 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->save (self);
#line 2335 "Runnable.c"
}

static void
game_hub_data_runnable_real_update_status (GameHubDataRunnable* self)
{
}

void
game_hub_data_runnable_update_status (GameHubDataRunnable* self)
{
#line 145 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 145 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->update_status (self);
#line 2350 "Runnable.c"
}

static void
game_hub_data_runnable_real_import (GameHubDataRunnable* self,
                                    gboolean update)
{
	GtkFileChooserDialog* chooser = NULL;
	GameHubUIWindowsMainWindow* _tmp0_;
	GtkFileChooserDialog* _tmp1_;
	gchar* games_dir = NULL;
	gchar* _tmp2_;
	GtkFileChooserDialog* _tmp7_;
	const gchar* _tmp8_;
	GtkFileChooserDialog* _tmp9_;
	GtkWidget* select_btn = NULL;
	GtkFileChooserDialog* _tmp10_;
	GtkWidget* _tmp11_;
	GtkWidget* _tmp12_;
	GtkWidget* _tmp13_;
	GtkStyleContext* _tmp14_;
	GtkWidget* _tmp15_;
	GtkFileChooserDialog* _tmp16_;
	GtkFileChooserDialog* _tmp43_;
#line 149 "../src/data/Runnable.vala"
	_tmp0_ = game_hub_ui_windows_main_window_instance;
#line 149 "../src/data/Runnable.vala"
	_tmp1_ = (GtkFileChooserDialog*) gtk_file_chooser_dialog_new (_ ("Select directory"), (GtkWindow*) _tmp0_, GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER, NULL);
#line 149 "../src/data/Runnable.vala"
	g_object_ref_sink (_tmp1_);
#line 149 "../src/data/Runnable.vala"
	chooser = _tmp1_;
#line 151 "../src/data/Runnable.vala"
	_tmp2_ = g_strdup ("");
#line 151 "../src/data/Runnable.vala"
	games_dir = _tmp2_;
#line 152 "../src/data/Runnable.vala"
	if (GAME_HUB_DATA_SOURCES_GOG_IS_GOG_GAME (self)) {
#line 2388 "Runnable.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 154 "../src/data/Runnable.vala"
		_tmp3_ = game_hub_utils_fs_utils_paths_gog_get_Games ();
#line 154 "../src/data/Runnable.vala"
		_tmp4_ = _tmp3_;
#line 154 "../src/data/Runnable.vala"
		_g_free0 (games_dir);
#line 154 "../src/data/Runnable.vala"
		games_dir = _tmp4_;
#line 2399 "Runnable.c"
	} else {
#line 156 "../src/data/Runnable.vala"
		if (GAME_HUB_DATA_SOURCES_HUMBLE_IS_HUMBLE_GAME (self)) {
#line 2403 "Runnable.c"
			gchar* _tmp5_;
			gchar* _tmp6_;
#line 158 "../src/data/Runnable.vala"
			_tmp5_ = game_hub_utils_fs_utils_paths_humble_get_Games ();
#line 158 "../src/data/Runnable.vala"
			_tmp6_ = _tmp5_;
#line 158 "../src/data/Runnable.vala"
			_g_free0 (games_dir);
#line 158 "../src/data/Runnable.vala"
			games_dir = _tmp6_;
#line 2414 "Runnable.c"
		}
	}
#line 161 "../src/data/Runnable.vala"
	_tmp7_ = chooser;
#line 161 "../src/data/Runnable.vala"
	_tmp8_ = games_dir;
#line 161 "../src/data/Runnable.vala"
	gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp7_, _tmp8_);
#line 163 "../src/data/Runnable.vala"
	_tmp9_ = chooser;
#line 163 "../src/data/Runnable.vala"
	gtk_dialog_add_button ((GtkDialog*) _tmp9_, _ ("Cancel"), (gint) GTK_RESPONSE_CANCEL);
#line 164 "../src/data/Runnable.vala"
	_tmp10_ = chooser;
#line 164 "../src/data/Runnable.vala"
	_tmp11_ = gtk_dialog_add_button ((GtkDialog*) _tmp10_, _ ("Select"), (gint) GTK_RESPONSE_ACCEPT);
#line 164 "../src/data/Runnable.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 164 "../src/data/Runnable.vala"
	select_btn = _tmp12_;
#line 166 "../src/data/Runnable.vala"
	_tmp13_ = select_btn;
#line 166 "../src/data/Runnable.vala"
	_tmp14_ = gtk_widget_get_style_context (_tmp13_);
#line 166 "../src/data/Runnable.vala"
	gtk_style_context_add_class (_tmp14_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
#line 167 "../src/data/Runnable.vala"
	_tmp15_ = select_btn;
#line 167 "../src/data/Runnable.vala"
	gtk_widget_grab_default (_tmp15_);
#line 169 "../src/data/Runnable.vala"
	_tmp16_ = chooser;
#line 169 "../src/data/Runnable.vala"
	if (gtk_dialog_run ((GtkDialog*) _tmp16_) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 2449 "Runnable.c"
		GtkFileChooserDialog* _tmp17_;
		GFile* _tmp18_;
		GFile* _tmp19_;
		GFile* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		GFile* _tmp23_;
		GFile* _tmp24_;
		GFile* _tmp25_;
		GFile* _tmp26_;
		GFile* _tmp27_;
		gboolean _tmp28_;
		GFile* _tmp29_;
		GFile* _tmp30_;
		GFile* _tmp31_;
		gboolean _tmp32_;
#line 171 "../src/data/Runnable.vala"
		_tmp17_ = chooser;
#line 171 "../src/data/Runnable.vala"
		_tmp18_ = gtk_file_chooser_get_file ((GtkFileChooser*) _tmp17_);
#line 171 "../src/data/Runnable.vala"
		_tmp19_ = _tmp18_;
#line 171 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_install_dir (self, _tmp19_);
#line 171 "../src/data/Runnable.vala"
		_g_object_unref0 (_tmp19_);
#line 172 "../src/data/Runnable.vala"
		_tmp20_ = self->priv->_install_dir;
#line 172 "../src/data/Runnable.vala"
		_tmp21_ = g_file_get_path (_tmp20_);
#line 172 "../src/data/Runnable.vala"
		_tmp22_ = _tmp21_;
#line 172 "../src/data/Runnable.vala"
		_tmp23_ = game_hub_utils_fs_utils_file (_tmp22_, "start.sh", NULL);
#line 172 "../src/data/Runnable.vala"
		_tmp24_ = _tmp23_;
#line 172 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_executable (self, _tmp24_);
#line 172 "../src/data/Runnable.vala"
		_g_object_unref0 (_tmp24_);
#line 172 "../src/data/Runnable.vala"
		_g_free0 (_tmp22_);
#line 174 "../src/data/Runnable.vala"
		_tmp25_ = game_hub_data_runnable_get_executable (self);
#line 174 "../src/data/Runnable.vala"
		_tmp26_ = _tmp25_;
#line 174 "../src/data/Runnable.vala"
		_tmp27_ = _tmp26_;
#line 174 "../src/data/Runnable.vala"
		_tmp28_ = !g_file_query_exists (_tmp27_, NULL);
#line 174 "../src/data/Runnable.vala"
		_g_object_unref0 (_tmp27_);
#line 174 "../src/data/Runnable.vala"
		if (_tmp28_) {
#line 176 "../src/data/Runnable.vala"
			game_hub_data_runnable_choose_executable (self, FALSE);
#line 2506 "Runnable.c"
		}
#line 179 "../src/data/Runnable.vala"
		_tmp29_ = game_hub_data_runnable_get_executable (self);
#line 179 "../src/data/Runnable.vala"
		_tmp30_ = _tmp29_;
#line 179 "../src/data/Runnable.vala"
		_tmp31_ = _tmp30_;
#line 179 "../src/data/Runnable.vala"
		_tmp32_ = g_file_query_exists (_tmp31_, NULL);
#line 179 "../src/data/Runnable.vala"
		_g_object_unref0 (_tmp31_);
#line 179 "../src/data/Runnable.vala"
		if (_tmp32_) {
#line 2520 "Runnable.c"
			gchar* _tmp33_;
			gchar* _tmp34_;
			GFile* _tmp35_;
			GFile* _tmp36_;
			GFile* _tmp37_;
			gchar* _tmp38_;
			gchar** _tmp39_;
			gchar** _tmp40_;
			gint _tmp40__length1;
			gchar* _tmp41_;
			gchar* _tmp42_;
#line 181 "../src/data/Runnable.vala"
			_tmp33_ = g_strdup ("chmod");
#line 181 "../src/data/Runnable.vala"
			_tmp34_ = g_strdup ("+x");
#line 181 "../src/data/Runnable.vala"
			_tmp35_ = game_hub_data_runnable_get_executable (self);
#line 181 "../src/data/Runnable.vala"
			_tmp36_ = _tmp35_;
#line 181 "../src/data/Runnable.vala"
			_tmp37_ = _tmp36_;
#line 181 "../src/data/Runnable.vala"
			_tmp38_ = g_file_get_path (_tmp37_);
#line 181 "../src/data/Runnable.vala"
			_tmp39_ = g_new0 (gchar*, 3 + 1);
#line 181 "../src/data/Runnable.vala"
			_tmp39_[0] = _tmp33_;
#line 181 "../src/data/Runnable.vala"
			_tmp39_[1] = _tmp34_;
#line 181 "../src/data/Runnable.vala"
			_tmp39_[2] = _tmp38_;
#line 181 "../src/data/Runnable.vala"
			_tmp40_ = _tmp39_;
#line 181 "../src/data/Runnable.vala"
			_tmp40__length1 = 3;
#line 181 "../src/data/Runnable.vala"
			_tmp41_ = game_hub_utils_run (_tmp40_, (gint) 3, NULL, NULL, (gint) 0, FALSE, FALSE, TRUE);
#line 181 "../src/data/Runnable.vala"
			_tmp42_ = _tmp41_;
#line 181 "../src/data/Runnable.vala"
			_g_free0 (_tmp42_);
#line 181 "../src/data/Runnable.vala"
			_tmp40_ = (_vala_array_free (_tmp40_, _tmp40__length1, (GDestroyNotify) g_free), NULL);
#line 181 "../src/data/Runnable.vala"
			_g_object_unref0 (_tmp37_);
#line 2566 "Runnable.c"
		}
#line 184 "../src/data/Runnable.vala"
		if (update) {
#line 186 "../src/data/Runnable.vala"
			game_hub_data_runnable_update_status (self);
#line 187 "../src/data/Runnable.vala"
			game_hub_data_runnable_save (self);
#line 2574 "Runnable.c"
		}
	}
#line 191 "../src/data/Runnable.vala"
	_tmp43_ = chooser;
#line 191 "../src/data/Runnable.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp43_);
#line 147 "../src/data/Runnable.vala"
	_g_object_unref0 (select_btn);
#line 147 "../src/data/Runnable.vala"
	_g_free0 (games_dir);
#line 147 "../src/data/Runnable.vala"
	_g_object_unref0 (chooser);
#line 2587 "Runnable.c"
}

void
game_hub_data_runnable_import (GameHubDataRunnable* self,
                               gboolean update)
{
#line 147 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 147 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->import (self, update);
#line 2598 "Runnable.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 248 "../src/data/Runnable.vala"
	g_boxed_free (json_node_get_type (), self);
#line 2606 "Runnable.c"
}

JsonObject*
game_hub_data_runnable_get_compat_settings (GameHubDataRunnable* self,
                                            GameHubDataCompatTool* tool)
{
	JsonObject* result = NULL;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	JsonObject* _tmp16_;
#line 240 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 240 "../src/data/Runnable.vala"
	g_return_val_if_fail (tool != NULL, NULL);
#line 242 "../src/data/Runnable.vala"
	_tmp1_ = self->priv->_compat_tool_settings;
#line 242 "../src/data/Runnable.vala"
	if (_tmp1_ != NULL) {
#line 2625 "Runnable.c"
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 242 "../src/data/Runnable.vala"
		_tmp2_ = self->priv->_compat_tool_settings;
#line 242 "../src/data/Runnable.vala"
		_tmp3_ = strlen (_tmp2_);
#line 242 "../src/data/Runnable.vala"
		_tmp4_ = _tmp3_;
#line 242 "../src/data/Runnable.vala"
		_tmp0_ = _tmp4_ > 0;
#line 2637 "Runnable.c"
	} else {
#line 242 "../src/data/Runnable.vala"
		_tmp0_ = FALSE;
#line 2641 "Runnable.c"
	}
#line 242 "../src/data/Runnable.vala"
	if (_tmp0_) {
#line 2645 "Runnable.c"
		JsonNode* root = NULL;
		const gchar* _tmp5_;
		JsonNode* _tmp6_;
		JsonObject* settings = NULL;
		JsonNode* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar** _tmp11_;
		gchar** _tmp12_;
		gint _tmp12__length1;
		JsonObject* _tmp13_;
		JsonObject* _tmp14_;
		JsonObject* _tmp15_;
#line 244 "../src/data/Runnable.vala"
		_tmp5_ = self->priv->_compat_tool_settings;
#line 244 "../src/data/Runnable.vala"
		_tmp6_ = game_hub_utils_parser_parse_json (_tmp5_);
#line 244 "../src/data/Runnable.vala"
		root = _tmp6_;
#line 245 "../src/data/Runnable.vala"
		_tmp7_ = root;
#line 245 "../src/data/Runnable.vala"
		_tmp8_ = game_hub_data_compat_tool_get_id (tool);
#line 245 "../src/data/Runnable.vala"
		_tmp9_ = _tmp8_;
#line 245 "../src/data/Runnable.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 245 "../src/data/Runnable.vala"
		_tmp11_ = g_new0 (gchar*, 1 + 1);
#line 245 "../src/data/Runnable.vala"
		_tmp11_[0] = _tmp10_;
#line 245 "../src/data/Runnable.vala"
		_tmp12_ = _tmp11_;
#line 245 "../src/data/Runnable.vala"
		_tmp12__length1 = 1;
#line 245 "../src/data/Runnable.vala"
		_tmp13_ = game_hub_utils_parser_json_object (_tmp7_, _tmp12_, (gint) 1);
#line 245 "../src/data/Runnable.vala"
		_tmp14_ = _tmp13_;
#line 245 "../src/data/Runnable.vala"
		_tmp12_ = (_vala_array_free (_tmp12_, _tmp12__length1, (GDestroyNotify) g_free), NULL);
#line 245 "../src/data/Runnable.vala"
		settings = _tmp14_;
#line 246 "../src/data/Runnable.vala"
		_tmp15_ = settings;
#line 246 "../src/data/Runnable.vala"
		if (_tmp15_ != NULL) {
#line 248 "../src/data/Runnable.vala"
			result = settings;
#line 248 "../src/data/Runnable.vala"
			__vala_JsonNode_free0 (root);
#line 248 "../src/data/Runnable.vala"
			return result;
#line 2700 "Runnable.c"
		}
#line 242 "../src/data/Runnable.vala"
		_json_object_unref0 (settings);
#line 242 "../src/data/Runnable.vala"
		__vala_JsonNode_free0 (root);
#line 2706 "Runnable.c"
	}
#line 251 "../src/data/Runnable.vala"
	_tmp16_ = json_object_new ();
#line 251 "../src/data/Runnable.vala"
	result = _tmp16_;
#line 251 "../src/data/Runnable.vala"
	return result;
#line 2714 "Runnable.c"
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 262 "../src/data/Runnable.vala"
	return self ? json_object_ref (self) : NULL;
#line 2722 "Runnable.c"
}

void
game_hub_data_runnable_set_compat_settings (GameHubDataRunnable* self,
                                            GameHubDataCompatTool* tool,
                                            JsonObject* settings)
{
	JsonObject* root_object = NULL;
	JsonObject* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	JsonNode* root_node = NULL;
	JsonNode* _tmp21_;
	JsonObject* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
#line 254 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 254 "../src/data/Runnable.vala"
	g_return_if_fail (tool != NULL);
#line 256 "../src/data/Runnable.vala"
	_tmp0_ = json_object_new ();
#line 256 "../src/data/Runnable.vala"
	root_object = _tmp0_;
#line 257 "../src/data/Runnable.vala"
	_tmp2_ = self->priv->_compat_tool_settings;
#line 257 "../src/data/Runnable.vala"
	if (_tmp2_ != NULL) {
#line 2751 "Runnable.c"
		const gchar* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 257 "../src/data/Runnable.vala"
		_tmp3_ = self->priv->_compat_tool_settings;
#line 257 "../src/data/Runnable.vala"
		_tmp4_ = strlen (_tmp3_);
#line 257 "../src/data/Runnable.vala"
		_tmp5_ = _tmp4_;
#line 257 "../src/data/Runnable.vala"
		_tmp1_ = _tmp5_ > 0;
#line 2763 "Runnable.c"
	} else {
#line 257 "../src/data/Runnable.vala"
		_tmp1_ = FALSE;
#line 2767 "Runnable.c"
	}
#line 257 "../src/data/Runnable.vala"
	if (_tmp1_) {
#line 2771 "Runnable.c"
		JsonNode* root = NULL;
		const gchar* _tmp6_;
		JsonNode* _tmp7_;
		gboolean _tmp8_ = FALSE;
		JsonNode* _tmp9_;
#line 259 "../src/data/Runnable.vala"
		_tmp6_ = self->priv->_compat_tool_settings;
#line 259 "../src/data/Runnable.vala"
		_tmp7_ = game_hub_utils_parser_parse_json (_tmp6_);
#line 259 "../src/data/Runnable.vala"
		root = _tmp7_;
#line 260 "../src/data/Runnable.vala"
		_tmp9_ = root;
#line 260 "../src/data/Runnable.vala"
		if (_tmp9_ != NULL) {
#line 2787 "Runnable.c"
			JsonNode* _tmp10_;
#line 260 "../src/data/Runnable.vala"
			_tmp10_ = root;
#line 260 "../src/data/Runnable.vala"
			_tmp8_ = json_node_get_node_type (_tmp10_) == JSON_NODE_OBJECT;
#line 2793 "Runnable.c"
		} else {
#line 260 "../src/data/Runnable.vala"
			_tmp8_ = FALSE;
#line 2797 "Runnable.c"
		}
#line 260 "../src/data/Runnable.vala"
		if (_tmp8_) {
#line 2801 "Runnable.c"
			JsonNode* _tmp11_;
			JsonObject* _tmp12_;
			JsonObject* _tmp13_;
#line 262 "../src/data/Runnable.vala"
			_tmp11_ = root;
#line 262 "../src/data/Runnable.vala"
			_tmp12_ = json_node_get_object (_tmp11_);
#line 262 "../src/data/Runnable.vala"
			_tmp13_ = _json_object_ref0 (_tmp12_);
#line 262 "../src/data/Runnable.vala"
			_json_object_unref0 (root_object);
#line 262 "../src/data/Runnable.vala"
			root_object = _tmp13_;
#line 2815 "Runnable.c"
		}
#line 257 "../src/data/Runnable.vala"
		__vala_JsonNode_free0 (root);
#line 2819 "Runnable.c"
	}
#line 266 "../src/data/Runnable.vala"
	if (settings == NULL) {
#line 2823 "Runnable.c"
		JsonObject* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
#line 268 "../src/data/Runnable.vala"
		_tmp14_ = root_object;
#line 268 "../src/data/Runnable.vala"
		_tmp15_ = game_hub_data_compat_tool_get_id (tool);
#line 268 "../src/data/Runnable.vala"
		_tmp16_ = _tmp15_;
#line 268 "../src/data/Runnable.vala"
		json_object_remove_member (_tmp14_, _tmp16_);
#line 2835 "Runnable.c"
	} else {
		JsonObject* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		JsonObject* _tmp20_;
#line 272 "../src/data/Runnable.vala"
		_tmp17_ = root_object;
#line 272 "../src/data/Runnable.vala"
		_tmp18_ = game_hub_data_compat_tool_get_id (tool);
#line 272 "../src/data/Runnable.vala"
		_tmp19_ = _tmp18_;
#line 272 "../src/data/Runnable.vala"
		_tmp20_ = _json_object_ref0 (settings);
#line 272 "../src/data/Runnable.vala"
		json_object_set_object_member (_tmp17_, _tmp19_, _tmp20_);
#line 2851 "Runnable.c"
	}
#line 275 "../src/data/Runnable.vala"
	_tmp21_ = json_node_new (JSON_NODE_OBJECT);
#line 275 "../src/data/Runnable.vala"
	root_node = _tmp21_;
#line 276 "../src/data/Runnable.vala"
	_tmp22_ = root_object;
#line 276 "../src/data/Runnable.vala"
	json_node_set_object (root_node, _tmp22_);
#line 277 "../src/data/Runnable.vala"
	_tmp23_ = json_to_string (root_node, FALSE);
#line 277 "../src/data/Runnable.vala"
	_tmp24_ = _tmp23_;
#line 277 "../src/data/Runnable.vala"
	game_hub_data_runnable_set_compat_tool_settings (self, _tmp24_);
#line 277 "../src/data/Runnable.vala"
	_g_free0 (_tmp24_);
#line 278 "../src/data/Runnable.vala"
	game_hub_data_runnable_set_compat_options_saved (self, TRUE);
#line 279 "../src/data/Runnable.vala"
	game_hub_data_runnable_save (self);
#line 254 "../src/data/Runnable.vala"
	__vala_JsonNode_free0 (root_node);
#line 254 "../src/data/Runnable.vala"
	_json_object_unref0 (root_object);
#line 2877 "Runnable.c"
}

static gboolean*
_bool_dup (gboolean* self)
{
	gboolean* dup;
#line 290 "../src/data/Runnable.vala"
	dup = g_new0 (gboolean, 1);
#line 290 "../src/data/Runnable.vala"
	memcpy (dup, self, sizeof (gboolean));
#line 290 "../src/data/Runnable.vala"
	return dup;
#line 2890 "Runnable.c"
}

static gpointer
__bool_dup0 (gpointer self)
{
#line 290 "../src/data/Runnable.vala"
	return self ? _bool_dup (self) : NULL;
#line 2898 "Runnable.c"
}

gboolean*
game_hub_data_runnable_get_compat_option_bool (GameHubDataRunnable* self,
                                               const gchar* key)
{
	gboolean* result = NULL;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
#line 282 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 282 "../src/data/Runnable.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 284 "../src/data/Runnable.vala"
	_tmp1_ = self->priv->_compat_tool_settings;
#line 284 "../src/data/Runnable.vala"
	if (_tmp1_ != NULL) {
#line 2916 "Runnable.c"
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 284 "../src/data/Runnable.vala"
		_tmp2_ = self->priv->_compat_tool_settings;
#line 284 "../src/data/Runnable.vala"
		_tmp3_ = strlen (_tmp2_);
#line 284 "../src/data/Runnable.vala"
		_tmp4_ = _tmp3_;
#line 284 "../src/data/Runnable.vala"
		_tmp0_ = _tmp4_ > 0;
#line 2928 "Runnable.c"
	} else {
#line 284 "../src/data/Runnable.vala"
		_tmp0_ = FALSE;
#line 2932 "Runnable.c"
	}
#line 284 "../src/data/Runnable.vala"
	if (_tmp0_) {
#line 2936 "Runnable.c"
		JsonNode* root = NULL;
		const gchar* _tmp5_;
		JsonNode* _tmp6_;
		gboolean _tmp7_ = FALSE;
		JsonNode* _tmp8_;
#line 286 "../src/data/Runnable.vala"
		_tmp5_ = self->priv->_compat_tool_settings;
#line 286 "../src/data/Runnable.vala"
		_tmp6_ = game_hub_utils_parser_parse_json (_tmp5_);
#line 286 "../src/data/Runnable.vala"
		root = _tmp6_;
#line 287 "../src/data/Runnable.vala"
		_tmp8_ = root;
#line 287 "../src/data/Runnable.vala"
		if (_tmp8_ != NULL) {
#line 2952 "Runnable.c"
			JsonNode* _tmp9_;
#line 287 "../src/data/Runnable.vala"
			_tmp9_ = root;
#line 287 "../src/data/Runnable.vala"
			_tmp7_ = json_node_get_node_type (_tmp9_) == JSON_NODE_OBJECT;
#line 2958 "Runnable.c"
		} else {
#line 287 "../src/data/Runnable.vala"
			_tmp7_ = FALSE;
#line 2962 "Runnable.c"
		}
#line 287 "../src/data/Runnable.vala"
		if (_tmp7_) {
#line 2966 "Runnable.c"
			JsonObject* obj = NULL;
			JsonNode* _tmp10_;
			JsonObject* _tmp11_;
			JsonObject* _tmp12_;
			JsonObject* _tmp13_;
#line 289 "../src/data/Runnable.vala"
			_tmp10_ = root;
#line 289 "../src/data/Runnable.vala"
			_tmp11_ = json_node_get_object (_tmp10_);
#line 289 "../src/data/Runnable.vala"
			_tmp12_ = _json_object_ref0 (_tmp11_);
#line 289 "../src/data/Runnable.vala"
			obj = _tmp12_;
#line 290 "../src/data/Runnable.vala"
			_tmp13_ = obj;
#line 290 "../src/data/Runnable.vala"
			if (json_object_has_member (_tmp13_, key)) {
#line 2984 "Runnable.c"
				JsonObject* _tmp14_;
				gboolean _tmp15_;
				gboolean* _tmp16_;
#line 290 "../src/data/Runnable.vala"
				_tmp14_ = obj;
#line 290 "../src/data/Runnable.vala"
				_tmp15_ = json_object_get_boolean_member (_tmp14_, key);
#line 290 "../src/data/Runnable.vala"
				_tmp16_ = __bool_dup0 (&_tmp15_);
#line 290 "../src/data/Runnable.vala"
				result = _tmp16_;
#line 290 "../src/data/Runnable.vala"
				_json_object_unref0 (obj);
#line 290 "../src/data/Runnable.vala"
				__vala_JsonNode_free0 (root);
#line 290 "../src/data/Runnable.vala"
				return result;
#line 3002 "Runnable.c"
			}
#line 287 "../src/data/Runnable.vala"
			_json_object_unref0 (obj);
#line 3006 "Runnable.c"
		}
#line 284 "../src/data/Runnable.vala"
		__vala_JsonNode_free0 (root);
#line 3010 "Runnable.c"
	}
#line 293 "../src/data/Runnable.vala"
	result = NULL;
#line 293 "../src/data/Runnable.vala"
	return result;
#line 3016 "Runnable.c"
}

void
game_hub_data_runnable_set_compat_option_bool (GameHubDataRunnable* self,
                                               const gchar* key,
                                               gboolean* value)
{
	JsonObject* root_object = NULL;
	JsonObject* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	JsonNode* root_node = NULL;
	JsonNode* _tmp16_;
	JsonObject* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
#line 296 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 296 "../src/data/Runnable.vala"
	g_return_if_fail (key != NULL);
#line 298 "../src/data/Runnable.vala"
	_tmp0_ = json_object_new ();
#line 298 "../src/data/Runnable.vala"
	root_object = _tmp0_;
#line 299 "../src/data/Runnable.vala"
	_tmp2_ = self->priv->_compat_tool_settings;
#line 299 "../src/data/Runnable.vala"
	if (_tmp2_ != NULL) {
#line 3045 "Runnable.c"
		const gchar* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 299 "../src/data/Runnable.vala"
		_tmp3_ = self->priv->_compat_tool_settings;
#line 299 "../src/data/Runnable.vala"
		_tmp4_ = strlen (_tmp3_);
#line 299 "../src/data/Runnable.vala"
		_tmp5_ = _tmp4_;
#line 299 "../src/data/Runnable.vala"
		_tmp1_ = _tmp5_ > 0;
#line 3057 "Runnable.c"
	} else {
#line 299 "../src/data/Runnable.vala"
		_tmp1_ = FALSE;
#line 3061 "Runnable.c"
	}
#line 299 "../src/data/Runnable.vala"
	if (_tmp1_) {
#line 3065 "Runnable.c"
		JsonNode* root = NULL;
		const gchar* _tmp6_;
		JsonNode* _tmp7_;
		gboolean _tmp8_ = FALSE;
		JsonNode* _tmp9_;
#line 301 "../src/data/Runnable.vala"
		_tmp6_ = self->priv->_compat_tool_settings;
#line 301 "../src/data/Runnable.vala"
		_tmp7_ = game_hub_utils_parser_parse_json (_tmp6_);
#line 301 "../src/data/Runnable.vala"
		root = _tmp7_;
#line 302 "../src/data/Runnable.vala"
		_tmp9_ = root;
#line 302 "../src/data/Runnable.vala"
		if (_tmp9_ != NULL) {
#line 3081 "Runnable.c"
			JsonNode* _tmp10_;
#line 302 "../src/data/Runnable.vala"
			_tmp10_ = root;
#line 302 "../src/data/Runnable.vala"
			_tmp8_ = json_node_get_node_type (_tmp10_) == JSON_NODE_OBJECT;
#line 3087 "Runnable.c"
		} else {
#line 302 "../src/data/Runnable.vala"
			_tmp8_ = FALSE;
#line 3091 "Runnable.c"
		}
#line 302 "../src/data/Runnable.vala"
		if (_tmp8_) {
#line 3095 "Runnable.c"
			JsonNode* _tmp11_;
			JsonObject* _tmp12_;
			JsonObject* _tmp13_;
#line 304 "../src/data/Runnable.vala"
			_tmp11_ = root;
#line 304 "../src/data/Runnable.vala"
			_tmp12_ = json_node_get_object (_tmp11_);
#line 304 "../src/data/Runnable.vala"
			_tmp13_ = _json_object_ref0 (_tmp12_);
#line 304 "../src/data/Runnable.vala"
			_json_object_unref0 (root_object);
#line 304 "../src/data/Runnable.vala"
			root_object = _tmp13_;
#line 3109 "Runnable.c"
		}
#line 299 "../src/data/Runnable.vala"
		__vala_JsonNode_free0 (root);
#line 3113 "Runnable.c"
	}
#line 307 "../src/data/Runnable.vala"
	if (value != NULL) {
#line 3117 "Runnable.c"
		JsonObject* _tmp14_;
#line 309 "../src/data/Runnable.vala"
		_tmp14_ = root_object;
#line 309 "../src/data/Runnable.vala"
		json_object_set_boolean_member (_tmp14_, key, *value);
#line 3123 "Runnable.c"
	} else {
		JsonObject* _tmp15_;
#line 313 "../src/data/Runnable.vala"
		_tmp15_ = root_object;
#line 313 "../src/data/Runnable.vala"
		json_object_remove_member (_tmp15_, key);
#line 3130 "Runnable.c"
	}
#line 315 "../src/data/Runnable.vala"
	_tmp16_ = json_node_new (JSON_NODE_OBJECT);
#line 315 "../src/data/Runnable.vala"
	root_node = _tmp16_;
#line 316 "../src/data/Runnable.vala"
	_tmp17_ = root_object;
#line 316 "../src/data/Runnable.vala"
	json_node_set_object (root_node, _tmp17_);
#line 317 "../src/data/Runnable.vala"
	_tmp18_ = json_to_string (root_node, FALSE);
#line 317 "../src/data/Runnable.vala"
	_tmp19_ = _tmp18_;
#line 317 "../src/data/Runnable.vala"
	game_hub_data_runnable_set_compat_tool_settings (self, _tmp19_);
#line 317 "../src/data/Runnable.vala"
	_g_free0 (_tmp19_);
#line 318 "../src/data/Runnable.vala"
	game_hub_data_runnable_save (self);
#line 296 "../src/data/Runnable.vala"
	__vala_JsonNode_free0 (root_node);
#line 296 "../src/data/Runnable.vala"
	_json_object_unref0 (root_object);
#line 3154 "Runnable.c"
}

GameHubDataRunnable*
game_hub_data_runnable_construct (GType object_type)
{
	GameHubDataRunnable * self = NULL;
#line 27 "../src/data/Runnable.vala"
	self = (GameHubDataRunnable*) g_object_new (object_type, NULL);
#line 27 "../src/data/Runnable.vala"
	return self;
#line 3165 "Runnable.c"
}

const gchar*
game_hub_data_runnable_get_id (GameHubDataRunnable* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 29 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_id;
#line 29 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 29 "../src/data/Runnable.vala"
	return result;
#line 3181 "Runnable.c"
}

void
game_hub_data_runnable_set_id (GameHubDataRunnable* self,
                               const gchar* value)
{
#line 29 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/data/Runnable.vala"
	if (g_strcmp0 (value, game_hub_data_runnable_get_id (self)) != 0) {
#line 3192 "Runnable.c"
		gchar* _tmp0_;
#line 29 "../src/data/Runnable.vala"
		_tmp0_ = g_strdup (value);
#line 29 "../src/data/Runnable.vala"
		_g_free0 (self->priv->_id);
#line 29 "../src/data/Runnable.vala"
		self->priv->_id = _tmp0_;
#line 29 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_ID_PROPERTY]);
#line 3202 "Runnable.c"
	}
}

const gchar*
game_hub_data_runnable_get_escaped_name (GameHubDataRunnable* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_escaped_name;
#line 32 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 32 "../src/data/Runnable.vala"
	return result;
#line 3219 "Runnable.c"
}

void
game_hub_data_runnable_set_escaped_name (GameHubDataRunnable* self,
                                         const gchar* value)
{
#line 32 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/data/Runnable.vala"
	if (g_strcmp0 (value, game_hub_data_runnable_get_escaped_name (self)) != 0) {
#line 3230 "Runnable.c"
		gchar* _tmp0_;
#line 32 "../src/data/Runnable.vala"
		_tmp0_ = g_strdup (value);
#line 32 "../src/data/Runnable.vala"
		_g_free0 (self->priv->_escaped_name);
#line 32 "../src/data/Runnable.vala"
		self->priv->_escaped_name = _tmp0_;
#line 32 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_ESCAPED_NAME_PROPERTY]);
#line 3240 "Runnable.c"
	}
}

const gchar*
game_hub_data_runnable_get_normalized_name (GameHubDataRunnable* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 33 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 33 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_normalized_name;
#line 33 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 33 "../src/data/Runnable.vala"
	return result;
#line 3257 "Runnable.c"
}

void
game_hub_data_runnable_set_normalized_name (GameHubDataRunnable* self,
                                            const gchar* value)
{
#line 33 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/data/Runnable.vala"
	if (g_strcmp0 (value, game_hub_data_runnable_get_normalized_name (self)) != 0) {
#line 3268 "Runnable.c"
		gchar* _tmp0_;
#line 33 "../src/data/Runnable.vala"
		_tmp0_ = g_strdup (value);
#line 33 "../src/data/Runnable.vala"
		_g_free0 (self->priv->_normalized_name);
#line 33 "../src/data/Runnable.vala"
		self->priv->_normalized_name = _tmp0_;
#line 33 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_NORMALIZED_NAME_PROPERTY]);
#line 3278 "Runnable.c"
	}
}

const gchar*
game_hub_data_runnable_get_name (GameHubDataRunnable* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 37 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_name;
#line 39 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 39 "../src/data/Runnable.vala"
	return result;
#line 3295 "Runnable.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1481 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1481 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 3317 "Runnable.c"
	} else {
#line 1481 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 3321 "Runnable.c"
	}
#line 1481 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1481 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 3327 "Runnable.c"
	} else {
#line 1481 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 3331 "Runnable.c"
	}
#line 1481 "glib-2.0.vapi"
	if (_tmp0_) {
#line 3335 "Runnable.c"
		gchar* _tmp2_;
#line 1482 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1482 "glib-2.0.vapi"
		result = _tmp2_;
#line 1482 "glib-2.0.vapi"
		return result;
#line 3343 "Runnable.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1485 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1485 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1485 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1485 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1485 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1485 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1485 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1485 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 3371 "Runnable.c"
				goto __catch4_g_regex_error;
			}
#line 1485 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1485 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1485 "glib-2.0.vapi"
			return NULL;
#line 3380 "Runnable.c"
		}
#line 1486 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1486 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1486 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1486 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1486 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1486 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 3394 "Runnable.c"
				goto __catch4_g_regex_error;
			}
#line 1486 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1486 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1486 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1486 "glib-2.0.vapi"
			return NULL;
#line 3405 "Runnable.c"
		}
#line 1486 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1486 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1486 "glib-2.0.vapi"
		result = _tmp10_;
#line 1486 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1486 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1486 "glib-2.0.vapi"
		return result;
#line 3419 "Runnable.c"
	}
	goto __finally4;
	__catch4_g_regex_error:
	{
		GError* e = NULL;
#line 1484 "glib-2.0.vapi"
		e = _inner_error0_;
#line 1484 "glib-2.0.vapi"
		_inner_error0_ = NULL;
#line 1488 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1484 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 3433 "Runnable.c"
	}
	__finally4:
#line 1484 "glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1484 "glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1484 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1484 "glib-2.0.vapi"
		return NULL;
#line 3444 "Runnable.c"
	}
}

void
game_hub_data_runnable_set_name (GameHubDataRunnable* self,
                                 const gchar* value)
{
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 41 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/data/Runnable.vala"
	_tmp0_ = g_strdup (value);
#line 43 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_name);
#line 43 "../src/data/Runnable.vala"
	self->priv->_name = _tmp0_;
#line 44 "../src/data/Runnable.vala"
	_tmp1_ = self->priv->_name;
#line 44 "../src/data/Runnable.vala"
	_tmp2_ = string_replace (_tmp1_, " ", "_");
#line 44 "../src/data/Runnable.vala"
	_tmp3_ = _tmp2_;
#line 44 "../src/data/Runnable.vala"
	_tmp4_ = game_hub_utils_strip_name (_tmp3_, "_.,", FALSE);
#line 44 "../src/data/Runnable.vala"
	_tmp5_ = _tmp4_;
#line 44 "../src/data/Runnable.vala"
	game_hub_data_runnable_set_escaped_name (self, _tmp5_);
#line 44 "../src/data/Runnable.vala"
	_g_free0 (_tmp5_);
#line 44 "../src/data/Runnable.vala"
	_g_free0 (_tmp3_);
#line 45 "../src/data/Runnable.vala"
	_tmp6_ = self->priv->_name;
#line 45 "../src/data/Runnable.vala"
	_tmp7_ = game_hub_utils_strip_name (_tmp6_, NULL, TRUE);
#line 45 "../src/data/Runnable.vala"
	_tmp8_ = _tmp7_;
#line 45 "../src/data/Runnable.vala"
	game_hub_data_runnable_set_normalized_name (self, _tmp8_);
#line 45 "../src/data/Runnable.vala"
	_g_free0 (_tmp8_);
#line 41 "../src/data/Runnable.vala"
	g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_NAME_PROPERTY]);
#line 3497 "Runnable.c"
}

const gchar*
game_hub_data_runnable_get_compat_tool (GameHubDataRunnable* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 49 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_compat_tool;
#line 49 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 49 "../src/data/Runnable.vala"
	return result;
#line 3513 "Runnable.c"
}

void
game_hub_data_runnable_set_compat_tool (GameHubDataRunnable* self,
                                        const gchar* value)
{
#line 49 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/data/Runnable.vala"
	if (g_strcmp0 (value, game_hub_data_runnable_get_compat_tool (self)) != 0) {
#line 3524 "Runnable.c"
		gchar* _tmp0_;
#line 49 "../src/data/Runnable.vala"
		_tmp0_ = g_strdup (value);
#line 49 "../src/data/Runnable.vala"
		_g_free0 (self->priv->_compat_tool);
#line 49 "../src/data/Runnable.vala"
		self->priv->_compat_tool = _tmp0_;
#line 49 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_COMPAT_TOOL_PROPERTY]);
#line 3534 "Runnable.c"
	}
}

const gchar*
game_hub_data_runnable_get_compat_tool_settings (GameHubDataRunnable* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 50 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_compat_tool_settings;
#line 50 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 50 "../src/data/Runnable.vala"
	return result;
#line 3551 "Runnable.c"
}

void
game_hub_data_runnable_set_compat_tool_settings (GameHubDataRunnable* self,
                                                 const gchar* value)
{
#line 50 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/data/Runnable.vala"
	if (g_strcmp0 (value, game_hub_data_runnable_get_compat_tool_settings (self)) != 0) {
#line 3562 "Runnable.c"
		gchar* _tmp0_;
#line 50 "../src/data/Runnable.vala"
		_tmp0_ = g_strdup (value);
#line 50 "../src/data/Runnable.vala"
		_g_free0 (self->priv->_compat_tool_settings);
#line 50 "../src/data/Runnable.vala"
		self->priv->_compat_tool_settings = _tmp0_;
#line 50 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_COMPAT_TOOL_SETTINGS_PROPERTY]);
#line 3572 "Runnable.c"
	}
}

const gchar*
game_hub_data_runnable_get_arguments (GameHubDataRunnable* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 52 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 52 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_arguments;
#line 52 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 52 "../src/data/Runnable.vala"
	return result;
#line 3589 "Runnable.c"
}

void
game_hub_data_runnable_set_arguments (GameHubDataRunnable* self,
                                      const gchar* value)
{
#line 52 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/data/Runnable.vala"
	if (g_strcmp0 (value, game_hub_data_runnable_get_arguments (self)) != 0) {
#line 3600 "Runnable.c"
		gchar* _tmp0_;
#line 52 "../src/data/Runnable.vala"
		_tmp0_ = g_strdup (value);
#line 52 "../src/data/Runnable.vala"
		_g_free0 (self->priv->_arguments);
#line 52 "../src/data/Runnable.vala"
		self->priv->_arguments = _tmp0_;
#line 52 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_ARGUMENTS_PROPERTY]);
#line 3610 "Runnable.c"
	}
}

gboolean
game_hub_data_runnable_get_is_running (GameHubDataRunnable* self)
{
	gboolean result;
#line 54 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 54 "../src/data/Runnable.vala"
	result = self->priv->_is_running;
#line 54 "../src/data/Runnable.vala"
	return result;
#line 3624 "Runnable.c"
}

void
game_hub_data_runnable_set_is_running (GameHubDataRunnable* self,
                                       gboolean value)
{
#line 54 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/data/Runnable.vala"
	if (game_hub_data_runnable_get_is_running (self) != value) {
#line 54 "../src/data/Runnable.vala"
		self->priv->_is_running = value;
#line 54 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_IS_RUNNING_PROPERTY]);
#line 3639 "Runnable.c"
	}
}

GeeArrayList*
game_hub_data_runnable_get_platforms (GameHubDataRunnable* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 56 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_platforms;
#line 56 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 56 "../src/data/Runnable.vala"
	return result;
#line 3656 "Runnable.c"
}

void
game_hub_data_runnable_set_platforms (GameHubDataRunnable* self,
                                      GeeArrayList* value)
{
#line 56 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/data/Runnable.vala"
	if (game_hub_data_runnable_get_platforms (self) != value) {
#line 3667 "Runnable.c"
		GeeArrayList* _tmp0_;
#line 56 "../src/data/Runnable.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 56 "../src/data/Runnable.vala"
		_g_object_unref0 (self->priv->_platforms);
#line 56 "../src/data/Runnable.vala"
		self->priv->_platforms = _tmp0_;
#line 56 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_PLATFORMS_PROPERTY]);
#line 3677 "Runnable.c"
	}
}

GFile*
game_hub_data_runnable_get_executable (GameHubDataRunnable* self)
{
#line 69 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 69 "../src/data/Runnable.vala"
	return GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->get_executable (self);
#line 3688 "Runnable.c"
}

void
game_hub_data_runnable_set_executable (GameHubDataRunnable* self,
                                       GFile* value)
{
#line 69 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 69 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->set_executable (self, value);
#line 3699 "Runnable.c"
}

GFile*
game_hub_data_runnable_get_install_dir (GameHubDataRunnable* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 70 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 70 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_install_dir;
#line 70 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 70 "../src/data/Runnable.vala"
	return result;
#line 3715 "Runnable.c"
}

void
game_hub_data_runnable_set_install_dir (GameHubDataRunnable* self,
                                        GFile* value)
{
#line 70 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 70 "../src/data/Runnable.vala"
	if (game_hub_data_runnable_get_install_dir (self) != value) {
#line 3726 "Runnable.c"
		GFile* _tmp0_;
#line 70 "../src/data/Runnable.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 70 "../src/data/Runnable.vala"
		_g_object_unref0 (self->priv->_install_dir);
#line 70 "../src/data/Runnable.vala"
		self->priv->_install_dir = _tmp0_;
#line 70 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_INSTALL_DIR_PROPERTY]);
#line 3736 "Runnable.c"
	}
}

GFile*
game_hub_data_runnable_get_default_install_dir (GameHubDataRunnable* self)
{
#line 71 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "../src/data/Runnable.vala"
	return GAME_HUB_DATA_RUNNABLE_GET_CLASS (self)->get_default_install_dir (self);
#line 3747 "Runnable.c"
}

static GFile*
game_hub_data_runnable_real_get_default_install_dir (GameHubDataRunnable* base)
{
	GFile* result;
	GameHubDataRunnable* self;
#line 71 "../src/data/Runnable.vala"
	self = base;
#line 71 "../src/data/Runnable.vala"
	result = NULL;
#line 71 "../src/data/Runnable.vala"
	return result;
#line 3761 "Runnable.c"
}

GeeArrayList*
game_hub_data_runnable_get_actions (GameHubDataRunnable* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 73 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 73 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_actions;
#line 73 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 73 "../src/data/Runnable.vala"
	return result;
#line 3777 "Runnable.c"
}

void
game_hub_data_runnable_set_actions (GameHubDataRunnable* self,
                                    GeeArrayList* value)
{
#line 73 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 73 "../src/data/Runnable.vala"
	if (game_hub_data_runnable_get_actions (self) != value) {
#line 3788 "Runnable.c"
		GeeArrayList* _tmp0_;
#line 73 "../src/data/Runnable.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 73 "../src/data/Runnable.vala"
		_g_object_unref0 (self->priv->_actions);
#line 73 "../src/data/Runnable.vala"
		self->priv->_actions = _tmp0_;
#line 73 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_ACTIONS_PROPERTY]);
#line 3798 "Runnable.c"
	}
}

gboolean
game_hub_data_runnable_get_use_compat (GameHubDataRunnable* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 196 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 198 "../src/data/Runnable.vala"
	_tmp1_ = game_hub_data_runnable_get_needs_compat (self);
#line 198 "../src/data/Runnable.vala"
	_tmp2_ = _tmp1_;
#line 198 "../src/data/Runnable.vala"
	if (_tmp2_) {
#line 198 "../src/data/Runnable.vala"
		_tmp0_ = TRUE;
#line 3819 "Runnable.c"
	} else {
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 198 "../src/data/Runnable.vala"
		_tmp3_ = game_hub_data_runnable_get_force_compat (self);
#line 198 "../src/data/Runnable.vala"
		_tmp4_ = _tmp3_;
#line 198 "../src/data/Runnable.vala"
		_tmp0_ = _tmp4_;
#line 3829 "Runnable.c"
	}
#line 198 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 198 "../src/data/Runnable.vala"
	return result;
#line 3835 "Runnable.c"
}

gboolean
game_hub_data_runnable_get_needs_compat (GameHubDataRunnable* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 204 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 206 "../src/data/Runnable.vala"
	if (!game_hub_data_runnable_is_supported (self, NULL, FALSE)) {
#line 206 "../src/data/Runnable.vala"
		_tmp1_ = game_hub_data_runnable_is_supported (self, NULL, TRUE);
#line 3850 "Runnable.c"
	} else {
#line 206 "../src/data/Runnable.vala"
		_tmp1_ = FALSE;
#line 3854 "Runnable.c"
	}
#line 206 "../src/data/Runnable.vala"
	if (_tmp1_) {
#line 206 "../src/data/Runnable.vala"
		_tmp0_ = TRUE;
#line 3860 "Runnable.c"
	} else {
		gboolean _tmp2_ = FALSE;
		GFile* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		gboolean _tmp6_;
#line 206 "../src/data/Runnable.vala"
		_tmp3_ = game_hub_data_runnable_get_executable (self);
#line 206 "../src/data/Runnable.vala"
		_tmp4_ = _tmp3_;
#line 206 "../src/data/Runnable.vala"
		_tmp5_ = _tmp4_;
#line 206 "../src/data/Runnable.vala"
		_tmp6_ = _tmp5_ != NULL;
#line 206 "../src/data/Runnable.vala"
		_g_object_unref0 (_tmp5_);
#line 206 "../src/data/Runnable.vala"
		if (_tmp6_) {
#line 3879 "Runnable.c"
			GFile* _tmp7_;
			GFile* _tmp8_;
			GFile* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
#line 206 "../src/data/Runnable.vala"
			_tmp7_ = game_hub_data_runnable_get_executable (self);
#line 206 "../src/data/Runnable.vala"
			_tmp8_ = _tmp7_;
#line 206 "../src/data/Runnable.vala"
			_tmp9_ = _tmp8_;
#line 206 "../src/data/Runnable.vala"
			_tmp10_ = g_file_get_basename (_tmp9_);
#line 206 "../src/data/Runnable.vala"
			_tmp11_ = _tmp10_;
#line 206 "../src/data/Runnable.vala"
			_tmp2_ = g_str_has_suffix (_tmp11_, ".exe");
#line 206 "../src/data/Runnable.vala"
			_g_free0 (_tmp11_);
#line 206 "../src/data/Runnable.vala"
			_g_object_unref0 (_tmp9_);
#line 3901 "Runnable.c"
		} else {
#line 206 "../src/data/Runnable.vala"
			_tmp2_ = FALSE;
#line 3905 "Runnable.c"
		}
#line 206 "../src/data/Runnable.vala"
		_tmp0_ = _tmp2_;
#line 3909 "Runnable.c"
	}
#line 206 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 206 "../src/data/Runnable.vala"
	return result;
#line 3915 "Runnable.c"
}

static gboolean
_bool_equal (const gboolean * s1,
             const gboolean * s2)
{
#line 215 "../src/data/Runnable.vala"
	if (s1 == s2) {
#line 215 "../src/data/Runnable.vala"
		return TRUE;
#line 3926 "Runnable.c"
	}
#line 215 "../src/data/Runnable.vala"
	if (s1 == NULL) {
#line 215 "../src/data/Runnable.vala"
		return FALSE;
#line 3932 "Runnable.c"
	}
#line 215 "../src/data/Runnable.vala"
	if (s2 == NULL) {
#line 215 "../src/data/Runnable.vala"
		return FALSE;
#line 3938 "Runnable.c"
	}
#line 215 "../src/data/Runnable.vala"
	return (*s1) == (*s2);
#line 3942 "Runnable.c"
}

gboolean
game_hub_data_runnable_get_force_compat (GameHubDataRunnable* self)
{
	gboolean result;
	gboolean* _tmp0_;
	gboolean* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 212 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 214 "../src/data/Runnable.vala"
	if (GAME_HUB_DATA_SOURCES_STEAM_IS_STEAM_GAME (self)) {
#line 214 "../src/data/Runnable.vala"
		result = FALSE;
#line 214 "../src/data/Runnable.vala"
		return result;
#line 3961 "Runnable.c"
	}
#line 215 "../src/data/Runnable.vala"
	_tmp0_ = game_hub_data_runnable_get_compat_option_bool (self, "force_compat");
#line 215 "../src/data/Runnable.vala"
	_tmp1_ = _tmp0_;
#line 215 "../src/data/Runnable.vala"
	_tmp2_ = TRUE;
#line 215 "../src/data/Runnable.vala"
	_tmp3_ = _bool_equal (_tmp1_, &_tmp2_) == TRUE;
#line 215 "../src/data/Runnable.vala"
	_g_free0 (_tmp1_);
#line 215 "../src/data/Runnable.vala"
	if (_tmp3_) {
#line 215 "../src/data/Runnable.vala"
		result = TRUE;
#line 215 "../src/data/Runnable.vala"
		return result;
#line 3979 "Runnable.c"
	}
#line 216 "../src/data/Runnable.vala"
	result = FALSE;
#line 216 "../src/data/Runnable.vala"
	return result;
#line 3985 "Runnable.c"
}

void
game_hub_data_runnable_set_force_compat (GameHubDataRunnable* self,
                                         gboolean value)
{
#line 218 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 220 "../src/data/Runnable.vala"
	if (GAME_HUB_DATA_SOURCES_STEAM_IS_STEAM_GAME (self)) {
#line 220 "../src/data/Runnable.vala"
		return;
#line 3998 "Runnable.c"
	}
#line 221 "../src/data/Runnable.vala"
	game_hub_data_runnable_set_compat_option_bool (self, "force_compat", &value);
#line 222 "../src/data/Runnable.vala"
	g_object_notify ((GObject*) self, "use-compat");
#line 218 "../src/data/Runnable.vala"
	g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_FORCE_COMPAT_PROPERTY]);
#line 4006 "Runnable.c"
}

gboolean
game_hub_data_runnable_get_compat_options_saved (GameHubDataRunnable* self)
{
	gboolean result;
	gboolean* _tmp0_;
	gboolean* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 228 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 230 "../src/data/Runnable.vala"
	if (GAME_HUB_DATA_SOURCES_STEAM_IS_STEAM_GAME (self)) {
#line 230 "../src/data/Runnable.vala"
		result = FALSE;
#line 230 "../src/data/Runnable.vala"
		return result;
#line 4025 "Runnable.c"
	}
#line 231 "../src/data/Runnable.vala"
	_tmp0_ = game_hub_data_runnable_get_compat_option_bool (self, "compat_options_saved");
#line 231 "../src/data/Runnable.vala"
	_tmp1_ = _tmp0_;
#line 231 "../src/data/Runnable.vala"
	_tmp2_ = TRUE;
#line 231 "../src/data/Runnable.vala"
	_tmp3_ = _bool_equal (_tmp1_, &_tmp2_) == TRUE;
#line 231 "../src/data/Runnable.vala"
	_g_free0 (_tmp1_);
#line 231 "../src/data/Runnable.vala"
	result = _tmp3_;
#line 231 "../src/data/Runnable.vala"
	return result;
#line 4041 "Runnable.c"
}

void
game_hub_data_runnable_set_compat_options_saved (GameHubDataRunnable* self,
                                                 gboolean value)
{
#line 233 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 235 "../src/data/Runnable.vala"
	if (GAME_HUB_DATA_SOURCES_STEAM_IS_STEAM_GAME (self)) {
#line 235 "../src/data/Runnable.vala"
		return;
#line 4054 "Runnable.c"
	}
#line 236 "../src/data/Runnable.vala"
	game_hub_data_runnable_set_compat_option_bool (self, "compat_options_saved", &value);
#line 233 "../src/data/Runnable.vala"
	g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_COMPAT_OPTIONS_SAVED_PROPERTY]);
#line 4060 "Runnable.c"
}

static inline gpointer
game_hub_data_runnable_installer_get_instance_private (GameHubDataRunnableInstaller* self)
{
	return G_STRUCT_MEMBER_P (self, GameHubDataRunnableInstaller_private_offset);
}

static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1307 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1308 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1308 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1309 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1309 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1310 "glib-2.0.vapi"
	result = _result_;
#line 1310 "glib-2.0.vapi"
	return result;
#line 4090 "Runnable.c"
}

GameHubDataRunnableInstallerInstallerType
game_hub_data_runnable_installer_installer_type_from_mime (const gchar* type)
{
	GameHubDataRunnableInstallerInstallerType result = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label0 = 0;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label1 = 0;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label2 = 0;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label3 = 0;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label4 = 0;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label5 = 0;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label6 = 0;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label7 = 0;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label8 = 0;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label9 = 0;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label10 = 0;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label11 = 0;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label12 = 0;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label13 = 0;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label14 = 0;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label15 = 0;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label16 = 0;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label17 = 0;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label18 = 0;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label19 = 0;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label20 = 0;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label21 = 0;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label22 = 0;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label23 = 0;
#line 700 "../src/data/Runnable.vala"
	static GQuark _tmp2_label24 = 0;
#line 698 "../src/data/Runnable.vala"
	g_return_val_if_fail (type != NULL, 0);
#line 700 "../src/data/Runnable.vala"
	_tmp0_ = string_strip (type);
#line 700 "../src/data/Runnable.vala"
	_tmp1_ = _tmp0_;
#line 700 "../src/data/Runnable.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 700 "../src/data/Runnable.vala"
	g_free (_tmp1_);
#line 700 "../src/data/Runnable.vala"
	if ((((_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("application/x-executable")))) || (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("application/x-elf"))))) || (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("application/x-sh"))))) || (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("application/x-shellscript"))))) {
#line 700 "../src/data/Runnable.vala"
		switch (0) {
#line 4164 "Runnable.c"
			default:
			{
#line 706 "../src/data/Runnable.vala"
				result = GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_EXECUTABLE;
#line 706 "../src/data/Runnable.vala"
				return result;
#line 4171 "Runnable.c"
			}
		}
	} else if (((((((((_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("application/x-dosexec")))) || (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("application/x-ms-dos-executable"))))) || (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("application/dos-exe"))))) || (_tmp3_ == ((0 != _tmp2_label7) ? _tmp2_label7 : (_tmp2_label7 = g_quark_from_static_string ("application/exe"))))) || (_tmp3_ == ((0 != _tmp2_label8) ? _tmp2_label8 : (_tmp2_label8 = g_quark_from_static_string ("application/msdos-windows"))))) || (_tmp3_ == ((0 != _tmp2_label9) ? _tmp2_label9 : (_tmp2_label9 = g_quark_from_static_string ("application/x-exe"))))) || (_tmp3_ == ((0 != _tmp2_label10) ? _tmp2_label10 : (_tmp2_label10 = g_quark_from_static_string ("application/x-msdownload"))))) || (_tmp3_ == ((0 != _tmp2_label11) ? _tmp2_label11 : (_tmp2_label11 = g_quark_from_static_string ("application/x-winexe"))))) || (_tmp3_ == ((0 != _tmp2_label12) ? _tmp2_label12 : (_tmp2_label12 = g_quark_from_static_string ("application/x-msi"))))) {
#line 700 "../src/data/Runnable.vala"
		switch (0) {
#line 4177 "Runnable.c"
			default:
			{
#line 717 "../src/data/Runnable.vala"
				result = GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_EXECUTABLE;
#line 717 "../src/data/Runnable.vala"
				return result;
#line 4184 "Runnable.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label13) ? _tmp2_label13 : (_tmp2_label13 = g_quark_from_static_string ("application/octet-stream")))) {
#line 700 "../src/data/Runnable.vala"
		switch (0) {
#line 4190 "Runnable.c"
			default:
			{
#line 720 "../src/data/Runnable.vala"
				result = GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_GOG_PART;
#line 720 "../src/data/Runnable.vala"
				return result;
#line 4197 "Runnable.c"
			}
		}
	} else if (((((((((((_tmp3_ == ((0 != _tmp2_label14) ? _tmp2_label14 : (_tmp2_label14 = g_quark_from_static_string ("application/zip")))) || (_tmp3_ == ((0 != _tmp2_label15) ? _tmp2_label15 : (_tmp2_label15 = g_quark_from_static_string ("application/x-tar"))))) || (_tmp3_ == ((0 != _tmp2_label16) ? _tmp2_label16 : (_tmp2_label16 = g_quark_from_static_string ("application/x-gtar"))))) || (_tmp3_ == ((0 != _tmp2_label17) ? _tmp2_label17 : (_tmp2_label17 = g_quark_from_static_string ("application/x-cpio"))))) || (_tmp3_ == ((0 != _tmp2_label18) ? _tmp2_label18 : (_tmp2_label18 = g_quark_from_static_string ("application/x-bzip2"))))) || (_tmp3_ == ((0 != _tmp2_label19) ? _tmp2_label19 : (_tmp2_label19 = g_quark_from_static_string ("application/gzip"))))) || (_tmp3_ == ((0 != _tmp2_label20) ? _tmp2_label20 : (_tmp2_label20 = g_quark_from_static_string ("application/x-lzip"))))) || (_tmp3_ == ((0 != _tmp2_label21) ? _tmp2_label21 : (_tmp2_label21 = g_quark_from_static_string ("application/x-lzma"))))) || (_tmp3_ == ((0 != _tmp2_label22) ? _tmp2_label22 : (_tmp2_label22 = g_quark_from_static_string ("application/x-7z-compressed"))))) || (_tmp3_ == ((0 != _tmp2_label23) ? _tmp2_label23 : (_tmp2_label23 = g_quark_from_static_string ("application/x-rar-compressed"))))) || (_tmp3_ == ((0 != _tmp2_label24) ? _tmp2_label24 : (_tmp2_label24 = g_quark_from_static_string ("application/x-compressed-tar"))))) {
#line 700 "../src/data/Runnable.vala"
		switch (0) {
#line 4203 "Runnable.c"
			default:
			{
#line 733 "../src/data/Runnable.vala"
				result = GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_ARCHIVE;
#line 733 "../src/data/Runnable.vala"
				return result;
#line 4210 "Runnable.c"
			}
		}
	}
#line 735 "../src/data/Runnable.vala"
	result = GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_UNKNOWN;
#line 735 "../src/data/Runnable.vala"
	return result;
#line 4218 "Runnable.c"
}

GType
game_hub_data_runnable_installer_installer_type_get_type (void)
{
	static volatile gsize game_hub_data_runnable_installer_installer_type_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_runnable_installer_installer_type_type_id__volatile)) {
		static const GEnumValue values[] = {{GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_UNKNOWN, "GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_UNKNOWN", "unknown"}, {GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_EXECUTABLE, "GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_EXECUTABLE", "executable"}, {GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_EXECUTABLE, "GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_EXECUTABLE", "windows-executable"}, {GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_GOG_PART, "GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_GOG_PART", "gog-part"}, {GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_ARCHIVE, "GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_ARCHIVE", "archive"}, {GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_NSIS_INSTALLER, "GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_NSIS_INSTALLER", "windows-nsis-installer"}, {0, NULL, NULL}};
		GType game_hub_data_runnable_installer_installer_type_type_id;
		game_hub_data_runnable_installer_installer_type_type_id = g_enum_register_static ("GameHubDataRunnableInstallerInstallerType", values);
		g_once_init_leave (&game_hub_data_runnable_installer_installer_type_type_id__volatile, game_hub_data_runnable_installer_installer_type_type_id);
	}
	return game_hub_data_runnable_installer_installer_type_type_id__volatile;
}

GType
game_hub_data_runnable_installer_install_mode_get_type (void)
{
	static volatile gsize game_hub_data_runnable_installer_install_mode_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_runnable_installer_install_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_INTERACTIVE, "GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_INTERACTIVE", "interactive"}, {GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_AUTOMATIC, "GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_AUTOMATIC", "automatic"}, {GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_AUTOMATIC_DOWNLOAD, "GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALL_MODE_AUTOMATIC_DOWNLOAD", "automatic-download"}, {0, NULL, NULL}};
		GType game_hub_data_runnable_installer_install_mode_type_id;
		game_hub_data_runnable_installer_install_mode_type_id = g_enum_register_static ("GameHubDataRunnableInstallerInstallMode", values);
		g_once_init_leave (&game_hub_data_runnable_installer_install_mode_type_id__volatile, game_hub_data_runnable_installer_install_mode_type_id);
	}
	return game_hub_data_runnable_installer_install_mode_type_id__volatile;
}

static void
game_hub_data_runnable_installer_real_fetch_parts_data_free (gpointer _data)
{
	GameHubDataRunnableInstallerFetchPartsData* _data_;
	_data_ = _data;
#line 321 "../src/data/Runnable.vala"
	_game_hub_data_runnable_installer_unref0 (_data_->self);
#line 321 "../src/data/Runnable.vala"
	g_slice_free (GameHubDataRunnableInstallerFetchPartsData, _data_);
#line 4256 "Runnable.c"
}

static void
game_hub_data_runnable_installer_real_fetch_parts_async_ready_wrapper (GObject *source_object,
                                                                       GAsyncResult *res,
                                                                       void *user_data)
{
	GameHubDataRunnableInstallerFetchPartsData* _task_data_;
#line 321 "../src/data/Runnable.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 321 "../src/data/Runnable.vala"
	if (_task_data_->_callback_ != NULL) {
#line 321 "../src/data/Runnable.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 4271 "Runnable.c"
	}
#line 321 "../src/data/Runnable.vala"
	_task_data_->_task_complete_ = TRUE;
#line 4275 "Runnable.c"
}

static gpointer
_game_hub_data_runnable_installer_ref0 (gpointer self)
{
#line 321 "../src/data/Runnable.vala"
	return self ? game_hub_data_runnable_installer_ref (self) : NULL;
#line 4283 "Runnable.c"
}

static void
game_hub_data_runnable_installer_real_fetch_parts (GameHubDataRunnableInstaller* self,
                                                   GAsyncReadyCallback _callback_,
                                                   gpointer _user_data_)
{
	GameHubDataRunnableInstallerFetchPartsData* _data_;
	GameHubDataRunnableInstaller* _tmp0_;
#line 321 "../src/data/Runnable.vala"
	_data_ = g_slice_new0 (GameHubDataRunnableInstallerFetchPartsData);
#line 321 "../src/data/Runnable.vala"
	_data_->_callback_ = _callback_;
#line 321 "../src/data/Runnable.vala"
	_data_->_async_result = g_task_new (NULL, NULL, game_hub_data_runnable_installer_real_fetch_parts_async_ready_wrapper, _user_data_);
#line 321 "../src/data/Runnable.vala"
	if (_callback_ == NULL) {
#line 321 "../src/data/Runnable.vala"
		_data_->_task_complete_ = TRUE;
#line 4303 "Runnable.c"
	}
#line 321 "../src/data/Runnable.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_runnable_installer_real_fetch_parts_data_free);
#line 321 "../src/data/Runnable.vala"
	_tmp0_ = _game_hub_data_runnable_installer_ref0 (self);
#line 321 "../src/data/Runnable.vala"
	_data_->self = _tmp0_;
#line 321 "../src/data/Runnable.vala"
	game_hub_data_runnable_installer_real_fetch_parts_co (_data_);
#line 4313 "Runnable.c"
}

static void
game_hub_data_runnable_installer_real_fetch_parts_finish (GameHubDataRunnableInstaller* self,
                                                          GAsyncResult* _res_)
{
	GameHubDataRunnableInstallerFetchPartsData* _data_;
#line 321 "../src/data/Runnable.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 4323 "Runnable.c"
}

static gboolean
game_hub_data_runnable_installer_real_fetch_parts_co (GameHubDataRunnableInstallerFetchPartsData* _data_)
{
#line 364 "../src/data/Runnable.vala"
	switch (_data_->_state_) {
#line 364 "../src/data/Runnable.vala"
		case 0:
#line 4333 "Runnable.c"
		goto _state_0;
		default:
#line 364 "../src/data/Runnable.vala"
		g_assert_not_reached ();
#line 4338 "Runnable.c"
	}
	_state_0:
#line 364 "../src/data/Runnable.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 364 "../src/data/Runnable.vala"
	if (_data_->_state_ != 0) {
#line 364 "../src/data/Runnable.vala"
		while (!_data_->_task_complete_) {
#line 364 "../src/data/Runnable.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4349 "Runnable.c"
		}
	}
#line 364 "../src/data/Runnable.vala"
	g_object_unref (_data_->_async_result);
#line 364 "../src/data/Runnable.vala"
	return FALSE;
#line 4356 "Runnable.c"
}

void
game_hub_data_runnable_installer_fetch_parts (GameHubDataRunnableInstaller* self,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_)
{
#line 321 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_INSTALLER_GET_CLASS (self)->fetch_parts (self, _callback_, _user_data_);
#line 4366 "Runnable.c"
}

void
game_hub_data_runnable_installer_fetch_parts_finish (GameHubDataRunnableInstaller* self,
                                                     GAsyncResult* _res_)
{
#line 321 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_INSTALLER_GET_CLASS (self)->fetch_parts_finish (self, _res_);
#line 4375 "Runnable.c"
}

static void
game_hub_data_runnable_installer_install_data_free (gpointer _data)
{
	GameHubDataRunnableInstallerInstallData* _data_;
	_data_ = _data;
#line 321 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->tool);
#line 321 "../src/data/Runnable.vala"
	_game_hub_data_runnable_installer_unref0 (_data_->self);
#line 321 "../src/data/Runnable.vala"
	g_slice_free (GameHubDataRunnableInstallerInstallData, _data_);
#line 4389 "Runnable.c"
}

static void
game_hub_data_runnable_installer_install_async_ready_wrapper (GObject *source_object,
                                                              GAsyncResult *res,
                                                              void *user_data)
{
	GameHubDataRunnableInstallerInstallData* _task_data_;
#line 321 "../src/data/Runnable.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 321 "../src/data/Runnable.vala"
	if (_task_data_->_callback_ != NULL) {
#line 321 "../src/data/Runnable.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 4404 "Runnable.c"
	}
#line 321 "../src/data/Runnable.vala"
	_task_data_->_task_complete_ = TRUE;
#line 4408 "Runnable.c"
}

void
game_hub_data_runnable_installer_install (GameHubDataRunnableInstaller* self,
                                          GameHubDataRunnable* runnable,
                                          gboolean dl_only,
                                          GameHubDataCompatTool* tool,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	GameHubDataRunnableInstallerInstallData* _data_;
	GameHubDataRunnableInstaller* _tmp0_;
	GameHubDataRunnable* _tmp1_;
	GameHubDataCompatTool* _tmp2_;
#line 321 "../src/data/Runnable.vala"
	_data_ = g_slice_new0 (GameHubDataRunnableInstallerInstallData);
#line 321 "../src/data/Runnable.vala"
	_data_->_callback_ = _callback_;
#line 321 "../src/data/Runnable.vala"
	_data_->_async_result = g_task_new (NULL, NULL, game_hub_data_runnable_installer_install_async_ready_wrapper, _user_data_);
#line 321 "../src/data/Runnable.vala"
	if (_callback_ == NULL) {
#line 321 "../src/data/Runnable.vala"
		_data_->_task_complete_ = TRUE;
#line 4433 "Runnable.c"
	}
#line 321 "../src/data/Runnable.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_runnable_installer_install_data_free);
#line 321 "../src/data/Runnable.vala"
	_tmp0_ = _game_hub_data_runnable_installer_ref0 (self);
#line 321 "../src/data/Runnable.vala"
	_data_->self = _tmp0_;
#line 321 "../src/data/Runnable.vala"
	_tmp1_ = _g_object_ref0 (runnable);
#line 321 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->runnable);
#line 321 "../src/data/Runnable.vala"
	_data_->runnable = _tmp1_;
#line 321 "../src/data/Runnable.vala"
	_data_->dl_only = dl_only;
#line 321 "../src/data/Runnable.vala"
	_tmp2_ = _g_object_ref0 (tool);
#line 321 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->tool);
#line 321 "../src/data/Runnable.vala"
	_data_->tool = _tmp2_;
#line 321 "../src/data/Runnable.vala"
	game_hub_data_runnable_installer_install_co (_data_);
#line 4457 "Runnable.c"
}

void
game_hub_data_runnable_installer_install_finish (GameHubDataRunnableInstaller* self,
                                                 GAsyncResult* _res_)
{
	GameHubDataRunnableInstallerInstallData* _data_;
#line 321 "../src/data/Runnable.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 4467 "Runnable.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 366 "../src/data/Runnable.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 366 "../src/data/Runnable.vala"
	return _data6_;
#line 4477 "Runnable.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 366 "../src/data/Runnable.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 4487 "Runnable.c"
		GameHubDataRunnableInstaller* self;
#line 366 "../src/data/Runnable.vala"
		self = _data6_->self;
#line 366 "../src/data/Runnable.vala"
		_g_object_unref0 (_data6_->runnable);
#line 366 "../src/data/Runnable.vala"
		_game_hub_data_runnable_installer_unref0 (self);
#line 366 "../src/data/Runnable.vala"
		g_slice_free (Block6Data, _data6_);
#line 4497 "Runnable.c"
	}
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 368 "../src/data/Runnable.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 368 "../src/data/Runnable.vala"
	return _data7_;
#line 4508 "Runnable.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 368 "../src/data/Runnable.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 4518 "Runnable.c"
		GameHubDataRunnableInstaller* self;
#line 368 "../src/data/Runnable.vala"
		self = _data7_->_data6_->self;
#line 368 "../src/data/Runnable.vala"
		_g_object_unref0 (_data7_->game);
#line 368 "../src/data/Runnable.vala"
		block6_data_unref (_data7_->_data6_);
#line 368 "../src/data/Runnable.vala"
		_data7_->_data6_ = NULL;
#line 368 "../src/data/Runnable.vala"
		g_slice_free (Block7Data, _data7_);
#line 4530 "Runnable.c"
	}
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 388 "../src/data/Runnable.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 388 "../src/data/Runnable.vala"
	return _data8_;
#line 4541 "Runnable.c"
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 388 "../src/data/Runnable.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 4551 "Runnable.c"
		GameHubDataRunnableInstaller* self;
#line 388 "../src/data/Runnable.vala"
		self = _data8_->_data7_->_data6_->self;
#line 388 "../src/data/Runnable.vala"
		_g_object_unref0 (_data8_->file);
#line 388 "../src/data/Runnable.vala"
		_g_object_unref0 (_data8_->part);
#line 388 "../src/data/Runnable.vala"
		block7_data_unref (_data8_->_data7_);
#line 388 "../src/data/Runnable.vala"
		_data8_->_data7_ = NULL;
#line 388 "../src/data/Runnable.vala"
		g_slice_free (Block8Data, _data8_);
#line 4565 "Runnable.c"
	}
}

static void
___lambda18_ (Block8Data* _data8_,
              GameHubUtilsDownloaderDownloadStatus* s)
{
	Block7Data* _data7_;
	Block6Data* _data6_;
	GameHubDataRunnableInstaller* self;
	GameHubDataGame* _tmp0_;
	GameHubDataGame* _tmp1_;
	GameHubDataGameStatus* _tmp2_;
	GameHubDataGameStatus* _tmp3_;
#line 395 "../src/data/Runnable.vala"
	_data7_ = _data8_->_data7_;
#line 395 "../src/data/Runnable.vala"
	_data6_ = _data7_->_data6_;
#line 395 "../src/data/Runnable.vala"
	self = _data6_->self;
#line 395 "../src/data/Runnable.vala"
	g_return_if_fail (s != NULL);
#line 396 "../src/data/Runnable.vala"
	_tmp0_ = _data7_->game;
#line 396 "../src/data/Runnable.vala"
	_tmp1_ = _data7_->game;
#line 396 "../src/data/Runnable.vala"
	_tmp2_ = game_hub_data_game_get_status (_tmp1_);
#line 396 "../src/data/Runnable.vala"
	_tmp3_ = _tmp2_;
#line 396 "../src/data/Runnable.vala"
	g_signal_emit_by_name (_tmp0_, "status-change", _tmp3_);
#line 4598 "Runnable.c"
}

static void
____lambda18__game_hub_utils_downloader_download_status_change (GameHubUtilsDownloaderDownload* _sender,
                                                                GameHubUtilsDownloaderDownloadStatus* status,
                                                                gpointer self)
{
#line 395 "../src/data/Runnable.vala"
	___lambda18_ (self, status);
#line 4608 "Runnable.c"
}

static void
_____lambda17_ (Block8Data* _data8_,
                GameHubUtilsDownloaderDownload* dl)
{
	Block7Data* _data7_;
	Block6Data* _data6_;
	GameHubDataRunnableInstaller* self;
	GFile* _tmp0_;
	GameHubDataRunnableInstallerPart* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GameHubDataGame* _tmp4_;
#line 390 "../src/data/Runnable.vala"
	_data7_ = _data8_->_data7_;
#line 390 "../src/data/Runnable.vala"
	_data6_ = _data7_->_data6_;
#line 390 "../src/data/Runnable.vala"
	self = _data6_->self;
#line 390 "../src/data/Runnable.vala"
	g_return_if_fail (dl != NULL);
#line 391 "../src/data/Runnable.vala"
	_tmp0_ = dl->remote;
#line 391 "../src/data/Runnable.vala"
	_tmp1_ = _data8_->part;
#line 391 "../src/data/Runnable.vala"
	_tmp2_ = game_hub_data_runnable_installer_part_get_remote (_tmp1_);
#line 391 "../src/data/Runnable.vala"
	_tmp3_ = _tmp2_;
#line 391 "../src/data/Runnable.vala"
	if (_tmp0_ != _tmp3_) {
#line 391 "../src/data/Runnable.vala"
		return;
#line 4643 "Runnable.c"
	}
#line 392 "../src/data/Runnable.vala"
	_tmp4_ = _data7_->game;
#line 392 "../src/data/Runnable.vala"
	if (_tmp4_ != NULL) {
#line 4649 "Runnable.c"
		GameHubDataGame* _tmp5_;
		GameHubDataGame* _tmp6_;
		GameHubDataGameStatus* _tmp7_;
		GameHubDataGameStatus* _tmp8_;
#line 394 "../src/data/Runnable.vala"
		_tmp5_ = _data7_->game;
#line 394 "../src/data/Runnable.vala"
		_tmp6_ = _data7_->game;
#line 394 "../src/data/Runnable.vala"
		_tmp7_ = game_hub_data_game_status_new (GAME_HUB_DATA_GAME_STATE_DOWNLOADING, _tmp6_, dl);
#line 394 "../src/data/Runnable.vala"
		_tmp8_ = _tmp7_;
#line 394 "../src/data/Runnable.vala"
		game_hub_data_game_set_status (_tmp5_, _tmp8_);
#line 394 "../src/data/Runnable.vala"
		_game_hub_data_game_status_unref0 (_tmp8_);
#line 395 "../src/data/Runnable.vala"
		g_signal_connect_data (dl, "status-change", (GCallback) ____lambda18__game_hub_utils_downloader_download_status_change, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 4668 "Runnable.c"
	}
}

static void
______lambda17__game_hub_utils_downloader_downloader_download_started (GameHubUtilsDownloaderDownloader* _sender,
                                                                       GameHubUtilsDownloaderDownload* download,
                                                                       gpointer self)
{
#line 390 "../src/data/Runnable.vala"
	_____lambda17_ (self, download);
#line 4679 "Runnable.c"
}

static void
game_hub_data_runnable_installer_install_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_)
{
	GameHubDataRunnableInstallerInstallData* _data_;
#line 409 "../src/data/Runnable.vala"
	_data_ = _user_data_;
#line 409 "../src/data/Runnable.vala"
	_data_->_source_object_ = source_object;
#line 409 "../src/data/Runnable.vala"
	_data_->_res_ = _res_;
#line 409 "../src/data/Runnable.vala"
	_data_->_task_complete_ = TRUE;
#line 409 "../src/data/Runnable.vala"
	game_hub_data_runnable_installer_install_co (_data_);
#line 4698 "Runnable.c"
}

static GNotification*
_______lambda23_ (Block8Data* _data8_,
                  GNotification* n)
{
	Block7Data* _data7_;
	Block6Data* _data6_;
	GameHubDataRunnableInstaller* self;
	GNotification* result = NULL;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
	GameHubDataGame* _tmp2_;
	gchar* _tmp13_ = NULL;
	GameHubDataGame* _tmp14_;
	GVariant* args = NULL;
	GFile* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	GVariant* _tmp24_;
	GVariant* _tmp25_;
	GNotification* _tmp26_;
#line 431 "../src/data/Runnable.vala"
	_data7_ = _data8_->_data7_;
#line 431 "../src/data/Runnable.vala"
	_data6_ = _data7_->_data6_;
#line 431 "../src/data/Runnable.vala"
	self = _data6_->self;
#line 431 "../src/data/Runnable.vala"
	g_return_val_if_fail (n != NULL, NULL);
#line 432 "../src/data/Runnable.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("dialog-warning");
#line 432 "../src/data/Runnable.vala"
	_tmp1_ = _tmp0_;
#line 432 "../src/data/Runnable.vala"
	g_notification_set_icon (n, (GIcon*) _tmp1_);
#line 432 "../src/data/Runnable.vala"
	_g_object_unref0 (_tmp1_);
#line 433 "../src/data/Runnable.vala"
	_tmp2_ = _data7_->game;
#line 433 "../src/data/Runnable.vala"
	if (_tmp2_ != NULL) {
#line 4741 "Runnable.c"
		GFile* icon = NULL;
		GameHubDataGame* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		GFile* _tmp6_;
		gboolean _tmp7_ = FALSE;
		GFile* _tmp8_;
#line 435 "../src/data/Runnable.vala"
		_tmp3_ = _data7_->game;
#line 435 "../src/data/Runnable.vala"
		_tmp4_ = game_hub_data_game_get_icon (_tmp3_);
#line 435 "../src/data/Runnable.vala"
		_tmp5_ = _tmp4_;
#line 435 "../src/data/Runnable.vala"
		_tmp6_ = game_hub_utils_image_cache_local_file (_tmp5_, "icon");
#line 435 "../src/data/Runnable.vala"
		icon = _tmp6_;
#line 436 "../src/data/Runnable.vala"
		_tmp8_ = icon;
#line 436 "../src/data/Runnable.vala"
		if (_tmp8_ != NULL) {
#line 4763 "Runnable.c"
			GFile* _tmp9_;
#line 436 "../src/data/Runnable.vala"
			_tmp9_ = icon;
#line 436 "../src/data/Runnable.vala"
			_tmp7_ = g_file_query_exists (_tmp9_, NULL);
#line 4769 "Runnable.c"
		} else {
#line 436 "../src/data/Runnable.vala"
			_tmp7_ = FALSE;
#line 4773 "Runnable.c"
		}
#line 436 "../src/data/Runnable.vala"
		if (_tmp7_) {
#line 4777 "Runnable.c"
			GFile* _tmp10_;
			GFileIcon* _tmp11_;
			GFileIcon* _tmp12_;
#line 438 "../src/data/Runnable.vala"
			_tmp10_ = icon;
#line 438 "../src/data/Runnable.vala"
			_tmp11_ = (GFileIcon*) g_file_icon_new (_tmp10_);
#line 438 "../src/data/Runnable.vala"
			_tmp12_ = _tmp11_;
#line 438 "../src/data/Runnable.vala"
			g_notification_set_icon (n, (GIcon*) _tmp12_);
#line 438 "../src/data/Runnable.vala"
			_g_object_unref0 (_tmp12_);
#line 4791 "Runnable.c"
		}
#line 433 "../src/data/Runnable.vala"
		_g_object_unref0 (icon);
#line 4795 "Runnable.c"
	}
#line 441 "../src/data/Runnable.vala"
	_tmp14_ = _data7_->game;
#line 441 "../src/data/Runnable.vala"
	if (_tmp14_ != NULL) {
#line 4801 "Runnable.c"
		GameHubDataGame* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 441 "../src/data/Runnable.vala"
		_tmp15_ = _data7_->game;
#line 441 "../src/data/Runnable.vala"
		_tmp16_ = game_hub_data_game_get_full_id (_tmp15_);
#line 441 "../src/data/Runnable.vala"
		_tmp17_ = _tmp16_;
#line 441 "../src/data/Runnable.vala"
		_g_free0 (_tmp13_);
#line 441 "../src/data/Runnable.vala"
		_tmp13_ = _tmp17_;
#line 4815 "Runnable.c"
	} else {
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
#line 441 "../src/data/Runnable.vala"
		_tmp18_ = game_hub_data_runnable_get_id (_data6_->runnable);
#line 441 "../src/data/Runnable.vala"
		_tmp19_ = _tmp18_;
#line 441 "../src/data/Runnable.vala"
		_tmp20_ = g_strdup (_tmp19_);
#line 441 "../src/data/Runnable.vala"
		_g_free0 (_tmp13_);
#line 441 "../src/data/Runnable.vala"
		_tmp13_ = _tmp20_;
#line 4830 "Runnable.c"
	}
#line 441 "../src/data/Runnable.vala"
	_tmp21_ = _data8_->file;
#line 441 "../src/data/Runnable.vala"
	_tmp22_ = g_file_get_path (_tmp21_);
#line 441 "../src/data/Runnable.vala"
	_tmp23_ = _tmp22_;
#line 441 "../src/data/Runnable.vala"
	_tmp24_ = g_variant_new ("(ss)", _tmp13_, _tmp23_, NULL);
#line 441 "../src/data/Runnable.vala"
	g_variant_ref_sink (_tmp24_);
#line 441 "../src/data/Runnable.vala"
	_tmp25_ = _tmp24_;
#line 441 "../src/data/Runnable.vala"
	_g_free0 (_tmp23_);
#line 441 "../src/data/Runnable.vala"
	args = _tmp25_;
#line 442 "../src/data/Runnable.vala"
	g_notification_set_default_action_and_target_value (n, GAME_HUB_APPLICATION_ACTION_PREFIX GAME_HUB_APPLICATION_ACTION_CORRUPTED_INSTALLER_PICK_ACTION, args);
#line 443 "../src/data/Runnable.vala"
	g_notification_add_button_with_target_value (n, _ ("Show file"), GAME_HUB_APPLICATION_ACTION_PREFIX GAME_HUB_APPLICATION_ACTION_CORRUPTED_INSTALLER_SHOW, args);
#line 444 "../src/data/Runnable.vala"
	g_notification_add_button_with_target_value (n, _ ("Remove"), GAME_HUB_APPLICATION_ACTION_PREFIX GAME_HUB_APPLICATION_ACTION_CORRUPTED_INSTALLER_REMOVE, args);
#line 445 "../src/data/Runnable.vala"
	g_notification_add_button_with_target_value (n, _ ("Backup"), GAME_HUB_APPLICATION_ACTION_PREFIX GAME_HUB_APPLICATION_ACTION_CORRUPTED_INSTALLER_BACKUP, args);
#line 446 "../src/data/Runnable.vala"
	_tmp26_ = _g_object_ref0 (n);
#line 446 "../src/data/Runnable.vala"
	result = _tmp26_;
#line 446 "../src/data/Runnable.vala"
	_g_variant_unref0 (args);
#line 446 "../src/data/Runnable.vala"
	_g_free0 (_tmp13_);
#line 446 "../src/data/Runnable.vala"
	return result;
#line 4866 "Runnable.c"
}

static GNotification*
________lambda23__game_hub_utils_notification_configure_delegate (GNotification* notification,
                                                                  gpointer self)
{
	GNotification* result;
	result = _______lambda23_ (self, notification);
#line 427 "../src/data/Runnable.vala"
	return result;
#line 4877 "Runnable.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1477 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1477 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1477 "glib-2.0.vapi"
	return result;
#line 4896 "Runnable.c"
}

static GNotification*
_____lambda106_ (Block7Data* _data7_,
                 GNotification* n)
{
	Block6Data* _data6_;
	GameHubDataRunnableInstaller* self;
	GNotification* result = NULL;
	GThemedIcon* _tmp0_;
	GThemedIcon* _tmp1_;
	GameHubDataGame* _tmp2_;
	GameHubDataGame* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	GVariant* _tmp17_;
	GVariant* _tmp18_;
	GNotification* _tmp19_;
#line 598 "../src/data/Runnable.vala"
	_data6_ = _data7_->_data6_;
#line 598 "../src/data/Runnable.vala"
	self = _data6_->self;
#line 598 "../src/data/Runnable.vala"
	g_return_val_if_fail (n != NULL, NULL);
#line 599 "../src/data/Runnable.vala"
	_tmp0_ = (GThemedIcon*) g_themed_icon_new ("dialog-warning");
#line 599 "../src/data/Runnable.vala"
	_tmp1_ = _tmp0_;
#line 599 "../src/data/Runnable.vala"
	g_notification_set_icon (n, (GIcon*) _tmp1_);
#line 599 "../src/data/Runnable.vala"
	_g_object_unref0 (_tmp1_);
#line 600 "../src/data/Runnable.vala"
	_tmp2_ = _data7_->game;
#line 600 "../src/data/Runnable.vala"
	if (_tmp2_ != NULL) {
#line 4934 "Runnable.c"
		GFile* icon = NULL;
		GameHubDataGame* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		GFile* _tmp6_;
		gboolean _tmp7_ = FALSE;
		GFile* _tmp8_;
#line 602 "../src/data/Runnable.vala"
		_tmp3_ = _data7_->game;
#line 602 "../src/data/Runnable.vala"
		_tmp4_ = game_hub_data_game_get_icon (_tmp3_);
#line 602 "../src/data/Runnable.vala"
		_tmp5_ = _tmp4_;
#line 602 "../src/data/Runnable.vala"
		_tmp6_ = game_hub_utils_image_cache_local_file (_tmp5_, "icon");
#line 602 "../src/data/Runnable.vala"
		icon = _tmp6_;
#line 603 "../src/data/Runnable.vala"
		_tmp8_ = icon;
#line 603 "../src/data/Runnable.vala"
		if (_tmp8_ != NULL) {
#line 4956 "Runnable.c"
			GFile* _tmp9_;
#line 603 "../src/data/Runnable.vala"
			_tmp9_ = icon;
#line 603 "../src/data/Runnable.vala"
			_tmp7_ = g_file_query_exists (_tmp9_, NULL);
#line 4962 "Runnable.c"
		} else {
#line 603 "../src/data/Runnable.vala"
			_tmp7_ = FALSE;
#line 4966 "Runnable.c"
		}
#line 603 "../src/data/Runnable.vala"
		if (_tmp7_) {
#line 4970 "Runnable.c"
			GFile* _tmp10_;
			GFileIcon* _tmp11_;
			GFileIcon* _tmp12_;
#line 605 "../src/data/Runnable.vala"
			_tmp10_ = icon;
#line 605 "../src/data/Runnable.vala"
			_tmp11_ = (GFileIcon*) g_file_icon_new (_tmp10_);
#line 605 "../src/data/Runnable.vala"
			_tmp12_ = _tmp11_;
#line 605 "../src/data/Runnable.vala"
			g_notification_set_icon (n, (GIcon*) _tmp12_);
#line 605 "../src/data/Runnable.vala"
			_g_object_unref0 (_tmp12_);
#line 4984 "Runnable.c"
		}
#line 600 "../src/data/Runnable.vala"
		_g_object_unref0 (icon);
#line 4988 "Runnable.c"
	}
#line 608 "../src/data/Runnable.vala"
	_tmp13_ = _data7_->game;
#line 608 "../src/data/Runnable.vala"
	_tmp14_ = game_hub_data_game_get_full_id (_tmp13_);
#line 608 "../src/data/Runnable.vala"
	_tmp15_ = _tmp14_;
#line 608 "../src/data/Runnable.vala"
	_tmp16_ = _tmp15_;
#line 608 "../src/data/Runnable.vala"
	_tmp17_ = g_variant_new_string (_tmp16_);
#line 608 "../src/data/Runnable.vala"
	g_variant_ref_sink (_tmp17_);
#line 608 "../src/data/Runnable.vala"
	_tmp18_ = _tmp17_;
#line 608 "../src/data/Runnable.vala"
	g_notification_set_default_action_and_target_value (n, GAME_HUB_APPLICATION_ACTION_PREFIX GAME_HUB_APPLICATION_ACTION_GAME_PROPERTIES, _tmp18_);
#line 608 "../src/data/Runnable.vala"
	_g_variant_unref0 (_tmp18_);
#line 608 "../src/data/Runnable.vala"
	_g_free0 (_tmp16_);
#line 609 "../src/data/Runnable.vala"
	_tmp19_ = _g_object_ref0 (n);
#line 609 "../src/data/Runnable.vala"
	result = _tmp19_;
#line 609 "../src/data/Runnable.vala"
	return result;
#line 5016 "Runnable.c"
}

static GNotification*
______lambda106__game_hub_utils_notification_configure_delegate (GNotification* notification,
                                                                 gpointer self)
{
	GNotification* result;
	result = _____lambda106_ (self, notification);
#line 594 "../src/data/Runnable.vala"
	return result;
#line 5027 "Runnable.c"
}

static gboolean
game_hub_data_runnable_installer_install_co (GameHubDataRunnableInstallerInstallData* _data_)
{
#line 366 "../src/data/Runnable.vala"
	switch (_data_->_state_) {
#line 366 "../src/data/Runnable.vala"
		case 0:
#line 5037 "Runnable.c"
		goto _state_0;
#line 366 "../src/data/Runnable.vala"
		case 1:
#line 5041 "Runnable.c"
		goto _state_1;
#line 366 "../src/data/Runnable.vala"
		case 2:
#line 5045 "Runnable.c"
		goto _state_2;
#line 366 "../src/data/Runnable.vala"
		case 3:
#line 5049 "Runnable.c"
		goto _state_3;
#line 366 "../src/data/Runnable.vala"
		case 4:
#line 5053 "Runnable.c"
		goto _state_4;
#line 366 "../src/data/Runnable.vala"
		case 5:
#line 5057 "Runnable.c"
		goto _state_5;
#line 366 "../src/data/Runnable.vala"
		case 6:
#line 5061 "Runnable.c"
		goto _state_6;
#line 366 "../src/data/Runnable.vala"
		case 7:
#line 5065 "Runnable.c"
		goto _state_7;
		default:
#line 366 "../src/data/Runnable.vala"
		g_assert_not_reached ();
#line 5070 "Runnable.c"
	}
	_state_0:
#line 366 "../src/data/Runnable.vala"
	_data_->_data6_ = g_slice_new0 (Block6Data);
#line 366 "../src/data/Runnable.vala"
	_data_->_data6_->_ref_count_ = 1;
#line 366 "../src/data/Runnable.vala"
	_data_->_data6_->self = game_hub_data_runnable_installer_ref (_data_->self);
#line 366 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->_data6_->runnable);
#line 366 "../src/data/Runnable.vala"
	_data_->_data6_->runnable = _data_->runnable;
#line 366 "../src/data/Runnable.vala"
	_data_->_data6_->_async_data_ = _data_;
#line 5085 "Runnable.c"
	{
#line 368 "../src/data/Runnable.vala"
		_data_->_data7_ = g_slice_new0 (Block7Data);
#line 368 "../src/data/Runnable.vala"
		_data_->_data7_->_ref_count_ = 1;
#line 368 "../src/data/Runnable.vala"
		_data_->_data7_->_data6_ = block6_data_ref (_data_->_data6_);
#line 370 "../src/data/Runnable.vala"
		_data_->_data7_->game = NULL;
#line 372 "../src/data/Runnable.vala"
		if (GAME_HUB_DATA_IS_GAME (_data_->_data6_->runnable)) {
#line 374 "../src/data/Runnable.vala"
			_data_->_tmp0_ = _g_object_ref0 (GAME_HUB_DATA_IS_GAME (_data_->_data6_->runnable) ? ((GameHubDataGame*) _data_->_data6_->runnable) : NULL);
#line 374 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->_data7_->game);
#line 374 "../src/data/Runnable.vala"
			_data_->_data7_->game = _data_->_tmp0_;
#line 5103 "Runnable.c"
		}
#line 377 "../src/data/Runnable.vala"
		_data_->_tmp1_ = _data_->_data7_->game;
#line 377 "../src/data/Runnable.vala"
		if (_data_->_tmp1_ != NULL) {
#line 377 "../src/data/Runnable.vala"
			_data_->_tmp2_ = _data_->_data7_->game;
#line 377 "../src/data/Runnable.vala"
			_data_->_tmp3_ = _data_->_data7_->game;
#line 377 "../src/data/Runnable.vala"
			_data_->_tmp4_ = game_hub_data_game_status_new (GAME_HUB_DATA_GAME_STATE_DOWNLOADING, _data_->_tmp3_, NULL);
#line 377 "../src/data/Runnable.vala"
			_data_->_tmp5_ = _data_->_tmp4_;
#line 377 "../src/data/Runnable.vala"
			game_hub_data_game_set_status (_data_->_tmp2_, _data_->_tmp5_);
#line 377 "../src/data/Runnable.vala"
			_game_hub_data_game_status_unref0 (_data_->_tmp5_);
#line 5121 "Runnable.c"
		}
#line 379 "../src/data/Runnable.vala"
		_data_->_tmp7_ = game_hub_data_runnable_get_install_dir (_data_->_data6_->runnable);
#line 379 "../src/data/Runnable.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 379 "../src/data/Runnable.vala"
		_data_->_tmp9_ = _g_object_ref0 (_data_->_tmp8_);
#line 379 "../src/data/Runnable.vala"
		_data_->_tmp6_ = _data_->_tmp9_;
#line 379 "../src/data/Runnable.vala"
		if (_data_->_tmp6_ == NULL) {
#line 379 "../src/data/Runnable.vala"
			_data_->_tmp10_ = game_hub_data_runnable_get_default_install_dir (_data_->_data6_->runnable);
#line 379 "../src/data/Runnable.vala"
			_data_->_tmp11_ = _data_->_tmp10_;
#line 379 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->_tmp6_);
#line 379 "../src/data/Runnable.vala"
			_data_->_tmp6_ = _data_->_tmp11_;
#line 5141 "Runnable.c"
		}
#line 379 "../src/data/Runnable.vala"
		_data_->_tmp12_ = _g_object_ref0 (_data_->_tmp6_);
#line 379 "../src/data/Runnable.vala"
		_data_->runnable_install_dir = _data_->_tmp12_;
#line 381 "../src/data/Runnable.vala"
		_data_->_tmp13_ = _data_->runnable_install_dir;
#line 381 "../src/data/Runnable.vala"
		if (_data_->_tmp13_ == NULL) {
#line 381 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->runnable_install_dir);
#line 381 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->_tmp6_);
#line 381 "../src/data/Runnable.vala"
			block7_data_unref (_data_->_data7_);
#line 381 "../src/data/Runnable.vala"
			_data_->_data7_ = NULL;
#line 381 "../src/data/Runnable.vala"
			block6_data_unref (_data_->_data6_);
#line 381 "../src/data/Runnable.vala"
			_data_->_data6_ = NULL;
#line 381 "../src/data/Runnable.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 381 "../src/data/Runnable.vala"
			if (_data_->_state_ != 0) {
#line 381 "../src/data/Runnable.vala"
				while (!_data_->_task_complete_) {
#line 381 "../src/data/Runnable.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5171 "Runnable.c"
				}
			}
#line 381 "../src/data/Runnable.vala"
			g_object_unref (_data_->_async_result);
#line 381 "../src/data/Runnable.vala"
			return FALSE;
#line 5178 "Runnable.c"
		}
#line 383 "../src/data/Runnable.vala"
		_data_->_tmp14_ = _data_->runnable_install_dir;
#line 383 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_install_dir (_data_->_data6_->runnable, _data_->_tmp14_);
#line 385 "../src/data/Runnable.vala"
		_data_->_tmp15_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 385 "../src/data/Runnable.vala"
		_data_->files = _data_->_tmp15_;
#line 387 "../src/data/Runnable.vala"
		_data_->p = (guint) 1;
#line 5190 "Runnable.c"
		{
#line 388 "../src/data/Runnable.vala"
			_data_->_tmp16_ = _data_->self->priv->_parts;
#line 388 "../src/data/Runnable.vala"
			_data_->_tmp17_ = _g_object_ref0 (_data_->_tmp16_);
#line 388 "../src/data/Runnable.vala"
			_data_->_part_list = _data_->_tmp17_;
#line 388 "../src/data/Runnable.vala"
			_data_->_tmp18_ = _data_->_part_list;
#line 388 "../src/data/Runnable.vala"
			_data_->_tmp19_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp18_);
#line 388 "../src/data/Runnable.vala"
			_data_->_tmp20_ = _data_->_tmp19_;
#line 388 "../src/data/Runnable.vala"
			_data_->_part_size = _data_->_tmp20_;
#line 388 "../src/data/Runnable.vala"
			_data_->_part_index = -1;
#line 388 "../src/data/Runnable.vala"
			while (TRUE) {
#line 388 "../src/data/Runnable.vala"
				_data_->_data8_ = g_slice_new0 (Block8Data);
#line 388 "../src/data/Runnable.vala"
				_data_->_data8_->_ref_count_ = 1;
#line 388 "../src/data/Runnable.vala"
				_data_->_data8_->_data7_ = block7_data_ref (_data_->_data7_);
#line 388 "../src/data/Runnable.vala"
				_data_->_part_index = _data_->_part_index + 1;
#line 388 "../src/data/Runnable.vala"
				if (!(_data_->_part_index < _data_->_part_size)) {
#line 388 "../src/data/Runnable.vala"
					block8_data_unref (_data_->_data8_);
#line 388 "../src/data/Runnable.vala"
					_data_->_data8_ = NULL;
#line 388 "../src/data/Runnable.vala"
					break;
#line 5226 "Runnable.c"
				}
#line 388 "../src/data/Runnable.vala"
				_data_->_tmp21_ = _data_->_part_list;
#line 388 "../src/data/Runnable.vala"
				_data_->_tmp22_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp21_, _data_->_part_index);
#line 388 "../src/data/Runnable.vala"
				_data_->_data8_->part = (GameHubDataRunnableInstallerPart*) _data_->_tmp22_;
#line 390 "../src/data/Runnable.vala"
				_data_->_tmp23_ = game_hub_utils_downloader_get_instance ();
#line 390 "../src/data/Runnable.vala"
				_data_->_tmp24_ = _data_->_tmp23_;
#line 390 "../src/data/Runnable.vala"
				_data_->_tmp25_ = g_signal_connect_data (_data_->_tmp24_, "download-started", (GCallback) ______lambda17__game_hub_utils_downloader_downloader_download_started, block8_data_ref (_data_->_data8_), (GClosureNotify) block8_data_unref, 0);
#line 390 "../src/data/Runnable.vala"
				_data_->_tmp26_ = _data_->_tmp25_;
#line 390 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->_tmp24_);
#line 390 "../src/data/Runnable.vala"
				_data_->ds_id = _data_->_tmp26_;
#line 401 "../src/data/Runnable.vala"
				_data_->_tmp27_ = _data_->_data8_->part;
#line 401 "../src/data/Runnable.vala"
				_data_->_tmp28_ = game_hub_data_runnable_installer_part_get_id (_data_->_tmp27_);
#line 401 "../src/data/Runnable.vala"
				_data_->_tmp29_ = _data_->_tmp28_;
#line 401 "../src/data/Runnable.vala"
				_data_->_tmp30_ = g_strdup (_data_->_tmp29_);
#line 401 "../src/data/Runnable.vala"
				_data_->partDesc = _data_->_tmp30_;
#line 403 "../src/data/Runnable.vala"
				_data_->_tmp31_ = _data_->self->priv->_parts;
#line 403 "../src/data/Runnable.vala"
				_data_->_tmp32_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp31_);
#line 403 "../src/data/Runnable.vala"
				_data_->_tmp33_ = _data_->_tmp32_;
#line 403 "../src/data/Runnable.vala"
				if (_data_->_tmp33_ > 1) {
#line 405 "../src/data/Runnable.vala"
					_data_->_tmp34_ = _data_->self->priv->_parts;
#line 405 "../src/data/Runnable.vala"
					_data_->_tmp35_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp34_);
#line 405 "../src/data/Runnable.vala"
					_data_->_tmp36_ = _data_->_tmp35_;
#line 405 "../src/data/Runnable.vala"
					_data_->_tmp37_ = _data_->_data8_->part;
#line 405 "../src/data/Runnable.vala"
					_data_->_tmp38_ = game_hub_data_runnable_installer_part_get_id (_data_->_tmp37_);
#line 405 "../src/data/Runnable.vala"
					_data_->_tmp39_ = _data_->_tmp38_;
#line 405 "../src/data/Runnable.vala"
					_data_->_tmp40_ = g_strdup_printf (_ ("Part %1$u of %2$u: %3$s"), _data_->p, _data_->_tmp36_, _data_->_tmp39_);
#line 405 "../src/data/Runnable.vala"
					_g_free0 (_data_->partDesc);
#line 405 "../src/data/Runnable.vala"
					_data_->partDesc = _data_->_tmp40_;
#line 5282 "Runnable.c"
				}
#line 408 "../src/data/Runnable.vala"
				_data_->_tmp42_ = _data_->_data7_->game;
#line 408 "../src/data/Runnable.vala"
				if (_data_->_tmp42_ != NULL) {
#line 408 "../src/data/Runnable.vala"
					_data_->_tmp43_ = _data_->_data7_->game;
#line 408 "../src/data/Runnable.vala"
					_data_->_tmp44_ = game_hub_data_game_get_icon (_data_->_tmp43_);
#line 408 "../src/data/Runnable.vala"
					_data_->_tmp45_ = _data_->_tmp44_;
#line 408 "../src/data/Runnable.vala"
					_data_->_tmp41_ = _data_->_tmp45_;
#line 5296 "Runnable.c"
				} else {
#line 408 "../src/data/Runnable.vala"
					_data_->_tmp41_ = NULL;
#line 5300 "Runnable.c"
				}
#line 408 "../src/data/Runnable.vala"
				_data_->_tmp47_ = _data_->_data7_->game;
#line 408 "../src/data/Runnable.vala"
				if (_data_->_tmp47_ != NULL) {
#line 408 "../src/data/Runnable.vala"
					_data_->_tmp48_ = _data_->_data7_->game;
#line 408 "../src/data/Runnable.vala"
					_data_->_tmp49_ = game_hub_data_game_get_source (_data_->_tmp48_);
#line 408 "../src/data/Runnable.vala"
					_data_->_tmp50_ = _data_->_tmp49_;
#line 408 "../src/data/Runnable.vala"
					_data_->_tmp51_ = game_hub_data_game_source_get_icon (_data_->_tmp50_);
#line 408 "../src/data/Runnable.vala"
					_data_->_tmp52_ = _data_->_tmp51_;
#line 408 "../src/data/Runnable.vala"
					_data_->_tmp46_ = _data_->_tmp52_;
#line 5318 "Runnable.c"
				} else {
#line 408 "../src/data/Runnable.vala"
					_data_->_tmp46_ = NULL;
#line 5322 "Runnable.c"
				}
#line 408 "../src/data/Runnable.vala"
				_data_->_tmp53_ = game_hub_data_runnable_get_name (_data_->_data6_->runnable);
#line 408 "../src/data/Runnable.vala"
				_data_->_tmp54_ = _data_->_tmp53_;
#line 408 "../src/data/Runnable.vala"
				_data_->_tmp55_ = _data_->partDesc;
#line 408 "../src/data/Runnable.vala"
				_data_->_tmp56_ = game_hub_utils_downloader_download_info_new (_data_->_tmp54_, _data_->_tmp55_, _data_->_tmp41_, NULL, NULL, _data_->_tmp46_);
#line 408 "../src/data/Runnable.vala"
				_data_->info = _data_->_tmp56_;
#line 409 "../src/data/Runnable.vala"
				_data_->_tmp57_ = _data_->_data8_->part;
#line 409 "../src/data/Runnable.vala"
				_data_->_tmp58_ = game_hub_data_runnable_installer_part_get_remote (_data_->_tmp57_);
#line 409 "../src/data/Runnable.vala"
				_data_->_tmp59_ = _data_->_tmp58_;
#line 409 "../src/data/Runnable.vala"
				_data_->_tmp60_ = _data_->_data8_->part;
#line 409 "../src/data/Runnable.vala"
				_data_->_tmp61_ = game_hub_data_runnable_installer_part_get_local (_data_->_tmp60_);
#line 409 "../src/data/Runnable.vala"
				_data_->_tmp62_ = _data_->_tmp61_;
#line 409 "../src/data/Runnable.vala"
				_data_->_tmp63_ = _data_->info;
#line 409 "../src/data/Runnable.vala"
				_data_->_state_ = 1;
#line 409 "../src/data/Runnable.vala"
				game_hub_utils_downloader_download (_data_->_tmp59_, _data_->_tmp62_, _data_->_tmp63_, TRUE, TRUE, game_hub_data_runnable_installer_install_ready, _data_);
#line 409 "../src/data/Runnable.vala"
				return FALSE;
#line 5354 "Runnable.c"
				_state_1:
#line 409 "../src/data/Runnable.vala"
				_data_->_tmp64_ = game_hub_utils_downloader_download_finish (_data_->_res_, &_data_->_inner_error0_);
#line 409 "../src/data/Runnable.vala"
				_data_->_data8_->file = _data_->_tmp64_;
#line 409 "../src/data/Runnable.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 409 "../src/data/Runnable.vala"
					_g_object_unref0 (_data_->info);
#line 409 "../src/data/Runnable.vala"
					_g_free0 (_data_->partDesc);
#line 409 "../src/data/Runnable.vala"
					block8_data_unref (_data_->_data8_);
#line 409 "../src/data/Runnable.vala"
					_data_->_data8_ = NULL;
#line 409 "../src/data/Runnable.vala"
					_g_object_unref0 (_data_->_part_list);
#line 409 "../src/data/Runnable.vala"
					_g_object_unref0 (_data_->files);
#line 409 "../src/data/Runnable.vala"
					_g_object_unref0 (_data_->runnable_install_dir);
#line 409 "../src/data/Runnable.vala"
					_g_object_unref0 (_data_->_tmp6_);
#line 409 "../src/data/Runnable.vala"
					block7_data_unref (_data_->_data7_);
#line 409 "../src/data/Runnable.vala"
					_data_->_data7_ = NULL;
#line 409 "../src/data/Runnable.vala"
					if (g_error_matches (_data_->_inner_error0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 5384 "Runnable.c"
						goto __catch5_g_io_error_cancelled;
					}
					goto __catch5_g_error;
				}
#line 410 "../src/data/Runnable.vala"
				_data_->_tmp66_ = _data_->_data8_->file;
#line 410 "../src/data/Runnable.vala"
				if (_data_->_tmp66_ != NULL) {
#line 410 "../src/data/Runnable.vala"
					_data_->_tmp67_ = _data_->_data8_->file;
#line 410 "../src/data/Runnable.vala"
					_data_->_tmp65_ = g_file_query_exists (_data_->_tmp67_, NULL);
#line 5397 "Runnable.c"
				} else {
#line 410 "../src/data/Runnable.vala"
					_data_->_tmp65_ = FALSE;
#line 5401 "Runnable.c"
				}
#line 410 "../src/data/Runnable.vala"
				if (_data_->_tmp65_) {
#line 412 "../src/data/Runnable.vala"
					_data_->file_checksum = NULL;
#line 413 "../src/data/Runnable.vala"
					_data_->_tmp68_ = _data_->_data8_->part;
#line 413 "../src/data/Runnable.vala"
					_data_->_tmp69_ = game_hub_data_runnable_installer_part_get_checksum (_data_->_tmp68_);
#line 413 "../src/data/Runnable.vala"
					_data_->_tmp70_ = _data_->_tmp69_;
#line 413 "../src/data/Runnable.vala"
					if (_data_->_tmp70_ != NULL) {
#line 415 "../src/data/Runnable.vala"
						_data_->_tmp71_ = _data_->_data8_->file;
#line 415 "../src/data/Runnable.vala"
						_data_->_tmp72_ = g_file_get_path (_data_->_tmp71_);
#line 415 "../src/data/Runnable.vala"
						_data_->_tmp73_ = _data_->_tmp72_;
#line 415 "../src/data/Runnable.vala"
						_data_->_tmp74_ = g_strconcat (_data_->_tmp73_, ".", NULL);
#line 415 "../src/data/Runnable.vala"
						_data_->_tmp75_ = _data_->_tmp74_;
#line 415 "../src/data/Runnable.vala"
						_data_->_tmp76_ = _data_->_data8_->part;
#line 415 "../src/data/Runnable.vala"
						_data_->_tmp77_ = game_hub_data_runnable_installer_part_get_checksum_type_string (_data_->_tmp76_);
#line 415 "../src/data/Runnable.vala"
						_data_->_tmp78_ = _data_->_tmp77_;
#line 415 "../src/data/Runnable.vala"
						_data_->_tmp79_ = g_strconcat (_data_->_tmp75_, _data_->_tmp78_, NULL);
#line 415 "../src/data/Runnable.vala"
						_data_->_tmp80_ = _data_->_tmp79_;
#line 415 "../src/data/Runnable.vala"
						_data_->_tmp81_ = _data_->_data8_->part;
#line 415 "../src/data/Runnable.vala"
						_data_->_tmp82_ = game_hub_data_runnable_installer_part_get_checksum (_data_->_tmp81_);
#line 415 "../src/data/Runnable.vala"
						_data_->_tmp83_ = _data_->_tmp82_;
#line 415 "../src/data/Runnable.vala"
						g_file_set_contents (_data_->_tmp80_, _data_->_tmp83_, (gssize) -1, &_data_->_inner_error0_);
#line 415 "../src/data/Runnable.vala"
						_g_free0 (_data_->_tmp80_);
#line 415 "../src/data/Runnable.vala"
						_g_free0 (_data_->_tmp75_);
#line 415 "../src/data/Runnable.vala"
						_g_free0 (_data_->_tmp73_);
#line 415 "../src/data/Runnable.vala"
						if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 415 "../src/data/Runnable.vala"
							_g_free0 (_data_->file_checksum);
#line 415 "../src/data/Runnable.vala"
							_g_object_unref0 (_data_->info);
#line 415 "../src/data/Runnable.vala"
							_g_free0 (_data_->partDesc);
#line 415 "../src/data/Runnable.vala"
							block8_data_unref (_data_->_data8_);
#line 415 "../src/data/Runnable.vala"
							_data_->_data8_ = NULL;
#line 415 "../src/data/Runnable.vala"
							_g_object_unref0 (_data_->_part_list);
#line 415 "../src/data/Runnable.vala"
							_g_object_unref0 (_data_->files);
#line 415 "../src/data/Runnable.vala"
							_g_object_unref0 (_data_->runnable_install_dir);
#line 415 "../src/data/Runnable.vala"
							_g_object_unref0 (_data_->_tmp6_);
#line 415 "../src/data/Runnable.vala"
							block7_data_unref (_data_->_data7_);
#line 415 "../src/data/Runnable.vala"
							_data_->_data7_ = NULL;
#line 415 "../src/data/Runnable.vala"
							if (g_error_matches (_data_->_inner_error0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 5475 "Runnable.c"
								goto __catch5_g_io_error_cancelled;
							}
							goto __catch5_g_error;
						}
#line 416 "../src/data/Runnable.vala"
						_data_->_tmp84_ = _data_->_data7_->game;
#line 416 "../src/data/Runnable.vala"
						if (_data_->_tmp84_ != NULL) {
#line 416 "../src/data/Runnable.vala"
							_data_->_tmp85_ = _data_->_data7_->game;
#line 416 "../src/data/Runnable.vala"
							_data_->_tmp86_ = _data_->_data7_->game;
#line 416 "../src/data/Runnable.vala"
							_data_->_tmp87_ = game_hub_data_game_status_new (GAME_HUB_DATA_GAME_STATE_VERIFYING_INSTALLER_INTEGRITY, _data_->_tmp86_, NULL);
#line 416 "../src/data/Runnable.vala"
							_data_->_tmp88_ = _data_->_tmp87_;
#line 416 "../src/data/Runnable.vala"
							game_hub_data_game_set_status (_data_->_tmp85_, _data_->_tmp88_);
#line 416 "../src/data/Runnable.vala"
							_game_hub_data_game_status_unref0 (_data_->_tmp88_);
#line 5496 "Runnable.c"
						}
#line 417 "../src/data/Runnable.vala"
						_data_->_tmp89_ = _data_->_data8_->file;
#line 417 "../src/data/Runnable.vala"
						_data_->_tmp90_ = _data_->_data8_->part;
#line 417 "../src/data/Runnable.vala"
						_data_->_tmp91_ = game_hub_data_runnable_installer_part_get_checksum_type (_data_->_tmp90_);
#line 417 "../src/data/Runnable.vala"
						_data_->_tmp92_ = _data_->_tmp91_;
#line 417 "../src/data/Runnable.vala"
						_data_->_state_ = 2;
#line 417 "../src/data/Runnable.vala"
						game_hub_utils_compute_file_checksum (_data_->_tmp89_, _data_->_tmp92_, game_hub_data_runnable_installer_install_ready, _data_);
#line 417 "../src/data/Runnable.vala"
						return FALSE;
#line 5512 "Runnable.c"
						_state_2:
#line 417 "../src/data/Runnable.vala"
						_data_->_tmp93_ = game_hub_utils_compute_file_checksum_finish (_data_->_res_);
#line 417 "../src/data/Runnable.vala"
						_g_free0 (_data_->file_checksum);
#line 417 "../src/data/Runnable.vala"
						_data_->file_checksum = _data_->_tmp93_;
#line 418 "../src/data/Runnable.vala"
						_data_->_tmp94_ = _data_->_data7_->game;
#line 418 "../src/data/Runnable.vala"
						if (_data_->_tmp94_ != NULL) {
#line 418 "../src/data/Runnable.vala"
							_data_->_tmp95_ = _data_->_data7_->game;
#line 418 "../src/data/Runnable.vala"
							_data_->_tmp96_ = _data_->_data7_->game;
#line 418 "../src/data/Runnable.vala"
							_data_->_tmp97_ = game_hub_data_game_status_new (GAME_HUB_DATA_GAME_STATE_DOWNLOADING, _data_->_tmp96_, NULL);
#line 418 "../src/data/Runnable.vala"
							_data_->_tmp98_ = _data_->_tmp97_;
#line 418 "../src/data/Runnable.vala"
							game_hub_data_game_set_status (_data_->_tmp95_, _data_->_tmp98_);
#line 418 "../src/data/Runnable.vala"
							_game_hub_data_game_status_unref0 (_data_->_tmp98_);
#line 5536 "Runnable.c"
						}
					}
#line 421 "../src/data/Runnable.vala"
					_data_->_tmp101_ = _data_->_data8_->part;
#line 421 "../src/data/Runnable.vala"
					_data_->_tmp102_ = game_hub_data_runnable_installer_part_get_checksum (_data_->_tmp101_);
#line 421 "../src/data/Runnable.vala"
					_data_->_tmp103_ = _data_->_tmp102_;
#line 421 "../src/data/Runnable.vala"
					if (_data_->_tmp103_ == NULL) {
#line 421 "../src/data/Runnable.vala"
						_data_->_tmp100_ = TRUE;
#line 5549 "Runnable.c"
					} else {
#line 421 "../src/data/Runnable.vala"
						_data_->_tmp104_ = _data_->file_checksum;
#line 421 "../src/data/Runnable.vala"
						_data_->_tmp100_ = _data_->_tmp104_ == NULL;
#line 5555 "Runnable.c"
					}
#line 421 "../src/data/Runnable.vala"
					if (_data_->_tmp100_) {
#line 421 "../src/data/Runnable.vala"
						_data_->_tmp99_ = TRUE;
#line 5561 "Runnable.c"
					} else {
#line 421 "../src/data/Runnable.vala"
						_data_->_tmp105_ = _data_->_data8_->part;
#line 421 "../src/data/Runnable.vala"
						_data_->_tmp106_ = game_hub_data_runnable_installer_part_get_checksum (_data_->_tmp105_);
#line 421 "../src/data/Runnable.vala"
						_data_->_tmp107_ = _data_->_tmp106_;
#line 421 "../src/data/Runnable.vala"
						_data_->_tmp108_ = _data_->file_checksum;
#line 421 "../src/data/Runnable.vala"
						_data_->_tmp99_ = g_strcmp0 (_data_->_tmp107_, _data_->_tmp108_) == 0;
#line 5573 "Runnable.c"
					}
#line 421 "../src/data/Runnable.vala"
					if (_data_->_tmp99_) {
#line 423 "../src/data/Runnable.vala"
						_data_->_tmp109_ = _data_->files;
#line 423 "../src/data/Runnable.vala"
						_data_->_tmp110_ = _data_->_data8_->file;
#line 423 "../src/data/Runnable.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp109_, _data_->_tmp110_);
#line 5583 "Runnable.c"
					} else {
#line 427 "../src/data/Runnable.vala"
						_data_->_tmp111_ = game_hub_data_runnable_get_name (_data_->_data6_->runnable);
#line 427 "../src/data/Runnable.vala"
						_data_->_tmp112_ = _data_->_tmp111_;
#line 427 "../src/data/Runnable.vala"
						_data_->_tmp113_ = g_strdup_printf (_ ("%s: corrupted installer"), _data_->_tmp112_);
#line 427 "../src/data/Runnable.vala"
						_data_->_tmp114_ = _data_->_tmp113_;
#line 427 "../src/data/Runnable.vala"
						_data_->_tmp115_ = _data_->_data8_->file;
#line 427 "../src/data/Runnable.vala"
						_data_->_tmp116_ = g_file_get_basename (_data_->_tmp115_);
#line 427 "../src/data/Runnable.vala"
						_data_->_tmp117_ = _data_->_tmp116_;
#line 427 "../src/data/Runnable.vala"
						_data_->_tmp118_ = g_strdup_printf (_ ("Checksum mismatch in %s"), _data_->_tmp117_);
#line 427 "../src/data/Runnable.vala"
						_data_->_tmp119_ = _data_->_tmp118_;
#line 427 "../src/data/Runnable.vala"
						game_hub_utils_notify (_data_->_tmp114_, _data_->_tmp119_, G_NOTIFICATION_PRIORITY_HIGH, ________lambda23__game_hub_utils_notification_configure_delegate, _data_->_data8_);
#line 427 "../src/data/Runnable.vala"
						_g_free0 (_data_->_tmp119_);
#line 427 "../src/data/Runnable.vala"
						_g_free0 (_data_->_tmp117_);
#line 427 "../src/data/Runnable.vala"
						_g_free0 (_data_->_tmp114_);
#line 450 "../src/data/Runnable.vala"
						_data_->_tmp120_ = _data_->_data8_->file;
#line 450 "../src/data/Runnable.vala"
						_data_->_tmp121_ = g_file_get_basename (_data_->_tmp120_);
#line 450 "../src/data/Runnable.vala"
						_data_->_tmp122_ = _data_->_tmp121_;
#line 450 "../src/data/Runnable.vala"
						_data_->_tmp123_ = _data_->_data8_->part;
#line 450 "../src/data/Runnable.vala"
						_data_->_tmp124_ = game_hub_data_runnable_installer_part_get_checksum (_data_->_tmp123_);
#line 450 "../src/data/Runnable.vala"
						_data_->_tmp125_ = _data_->_tmp124_;
#line 450 "../src/data/Runnable.vala"
						_data_->_tmp126_ = _data_->file_checksum;
#line 450 "../src/data/Runnable.vala"
						g_warning ("Runnable.vala:450: Checksum mismatch in `%s`, skipping; expected: `%s`" \
", actual: `%s`", _data_->_tmp122_, _data_->_tmp125_, _data_->_tmp126_);
#line 450 "../src/data/Runnable.vala"
						_g_free0 (_data_->_tmp122_);
#line 5629 "Runnable.c"
					}
#line 410 "../src/data/Runnable.vala"
					_g_free0 (_data_->file_checksum);
#line 5633 "Runnable.c"
				}
#line 453 "../src/data/Runnable.vala"
				_data_->_tmp127_ = game_hub_utils_downloader_get_instance ();
#line 453 "../src/data/Runnable.vala"
				_data_->_tmp128_ = _data_->_tmp127_;
#line 453 "../src/data/Runnable.vala"
				g_signal_handler_disconnect ((GObject*) _data_->_tmp128_, _data_->ds_id);
#line 453 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->_tmp128_);
#line 455 "../src/data/Runnable.vala"
				_data_->_tmp129_ = _data_->p;
#line 455 "../src/data/Runnable.vala"
				_data_->p = _data_->_tmp129_ + 1;
#line 388 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->info);
#line 388 "../src/data/Runnable.vala"
				_g_free0 (_data_->partDesc);
#line 388 "../src/data/Runnable.vala"
				block8_data_unref (_data_->_data8_);
#line 388 "../src/data/Runnable.vala"
				_data_->_data8_ = NULL;
#line 5655 "Runnable.c"
			}
#line 388 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->_part_list);
#line 5659 "Runnable.c"
		}
#line 458 "../src/data/Runnable.vala"
		_data_->_tmp130_ = _data_->_data7_->game;
#line 458 "../src/data/Runnable.vala"
		if (_data_->_tmp130_ != NULL) {
#line 458 "../src/data/Runnable.vala"
			_data_->_tmp131_ = _data_->_data7_->game;
#line 458 "../src/data/Runnable.vala"
			_data_->_tmp132_ = _data_->_data7_->game;
#line 458 "../src/data/Runnable.vala"
			_data_->_tmp133_ = game_hub_data_game_status_new (GAME_HUB_DATA_GAME_STATE_UNINSTALLED, _data_->_tmp132_, NULL);
#line 458 "../src/data/Runnable.vala"
			_data_->_tmp134_ = _data_->_tmp133_;
#line 458 "../src/data/Runnable.vala"
			game_hub_data_game_set_status (_data_->_tmp131_, _data_->_tmp134_);
#line 458 "../src/data/Runnable.vala"
			_game_hub_data_game_status_unref0 (_data_->_tmp134_);
#line 5677 "Runnable.c"
		}
#line 459 "../src/data/Runnable.vala"
		game_hub_data_runnable_update_status (_data_->_data6_->runnable);
#line 461 "../src/data/Runnable.vala"
		if (_data_->dl_only) {
#line 461 "../src/data/Runnable.vala"
			_data_->_tmp135_ = TRUE;
#line 5685 "Runnable.c"
		} else {
#line 461 "../src/data/Runnable.vala"
			_data_->_tmp136_ = _data_->files;
#line 461 "../src/data/Runnable.vala"
			_data_->_tmp137_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp136_);
#line 461 "../src/data/Runnable.vala"
			_data_->_tmp138_ = _data_->_tmp137_;
#line 461 "../src/data/Runnable.vala"
			_data_->_tmp135_ = _data_->_tmp138_ == 0;
#line 5695 "Runnable.c"
		}
#line 461 "../src/data/Runnable.vala"
		if (_data_->_tmp135_) {
#line 461 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->files);
#line 461 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->runnable_install_dir);
#line 461 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->_tmp6_);
#line 461 "../src/data/Runnable.vala"
			block7_data_unref (_data_->_data7_);
#line 461 "../src/data/Runnable.vala"
			_data_->_data7_ = NULL;
#line 461 "../src/data/Runnable.vala"
			block6_data_unref (_data_->_data6_);
#line 461 "../src/data/Runnable.vala"
			_data_->_data6_ = NULL;
#line 461 "../src/data/Runnable.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 461 "../src/data/Runnable.vala"
			if (_data_->_state_ != 0) {
#line 461 "../src/data/Runnable.vala"
				while (!_data_->_task_complete_) {
#line 461 "../src/data/Runnable.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5721 "Runnable.c"
				}
			}
#line 461 "../src/data/Runnable.vala"
			g_object_unref (_data_->_async_result);
#line 461 "../src/data/Runnable.vala"
			return FALSE;
#line 5728 "Runnable.c"
		}
#line 463 "../src/data/Runnable.vala"
		_data_->f = (guint) 0;
#line 464 "../src/data/Runnable.vala"
		_data_->windows_installer = FALSE;
#line 465 "../src/data/Runnable.vala"
		_data_->nsis_installer = FALSE;
#line 5736 "Runnable.c"
		{
#line 466 "../src/data/Runnable.vala"
			_data_->_tmp139_ = _data_->files;
#line 466 "../src/data/Runnable.vala"
			_data_->_tmp140_ = _g_object_ref0 (_data_->_tmp139_);
#line 466 "../src/data/Runnable.vala"
			_data_->_file_list = _data_->_tmp140_;
#line 466 "../src/data/Runnable.vala"
			_data_->_tmp141_ = _data_->_file_list;
#line 466 "../src/data/Runnable.vala"
			_data_->_tmp142_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp141_);
#line 466 "../src/data/Runnable.vala"
			_data_->_tmp143_ = _data_->_tmp142_;
#line 466 "../src/data/Runnable.vala"
			_data_->_file_size = _data_->_tmp143_;
#line 466 "../src/data/Runnable.vala"
			_data_->_file_index = -1;
#line 466 "../src/data/Runnable.vala"
			while (TRUE) {
#line 466 "../src/data/Runnable.vala"
				_data_->_file_index = _data_->_file_index + 1;
#line 466 "../src/data/Runnable.vala"
				if (!(_data_->_file_index < _data_->_file_size)) {
#line 466 "../src/data/Runnable.vala"
					break;
#line 5762 "Runnable.c"
				}
#line 466 "../src/data/Runnable.vala"
				_data_->_tmp144_ = _data_->_file_list;
#line 466 "../src/data/Runnable.vala"
				_data_->_tmp145_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp144_, _data_->_file_index);
#line 466 "../src/data/Runnable.vala"
				_data_->file = (GFile*) _data_->_tmp145_;
#line 468 "../src/data/Runnable.vala"
				_data_->_tmp146_ = _data_->file;
#line 468 "../src/data/Runnable.vala"
				_data_->_tmp147_ = g_file_get_path (_data_->_tmp146_);
#line 468 "../src/data/Runnable.vala"
				_data_->path = _data_->_tmp147_;
#line 469 "../src/data/Runnable.vala"
				_data_->_tmp148_ = g_strdup ("chmod");
#line 469 "../src/data/Runnable.vala"
				_data_->_tmp149_ = g_strdup ("+x");
#line 469 "../src/data/Runnable.vala"
				_data_->_tmp150_ = _data_->path;
#line 469 "../src/data/Runnable.vala"
				_data_->_tmp151_ = g_strdup (_data_->_tmp150_);
#line 469 "../src/data/Runnable.vala"
				_data_->_tmp152_ = g_new0 (gchar*, 3 + 1);
#line 469 "../src/data/Runnable.vala"
				_data_->_tmp152_[0] = _data_->_tmp148_;
#line 469 "../src/data/Runnable.vala"
				_data_->_tmp152_[1] = _data_->_tmp149_;
#line 469 "../src/data/Runnable.vala"
				_data_->_tmp152_[2] = _data_->_tmp151_;
#line 469 "../src/data/Runnable.vala"
				_data_->_tmp153_ = _data_->_tmp152_;
#line 469 "../src/data/Runnable.vala"
				_data_->_tmp153__length1 = 3;
#line 469 "../src/data/Runnable.vala"
				_data_->_tmp154_ = game_hub_utils_run (_data_->_tmp153_, (gint) 3, NULL, NULL, (gint) 0, FALSE, FALSE, TRUE);
#line 469 "../src/data/Runnable.vala"
				_data_->_tmp155_ = _data_->_tmp154_;
#line 469 "../src/data/Runnable.vala"
				_g_free0 (_data_->_tmp155_);
#line 469 "../src/data/Runnable.vala"
				_data_->_tmp153_ = (_vala_array_free (_data_->_tmp153_, _data_->_tmp153__length1, (GDestroyNotify) g_free), NULL);
#line 471 "../src/data/Runnable.vala"
				_data_->_tmp156_ = game_hub_data_runnable_get_install_dir (_data_->_data6_->runnable);
#line 471 "../src/data/Runnable.vala"
				_data_->_tmp157_ = _data_->_tmp156_;
#line 471 "../src/data/Runnable.vala"
				_data_->_tmp158_ = g_file_get_path (_data_->_tmp157_);
#line 471 "../src/data/Runnable.vala"
				_data_->_tmp159_ = _data_->_tmp158_;
#line 471 "../src/data/Runnable.vala"
				_data_->_tmp160_ = game_hub_utils_fs_utils_mkdir (_data_->_tmp159_, NULL, NULL);
#line 471 "../src/data/Runnable.vala"
				_data_->_tmp161_ = _data_->_tmp160_;
#line 471 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->_tmp161_);
#line 471 "../src/data/Runnable.vala"
				_g_free0 (_data_->_tmp159_);
#line 473 "../src/data/Runnable.vala"
				_data_->_tmp162_ = _data_->file;
#line 473 "../src/data/Runnable.vala"
				_data_->_state_ = 3;
#line 473 "../src/data/Runnable.vala"
				game_hub_data_runnable_installer_guess_type (_data_->_tmp162_, _data_->f > ((guint) 0), game_hub_data_runnable_installer_install_ready, _data_);
#line 473 "../src/data/Runnable.vala"
				return FALSE;
#line 5828 "Runnable.c"
				_state_3:
#line 473 "../src/data/Runnable.vala"
				_data_->type = game_hub_data_runnable_installer_guess_type_finish (_data_->_res_);
#line 475 "../src/data/Runnable.vala"
				_data_->_tmp164_ = _data_->type;
#line 475 "../src/data/Runnable.vala"
				if (_data_->_tmp164_ == GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_EXECUTABLE) {
#line 475 "../src/data/Runnable.vala"
					_data_->_tmp163_ = GAME_HUB_DATA_COMPAT_IS_INNOEXTRACT (_data_->tool);
#line 5838 "Runnable.c"
				} else {
#line 475 "../src/data/Runnable.vala"
					_data_->_tmp163_ = FALSE;
#line 5842 "Runnable.c"
				}
#line 475 "../src/data/Runnable.vala"
				if (_data_->_tmp163_) {
#line 477 "../src/data/Runnable.vala"
					_data_->_tmp165_ = g_strdup ("file");
#line 477 "../src/data/Runnable.vala"
					_data_->_tmp166_ = g_strdup ("-b");
#line 477 "../src/data/Runnable.vala"
					_data_->_tmp167_ = _data_->path;
#line 477 "../src/data/Runnable.vala"
					_data_->_tmp168_ = g_strdup (_data_->_tmp167_);
#line 477 "../src/data/Runnable.vala"
					_data_->_tmp169_ = g_new0 (gchar*, 3 + 1);
#line 477 "../src/data/Runnable.vala"
					_data_->_tmp169_[0] = _data_->_tmp165_;
#line 477 "../src/data/Runnable.vala"
					_data_->_tmp169_[1] = _data_->_tmp166_;
#line 477 "../src/data/Runnable.vala"
					_data_->_tmp169_[2] = _data_->_tmp168_;
#line 477 "../src/data/Runnable.vala"
					_data_->_tmp170_ = _data_->_tmp169_;
#line 477 "../src/data/Runnable.vala"
					_data_->_tmp170__length1 = 3;
#line 477 "../src/data/Runnable.vala"
					_data_->_state_ = 4;
#line 477 "../src/data/Runnable.vala"
					game_hub_utils_run_thread (_data_->_tmp170_, (gint) 3, NULL, NULL, (gint) 0, FALSE, FALSE, TRUE, game_hub_data_runnable_installer_install_ready, _data_);
#line 477 "../src/data/Runnable.vala"
					return FALSE;
#line 5872 "Runnable.c"
					_state_4:
#line 477 "../src/data/Runnable.vala"
					_data_->_tmp171_ = game_hub_utils_run_thread_finish (_data_->_res_);
#line 477 "../src/data/Runnable.vala"
					_data_->_tmp172_ = _data_->_tmp171_;
#line 477 "../src/data/Runnable.vala"
					_data_->_tmp170_ = (_vala_array_free (_data_->_tmp170_, _data_->_tmp170__length1, (GDestroyNotify) g_free), NULL);
#line 477 "../src/data/Runnable.vala"
					_data_->desc = _data_->_tmp172_;
#line 478 "../src/data/Runnable.vala"
					_data_->_tmp175_ = _data_->desc;
#line 478 "../src/data/Runnable.vala"
					if (_data_->_tmp175_ != NULL) {
#line 478 "../src/data/Runnable.vala"
						_data_->_tmp176_ = _data_->desc;
#line 478 "../src/data/Runnable.vala"
						_data_->_tmp177_ = strlen (_data_->_tmp176_);
#line 478 "../src/data/Runnable.vala"
						_data_->_tmp178_ = _data_->_tmp177_;
#line 478 "../src/data/Runnable.vala"
						_data_->_tmp174_ = _data_->_tmp178_ > 0;
#line 5894 "Runnable.c"
					} else {
#line 478 "../src/data/Runnable.vala"
						_data_->_tmp174_ = FALSE;
#line 5898 "Runnable.c"
					}
#line 478 "../src/data/Runnable.vala"
					if (_data_->_tmp174_) {
#line 478 "../src/data/Runnable.vala"
						_data_->_tmp179_ = _data_->desc;
#line 478 "../src/data/Runnable.vala"
						_data_->_tmp180_ = game_hub_data_runnable_installer_NSIS_INSTALLER_DESCRIPTION;
#line 478 "../src/data/Runnable.vala"
						_data_->_tmp173_ = string_contains (_data_->_tmp179_, _data_->_tmp180_);
#line 5908 "Runnable.c"
					} else {
#line 478 "../src/data/Runnable.vala"
						_data_->_tmp173_ = FALSE;
#line 5912 "Runnable.c"
					}
#line 478 "../src/data/Runnable.vala"
					if (_data_->_tmp173_) {
#line 480 "../src/data/Runnable.vala"
						_data_->type = GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_NSIS_INSTALLER;
#line 5918 "Runnable.c"
					}
#line 475 "../src/data/Runnable.vala"
					_g_free0 (_data_->desc);
#line 5922 "Runnable.c"
				}
#line 484 "../src/data/Runnable.vala"
				_data_->cmd = NULL;
#line 484 "../src/data/Runnable.vala"
				_data_->cmd_length1 = 0;
#line 484 "../src/data/Runnable.vala"
				_data_->_cmd_size_ = _data_->cmd_length1;
#line 486 "../src/data/Runnable.vala"
				_data_->_tmp181_ = _data_->type;
#line 486 "../src/data/Runnable.vala"
				switch (_data_->_tmp181_) {
#line 486 "../src/data/Runnable.vala"
					case GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_EXECUTABLE:
#line 5936 "Runnable.c"
					{
#line 489 "../src/data/Runnable.vala"
						_data_->_tmp182_ = _data_->path;
#line 489 "../src/data/Runnable.vala"
						_data_->_tmp183_ = g_strdup (_data_->_tmp182_);
#line 489 "../src/data/Runnable.vala"
						_data_->_tmp184_ = g_strdup ("--");
#line 489 "../src/data/Runnable.vala"
						_data_->_tmp185_ = g_strdup ("--i-agree-to-all-licenses");
#line 489 "../src/data/Runnable.vala"
						_data_->_tmp186_ = g_strdup ("--noreadme");
#line 489 "../src/data/Runnable.vala"
						_data_->_tmp187_ = g_strdup ("--nooptions");
#line 489 "../src/data/Runnable.vala"
						_data_->_tmp188_ = g_strdup ("--noprompt");
#line 489 "../src/data/Runnable.vala"
						_data_->_tmp189_ = g_strdup ("--destination");
#line 489 "../src/data/Runnable.vala"
						_data_->_tmp190_ = game_hub_data_runnable_get_install_dir (_data_->_data6_->runnable);
#line 489 "../src/data/Runnable.vala"
						_data_->_tmp191_ = _data_->_tmp190_;
#line 489 "../src/data/Runnable.vala"
						_data_->_tmp192_ = g_file_get_path (_data_->_tmp191_);
#line 489 "../src/data/Runnable.vala"
						_data_->_tmp193_ = _data_->_tmp192_;
#line 489 "../src/data/Runnable.vala"
						_data_->_tmp194_ = string_replace (_data_->_tmp193_, "'", "\\'");
#line 489 "../src/data/Runnable.vala"
						_data_->_tmp195_ = g_new0 (gchar*, 8 + 1);
#line 489 "../src/data/Runnable.vala"
						_data_->_tmp195_[0] = _data_->_tmp183_;
#line 489 "../src/data/Runnable.vala"
						_data_->_tmp195_[1] = _data_->_tmp184_;
#line 489 "../src/data/Runnable.vala"
						_data_->_tmp195_[2] = _data_->_tmp185_;
#line 489 "../src/data/Runnable.vala"
						_data_->_tmp195_[3] = _data_->_tmp186_;
#line 489 "../src/data/Runnable.vala"
						_data_->_tmp195_[4] = _data_->_tmp187_;
#line 489 "../src/data/Runnable.vala"
						_data_->_tmp195_[5] = _data_->_tmp188_;
#line 489 "../src/data/Runnable.vala"
						_data_->_tmp195_[6] = _data_->_tmp189_;
#line 489 "../src/data/Runnable.vala"
						_data_->_tmp195_[7] = _data_->_tmp194_;
#line 489 "../src/data/Runnable.vala"
						_data_->cmd = (_vala_array_free (_data_->cmd, _data_->cmd_length1, (GDestroyNotify) g_free), NULL);
#line 489 "../src/data/Runnable.vala"
						_data_->cmd = _data_->_tmp195_;
#line 489 "../src/data/Runnable.vala"
						_data_->cmd_length1 = 8;
#line 489 "../src/data/Runnable.vala"
						_data_->_cmd_size_ = _data_->cmd_length1;
#line 489 "../src/data/Runnable.vala"
						_g_free0 (_data_->_tmp193_);
#line 492 "../src/data/Runnable.vala"
						break;
#line 5994 "Runnable.c"
					}
#line 486 "../src/data/Runnable.vala"
					case GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_ARCHIVE:
#line 486 "../src/data/Runnable.vala"
					case GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_NSIS_INSTALLER:
#line 6000 "Runnable.c"
					{
#line 496 "../src/data/Runnable.vala"
						_data_->_tmp196_ = g_strdup ("file-roller");
#line 496 "../src/data/Runnable.vala"
						_data_->_tmp197_ = _data_->path;
#line 496 "../src/data/Runnable.vala"
						_data_->_tmp198_ = g_strdup (_data_->_tmp197_);
#line 496 "../src/data/Runnable.vala"
						_data_->_tmp199_ = g_strdup ("-e");
#line 496 "../src/data/Runnable.vala"
						_data_->_tmp200_ = game_hub_data_runnable_get_install_dir (_data_->_data6_->runnable);
#line 496 "../src/data/Runnable.vala"
						_data_->_tmp201_ = _data_->_tmp200_;
#line 496 "../src/data/Runnable.vala"
						_data_->_tmp202_ = g_file_get_path (_data_->_tmp201_);
#line 496 "../src/data/Runnable.vala"
						_data_->_tmp203_ = g_new0 (gchar*, 4 + 1);
#line 496 "../src/data/Runnable.vala"
						_data_->_tmp203_[0] = _data_->_tmp196_;
#line 496 "../src/data/Runnable.vala"
						_data_->_tmp203_[1] = _data_->_tmp198_;
#line 496 "../src/data/Runnable.vala"
						_data_->_tmp203_[2] = _data_->_tmp199_;
#line 496 "../src/data/Runnable.vala"
						_data_->_tmp203_[3] = _data_->_tmp202_;
#line 496 "../src/data/Runnable.vala"
						_data_->cmd = (_vala_array_free (_data_->cmd, _data_->cmd_length1, (GDestroyNotify) g_free), NULL);
#line 496 "../src/data/Runnable.vala"
						_data_->cmd = _data_->_tmp203_;
#line 496 "../src/data/Runnable.vala"
						_data_->cmd_length1 = 4;
#line 496 "../src/data/Runnable.vala"
						_data_->_cmd_size_ = _data_->cmd_length1;
#line 497 "../src/data/Runnable.vala"
						break;
#line 6036 "Runnable.c"
					}
#line 486 "../src/data/Runnable.vala"
					case GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_EXECUTABLE:
#line 486 "../src/data/Runnable.vala"
					case GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_GOG_PART:
#line 6042 "Runnable.c"
					{
#line 501 "../src/data/Runnable.vala"
						_data_->cmd = (_vala_array_free (_data_->cmd, _data_->cmd_length1, (GDestroyNotify) g_free), NULL);
#line 501 "../src/data/Runnable.vala"
						_data_->cmd = NULL;
#line 501 "../src/data/Runnable.vala"
						_data_->cmd_length1 = 0;
#line 501 "../src/data/Runnable.vala"
						_data_->_cmd_size_ = _data_->cmd_length1;
#line 502 "../src/data/Runnable.vala"
						break;
#line 6054 "Runnable.c"
					}
					default:
					{
#line 505 "../src/data/Runnable.vala"
						_data_->_tmp204_ = g_strdup ("xdg-open");
#line 505 "../src/data/Runnable.vala"
						_data_->_tmp205_ = _data_->path;
#line 505 "../src/data/Runnable.vala"
						_data_->_tmp206_ = g_strdup (_data_->_tmp205_);
#line 505 "../src/data/Runnable.vala"
						_data_->_tmp207_ = g_new0 (gchar*, 2 + 1);
#line 505 "../src/data/Runnable.vala"
						_data_->_tmp207_[0] = _data_->_tmp204_;
#line 505 "../src/data/Runnable.vala"
						_data_->_tmp207_[1] = _data_->_tmp206_;
#line 505 "../src/data/Runnable.vala"
						_data_->cmd = (_vala_array_free (_data_->cmd, _data_->cmd_length1, (GDestroyNotify) g_free), NULL);
#line 505 "../src/data/Runnable.vala"
						_data_->cmd = _data_->_tmp207_;
#line 505 "../src/data/Runnable.vala"
						_data_->cmd_length1 = 2;
#line 505 "../src/data/Runnable.vala"
						_data_->_cmd_size_ = _data_->cmd_length1;
#line 506 "../src/data/Runnable.vala"
						break;
#line 6080 "Runnable.c"
					}
				}
#line 509 "../src/data/Runnable.vala"
				_data_->_tmp208_ = _data_->_data7_->game;
#line 509 "../src/data/Runnable.vala"
				if (_data_->_tmp208_ != NULL) {
#line 509 "../src/data/Runnable.vala"
					_data_->_tmp209_ = _data_->_data7_->game;
#line 509 "../src/data/Runnable.vala"
					_data_->_tmp210_ = _data_->_data7_->game;
#line 509 "../src/data/Runnable.vala"
					_data_->_tmp211_ = game_hub_data_game_status_new (GAME_HUB_DATA_GAME_STATE_INSTALLING, _data_->_tmp210_, NULL);
#line 509 "../src/data/Runnable.vala"
					_data_->_tmp212_ = _data_->_tmp211_;
#line 509 "../src/data/Runnable.vala"
					game_hub_data_game_set_status (_data_->_tmp209_, _data_->_tmp212_);
#line 509 "../src/data/Runnable.vala"
					_game_hub_data_game_status_unref0 (_data_->_tmp212_);
#line 6099 "Runnable.c"
				}
#line 511 "../src/data/Runnable.vala"
				_data_->_tmp213_ = _data_->cmd;
#line 511 "../src/data/Runnable.vala"
				_data_->_tmp213__length1 = _data_->cmd_length1;
#line 511 "../src/data/Runnable.vala"
				if (_data_->_tmp213_ != NULL) {
#line 513 "../src/data/Runnable.vala"
					_data_->_tmp214_ = _data_->cmd;
#line 513 "../src/data/Runnable.vala"
					_data_->_tmp214__length1 = _data_->cmd_length1;
#line 513 "../src/data/Runnable.vala"
					_data_->_state_ = 5;
#line 513 "../src/data/Runnable.vala"
					game_hub_utils_run_async (_data_->_tmp214_, (gint) _data_->_tmp214__length1, NULL, NULL, (gint) 0, FALSE, TRUE, TRUE, game_hub_data_runnable_installer_install_ready, _data_);
#line 513 "../src/data/Runnable.vala"
					return FALSE;
#line 6117 "Runnable.c"
					_state_5:
#line 513 "../src/data/Runnable.vala"
					game_hub_utils_run_finish (_data_->_res_);
#line 6121 "Runnable.c"
				}
#line 515 "../src/data/Runnable.vala"
				_data_->_tmp215_ = _data_->type;
#line 515 "../src/data/Runnable.vala"
				if (_data_->_tmp215_ == GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_EXECUTABLE) {
#line 517 "../src/data/Runnable.vala"
					_data_->windows_installer = TRUE;
#line 518 "../src/data/Runnable.vala"
					if (_data_->tool != NULL) {
#line 518 "../src/data/Runnable.vala"
						_data_->_tmp216_ = game_hub_data_compat_tool_can_install (_data_->tool, _data_->_data6_->runnable);
#line 6133 "Runnable.c"
					} else {
#line 518 "../src/data/Runnable.vala"
						_data_->_tmp216_ = FALSE;
#line 6137 "Runnable.c"
					}
#line 518 "../src/data/Runnable.vala"
					if (_data_->_tmp216_) {
#line 520 "../src/data/Runnable.vala"
						_data_->_tmp217_ = _data_->file;
#line 520 "../src/data/Runnable.vala"
						_data_->_state_ = 6;
#line 520 "../src/data/Runnable.vala"
						game_hub_data_compat_tool_install (_data_->tool, _data_->_data6_->runnable, _data_->_tmp217_, game_hub_data_runnable_installer_install_ready, _data_);
#line 520 "../src/data/Runnable.vala"
						return FALSE;
#line 6149 "Runnable.c"
						_state_6:
#line 520 "../src/data/Runnable.vala"
						game_hub_data_compat_tool_install_finish (_data_->tool, _data_->_res_);
#line 6153 "Runnable.c"
					}
				} else {
#line 523 "../src/data/Runnable.vala"
					_data_->_tmp218_ = _data_->type;
#line 523 "../src/data/Runnable.vala"
					if (_data_->_tmp218_ == GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_WINDOWS_NSIS_INSTALLER) {
#line 525 "../src/data/Runnable.vala"
						_data_->nsis_installer = TRUE;
#line 6162 "Runnable.c"
					}
				}
#line 527 "../src/data/Runnable.vala"
				_data_->_tmp219_ = _data_->f;
#line 527 "../src/data/Runnable.vala"
				_data_->f = _data_->_tmp219_ + 1;
#line 466 "../src/data/Runnable.vala"
				_data_->cmd = (_vala_array_free (_data_->cmd, _data_->cmd_length1, (GDestroyNotify) g_free), NULL);
#line 466 "../src/data/Runnable.vala"
				_g_free0 (_data_->path);
#line 466 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->file);
#line 6175 "Runnable.c"
			}
#line 466 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->_file_list);
#line 6179 "Runnable.c"
		}
		{
#line 532 "../src/data/Runnable.vala"
			if (_data_->nsis_installer) {
#line 534 "../src/data/Runnable.vala"
				_data_->_tmp220_ = game_hub_data_runnable_get_install_dir (_data_->_data6_->runnable);
#line 534 "../src/data/Runnable.vala"
				_data_->_tmp221_ = _data_->_tmp220_;
#line 534 "../src/data/Runnable.vala"
				_data_->_tmp222_ = g_file_get_path (_data_->_tmp221_);
#line 534 "../src/data/Runnable.vala"
				_data_->_tmp223_ = _data_->_tmp222_;
#line 534 "../src/data/Runnable.vala"
				game_hub_utils_fs_utils_rm (_data_->_tmp223_, "\\$*DIR", "-rf", NULL);
#line 534 "../src/data/Runnable.vala"
				_g_free0 (_data_->_tmp223_);
#line 6196 "Runnable.c"
			}
#line 537 "../src/data/Runnable.vala"
			_data_->dircount = 0;
#line 538 "../src/data/Runnable.vala"
			_data_->dirname = NULL;
#line 539 "../src/data/Runnable.vala"
			_data_->finfo = NULL;
#line 540 "../src/data/Runnable.vala"
			_data_->_tmp224_ = game_hub_data_runnable_get_install_dir (_data_->_data6_->runnable);
#line 540 "../src/data/Runnable.vala"
			_data_->_tmp225_ = _data_->_tmp224_;
#line 540 "../src/data/Runnable.vala"
			_data_->_state_ = 7;
#line 540 "../src/data/Runnable.vala"
			g_file_enumerate_children_async (_data_->_tmp225_, "standard::*", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, G_PRIORITY_DEFAULT, NULL, game_hub_data_runnable_installer_install_ready, _data_);
#line 540 "../src/data/Runnable.vala"
			return FALSE;
#line 6214 "Runnable.c"
			_state_7:
#line 540 "../src/data/Runnable.vala"
			_data_->_tmp226_ = g_file_enumerate_children_finish (_data_->_tmp225_, _data_->_res_, &_data_->_inner_error0_);
#line 540 "../src/data/Runnable.vala"
			_data_->enumerator = _data_->_tmp226_;
#line 540 "../src/data/Runnable.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 540 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->finfo);
#line 540 "../src/data/Runnable.vala"
				_g_free0 (_data_->dirname);
#line 6226 "Runnable.c"
				goto __catch6_g_error;
			}
#line 541 "../src/data/Runnable.vala"
			while (TRUE) {
#line 541 "../src/data/Runnable.vala"
				_data_->_tmp228_ = _data_->enumerator;
#line 541 "../src/data/Runnable.vala"
				_data_->_tmp229_ = g_file_enumerator_next_file (_data_->_tmp228_, NULL, &_data_->_inner_error0_);
#line 541 "../src/data/Runnable.vala"
				_data_->_tmp227_ = _data_->_tmp229_;
#line 541 "../src/data/Runnable.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 541 "../src/data/Runnable.vala"
					_g_object_unref0 (_data_->enumerator);
#line 541 "../src/data/Runnable.vala"
					_g_object_unref0 (_data_->finfo);
#line 541 "../src/data/Runnable.vala"
					_g_free0 (_data_->dirname);
#line 6245 "Runnable.c"
					goto __catch6_g_error;
				}
#line 541 "../src/data/Runnable.vala"
				_data_->_tmp230_ = _data_->_tmp227_;
#line 541 "../src/data/Runnable.vala"
				_data_->_tmp227_ = NULL;
#line 541 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->finfo);
#line 541 "../src/data/Runnable.vala"
				_data_->finfo = _data_->_tmp230_;
#line 541 "../src/data/Runnable.vala"
				_data_->_tmp231_ = _data_->finfo;
#line 541 "../src/data/Runnable.vala"
				if (!(_data_->_tmp231_ != NULL)) {
#line 541 "../src/data/Runnable.vala"
					_g_object_unref0 (_data_->_tmp227_);
#line 541 "../src/data/Runnable.vala"
					break;
#line 6264 "Runnable.c"
				}
#line 543 "../src/data/Runnable.vala"
				_data_->_tmp233_ = _data_->finfo;
#line 543 "../src/data/Runnable.vala"
				if (g_file_info_get_file_type (_data_->_tmp233_) == G_FILE_TYPE_DIRECTORY) {
#line 543 "../src/data/Runnable.vala"
					_data_->_tmp234_ = _data_->finfo;
#line 543 "../src/data/Runnable.vala"
					_data_->_tmp235_ = g_file_info_get_name (_data_->_tmp234_);
#line 543 "../src/data/Runnable.vala"
					_data_->_tmp232_ = g_strcmp0 (_data_->_tmp235_, GAME_HUB_UTILS_FS_UTILS_GAMEHUB_DIR) != 0;
#line 6276 "Runnable.c"
				} else {
#line 543 "../src/data/Runnable.vala"
					_data_->_tmp232_ = FALSE;
#line 6280 "Runnable.c"
				}
#line 543 "../src/data/Runnable.vala"
				if (_data_->_tmp232_) {
#line 545 "../src/data/Runnable.vala"
					_data_->_tmp236_ = _data_->dircount;
#line 545 "../src/data/Runnable.vala"
					_data_->dircount = _data_->_tmp236_ + 1;
#line 546 "../src/data/Runnable.vala"
					_data_->_tmp239_ = _data_->dirname;
#line 546 "../src/data/Runnable.vala"
					if (_data_->_tmp239_ == NULL) {
#line 546 "../src/data/Runnable.vala"
						_data_->_tmp238_ = _data_->dircount == 1;
#line 6294 "Runnable.c"
					} else {
#line 546 "../src/data/Runnable.vala"
						_data_->_tmp238_ = FALSE;
#line 6298 "Runnable.c"
					}
#line 546 "../src/data/Runnable.vala"
					if (_data_->_tmp238_) {
#line 546 "../src/data/Runnable.vala"
						_data_->_tmp240_ = _data_->finfo;
#line 546 "../src/data/Runnable.vala"
						_data_->_tmp241_ = g_file_info_get_name (_data_->_tmp240_);
#line 546 "../src/data/Runnable.vala"
						_data_->_tmp237_ = _data_->_tmp241_;
#line 6308 "Runnable.c"
					} else {
#line 546 "../src/data/Runnable.vala"
						_data_->_tmp237_ = NULL;
#line 6312 "Runnable.c"
					}
#line 546 "../src/data/Runnable.vala"
					_data_->_tmp242_ = g_strdup (_data_->_tmp237_);
#line 546 "../src/data/Runnable.vala"
					_g_free0 (_data_->dirname);
#line 546 "../src/data/Runnable.vala"
					_data_->dirname = _data_->_tmp242_;
#line 6320 "Runnable.c"
				} else {
#line 548 "../src/data/Runnable.vala"
					_data_->_tmp243_ = _data_->finfo;
#line 548 "../src/data/Runnable.vala"
					if (g_file_info_get_file_type (_data_->_tmp243_) != G_FILE_TYPE_DIRECTORY) {
#line 550 "../src/data/Runnable.vala"
						_g_free0 (_data_->dirname);
#line 550 "../src/data/Runnable.vala"
						_data_->dirname = NULL;
#line 551 "../src/data/Runnable.vala"
						_g_object_unref0 (_data_->_tmp227_);
#line 551 "../src/data/Runnable.vala"
						break;
#line 6334 "Runnable.c"
					}
				}
#line 541 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->_tmp227_);
#line 6339 "Runnable.c"
			}
#line 555 "../src/data/Runnable.vala"
			_data_->_tmp245_ = _data_->dirname;
#line 555 "../src/data/Runnable.vala"
			if (_data_->_tmp245_ != NULL) {
#line 555 "../src/data/Runnable.vala"
				_data_->_tmp244_ = !GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_DLC (_data_->_data6_->runnable);
#line 6347 "Runnable.c"
			} else {
#line 555 "../src/data/Runnable.vala"
				_data_->_tmp244_ = FALSE;
#line 6351 "Runnable.c"
			}
#line 555 "../src/data/Runnable.vala"
			if (_data_->_tmp244_) {
#line 557 "../src/data/Runnable.vala"
				_data_->_tmp246_ = game_hub_data_runnable_get_install_dir (_data_->_data6_->runnable);
#line 557 "../src/data/Runnable.vala"
				_data_->_tmp247_ = _data_->_tmp246_;
#line 557 "../src/data/Runnable.vala"
				_data_->_tmp248_ = _data_->dirname;
#line 557 "../src/data/Runnable.vala"
				_data_->_tmp249_ = string_replace (_data_->_tmp248_, " ", "\\ ");
#line 557 "../src/data/Runnable.vala"
				_data_->_tmp250_ = _data_->_tmp249_;
#line 557 "../src/data/Runnable.vala"
				game_hub_utils_fs_utils_mv_up (_data_->_tmp247_, _data_->_tmp250_);
#line 557 "../src/data/Runnable.vala"
				_g_free0 (_data_->_tmp250_);
#line 6369 "Runnable.c"
			}
#line 560 "../src/data/Runnable.vala"
			if (_data_->windows_installer) {
#line 560 "../src/data/Runnable.vala"
				_data_->_tmp251_ = TRUE;
#line 6375 "Runnable.c"
			} else {
#line 560 "../src/data/Runnable.vala"
				_data_->_tmp252_ = _data_->self->priv->_platform;
#line 560 "../src/data/Runnable.vala"
				_data_->_tmp251_ = _data_->_tmp252_ == GAME_HUB_DATA_PLATFORM_WINDOWS;
#line 6381 "Runnable.c"
			}
#line 560 "../src/data/Runnable.vala"
			if (_data_->_tmp251_) {
#line 562 "../src/data/Runnable.vala"
				game_hub_data_runnable_set_force_compat (_data_->_data6_->runnable, TRUE);
#line 6387 "Runnable.c"
			}
#line 530 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->enumerator);
#line 530 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->finfo);
#line 530 "../src/data/Runnable.vala"
			_g_free0 (_data_->dirname);
#line 6395 "Runnable.c"
		}
		goto __finally6;
		__catch6_g_error:
		{
#line 530 "../src/data/Runnable.vala"
			_data_->e = _data_->_inner_error0_;
#line 530 "../src/data/Runnable.vala"
			_data_->_inner_error0_ = NULL;
#line 530 "../src/data/Runnable.vala"
			_g_error_free0 (_data_->e);
#line 6406 "Runnable.c"
		}
		__finally6:
#line 530 "../src/data/Runnable.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 530 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->files);
#line 530 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->runnable_install_dir);
#line 530 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->_tmp6_);
#line 530 "../src/data/Runnable.vala"
			block7_data_unref (_data_->_data7_);
#line 530 "../src/data/Runnable.vala"
			_data_->_data7_ = NULL;
#line 530 "../src/data/Runnable.vala"
			if (g_error_matches (_data_->_inner_error0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 6423 "Runnable.c"
				goto __catch5_g_io_error_cancelled;
			}
			goto __catch5_g_error;
		}
#line 567 "../src/data/Runnable.vala"
		game_hub_data_runnable_update_status (_data_->_data6_->runnable);
#line 569 "../src/data/Runnable.vala"
		if (GAME_HUB_DATA_SOURCES_GOG_IS_GOG_GAME (_data_->_data6_->runnable)) {
#line 569 "../src/data/Runnable.vala"
			_data_->_tmp254_ = !GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_DLC (_data_->_data6_->runnable);
#line 6434 "Runnable.c"
		} else {
#line 569 "../src/data/Runnable.vala"
			_data_->_tmp254_ = FALSE;
#line 6438 "Runnable.c"
		}
#line 569 "../src/data/Runnable.vala"
		if (_data_->_tmp254_) {
#line 569 "../src/data/Runnable.vala"
			_data_->_tmp256_ = game_hub_data_runnable_get_executable (_data_->_data6_->runnable);
#line 569 "../src/data/Runnable.vala"
			_data_->_tmp257_ = _data_->_tmp256_;
#line 569 "../src/data/Runnable.vala"
			_data_->_tmp258_ = _data_->_tmp257_;
#line 569 "../src/data/Runnable.vala"
			_data_->_tmp259_ = _data_->_tmp258_ == NULL;
#line 569 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->_tmp258_);
#line 569 "../src/data/Runnable.vala"
			if (_data_->_tmp259_) {
#line 569 "../src/data/Runnable.vala"
				_data_->_tmp255_ = TRUE;
#line 6456 "Runnable.c"
			} else {
#line 569 "../src/data/Runnable.vala"
				_data_->_tmp260_ = game_hub_data_runnable_get_executable (_data_->_data6_->runnable);
#line 569 "../src/data/Runnable.vala"
				_data_->_tmp261_ = _data_->_tmp260_;
#line 569 "../src/data/Runnable.vala"
				_data_->_tmp262_ = _data_->_tmp261_;
#line 569 "../src/data/Runnable.vala"
				_data_->_tmp255_ = !g_file_query_exists (_data_->_tmp262_, NULL);
#line 569 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->_tmp262_);
#line 6468 "Runnable.c"
			}
#line 569 "../src/data/Runnable.vala"
			_data_->_tmp253_ = _data_->_tmp255_;
#line 6472 "Runnable.c"
		} else {
#line 569 "../src/data/Runnable.vala"
			_data_->_tmp253_ = FALSE;
#line 6476 "Runnable.c"
		}
#line 569 "../src/data/Runnable.vala"
		if (_data_->_tmp253_) {
#line 571 "../src/data/Runnable.vala"
			_data_->_tmp264_ = game_hub_data_runnable_get_actions (_data_->_data6_->runnable);
#line 571 "../src/data/Runnable.vala"
			_data_->_tmp265_ = _data_->_tmp264_;
#line 571 "../src/data/Runnable.vala"
			if (_data_->_tmp265_ != NULL) {
#line 571 "../src/data/Runnable.vala"
				_data_->_tmp266_ = game_hub_data_runnable_get_actions (_data_->_data6_->runnable);
#line 571 "../src/data/Runnable.vala"
				_data_->_tmp267_ = _data_->_tmp266_;
#line 571 "../src/data/Runnable.vala"
				_data_->_tmp268_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp267_);
#line 571 "../src/data/Runnable.vala"
				_data_->_tmp269_ = _data_->_tmp268_;
#line 571 "../src/data/Runnable.vala"
				_data_->_tmp263_ = _data_->_tmp269_ > 0;
#line 6496 "Runnable.c"
			} else {
#line 571 "../src/data/Runnable.vala"
				_data_->_tmp263_ = FALSE;
#line 6500 "Runnable.c"
			}
#line 571 "../src/data/Runnable.vala"
			if (_data_->_tmp263_) {
#line 6504 "Runnable.c"
				{
#line 573 "../src/data/Runnable.vala"
					_data_->_tmp270_ = game_hub_data_runnable_get_actions (_data_->_data6_->runnable);
#line 573 "../src/data/Runnable.vala"
					_data_->_tmp271_ = _data_->_tmp270_;
#line 573 "../src/data/Runnable.vala"
					_data_->_tmp272_ = _g_object_ref0 (_data_->_tmp271_);
#line 573 "../src/data/Runnable.vala"
					_data_->_action_list = _data_->_tmp272_;
#line 573 "../src/data/Runnable.vala"
					_data_->_tmp273_ = _data_->_action_list;
#line 573 "../src/data/Runnable.vala"
					_data_->_tmp274_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp273_);
#line 573 "../src/data/Runnable.vala"
					_data_->_tmp275_ = _data_->_tmp274_;
#line 573 "../src/data/Runnable.vala"
					_data_->_action_size = _data_->_tmp275_;
#line 573 "../src/data/Runnable.vala"
					_data_->_action_index = -1;
#line 573 "../src/data/Runnable.vala"
					while (TRUE) {
#line 573 "../src/data/Runnable.vala"
						_data_->_action_index = _data_->_action_index + 1;
#line 573 "../src/data/Runnable.vala"
						if (!(_data_->_action_index < _data_->_action_size)) {
#line 573 "../src/data/Runnable.vala"
							break;
#line 6532 "Runnable.c"
						}
#line 573 "../src/data/Runnable.vala"
						_data_->_tmp276_ = _data_->_action_list;
#line 573 "../src/data/Runnable.vala"
						_data_->_tmp277_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp276_, _data_->_action_index);
#line 573 "../src/data/Runnable.vala"
						_data_->action = (GameHubDataRunnableRunnableAction*) _data_->_tmp277_;
#line 575 "../src/data/Runnable.vala"
						_data_->_tmp278_ = _data_->action;
#line 575 "../src/data/Runnable.vala"
						_data_->_tmp279_ = game_hub_data_runnable_runnable_action_get_is_primary (_data_->_tmp278_);
#line 575 "../src/data/Runnable.vala"
						_data_->_tmp280_ = _data_->_tmp279_;
#line 575 "../src/data/Runnable.vala"
						if (_data_->_tmp280_) {
#line 577 "../src/data/Runnable.vala"
							_data_->_tmp282_ = _data_->action;
#line 577 "../src/data/Runnable.vala"
							_data_->_tmp283_ = game_hub_data_runnable_runnable_action_get_file (_data_->_tmp282_);
#line 577 "../src/data/Runnable.vala"
							_data_->_tmp284_ = _data_->_tmp283_;
#line 577 "../src/data/Runnable.vala"
							if (_data_->_tmp284_ != NULL) {
#line 577 "../src/data/Runnable.vala"
								_data_->_tmp285_ = _data_->action;
#line 577 "../src/data/Runnable.vala"
								_data_->_tmp286_ = game_hub_data_runnable_runnable_action_get_file (_data_->_tmp285_);
#line 577 "../src/data/Runnable.vala"
								_data_->_tmp287_ = _data_->_tmp286_;
#line 577 "../src/data/Runnable.vala"
								_data_->_tmp281_ = g_file_query_exists (_data_->_tmp287_, NULL);
#line 6564 "Runnable.c"
							} else {
#line 577 "../src/data/Runnable.vala"
								_data_->_tmp281_ = FALSE;
#line 6568 "Runnable.c"
							}
#line 577 "../src/data/Runnable.vala"
							if (_data_->_tmp281_) {
#line 579 "../src/data/Runnable.vala"
								_data_->_tmp288_ = _data_->action;
#line 579 "../src/data/Runnable.vala"
								_data_->_tmp289_ = game_hub_data_runnable_runnable_action_get_file (_data_->_tmp288_);
#line 579 "../src/data/Runnable.vala"
								_data_->_tmp290_ = _data_->_tmp289_;
#line 579 "../src/data/Runnable.vala"
								game_hub_data_runnable_set_executable (_data_->_data6_->runnable, _data_->_tmp290_);
#line 580 "../src/data/Runnable.vala"
								_data_->_tmp291_ = _data_->action;
#line 580 "../src/data/Runnable.vala"
								_data_->_tmp292_ = game_hub_data_runnable_runnable_action_get_args (_data_->_tmp291_);
#line 580 "../src/data/Runnable.vala"
								_data_->_tmp293_ = _data_->_tmp292_;
#line 580 "../src/data/Runnable.vala"
								game_hub_data_runnable_set_arguments (_data_->_data6_->runnable, _data_->_tmp293_);
#line 581 "../src/data/Runnable.vala"
								_game_hub_data_runnable_runnable_action_unref0 (_data_->action);
#line 581 "../src/data/Runnable.vala"
								break;
#line 6592 "Runnable.c"
							}
						}
#line 573 "../src/data/Runnable.vala"
						_game_hub_data_runnable_runnable_action_unref0 (_data_->action);
#line 6597 "Runnable.c"
					}
#line 573 "../src/data/Runnable.vala"
					_g_object_unref0 (_data_->_action_list);
#line 6601 "Runnable.c"
				}
			}
#line 587 "../src/data/Runnable.vala"
			game_hub_data_runnable_update_status (_data_->_data6_->runnable);
#line 6606 "Runnable.c"
		}
#line 590 "../src/data/Runnable.vala"
		_data_->_tmp296_ = game_hub_data_runnable_get_executable (_data_->_data6_->runnable);
#line 590 "../src/data/Runnable.vala"
		_data_->_tmp297_ = _data_->_tmp296_;
#line 590 "../src/data/Runnable.vala"
		_data_->_tmp298_ = _data_->_tmp297_;
#line 590 "../src/data/Runnable.vala"
		_data_->_tmp299_ = _data_->_tmp298_ == NULL;
#line 590 "../src/data/Runnable.vala"
		_g_object_unref0 (_data_->_tmp298_);
#line 590 "../src/data/Runnable.vala"
		if (_data_->_tmp299_) {
#line 590 "../src/data/Runnable.vala"
			_data_->_tmp295_ = TRUE;
#line 6622 "Runnable.c"
		} else {
#line 590 "../src/data/Runnable.vala"
			_data_->_tmp300_ = game_hub_data_runnable_get_executable (_data_->_data6_->runnable);
#line 590 "../src/data/Runnable.vala"
			_data_->_tmp301_ = _data_->_tmp300_;
#line 590 "../src/data/Runnable.vala"
			_data_->_tmp302_ = _data_->_tmp301_;
#line 590 "../src/data/Runnable.vala"
			_data_->_tmp295_ = !g_file_query_exists (_data_->_tmp302_, NULL);
#line 590 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->_tmp302_);
#line 6634 "Runnable.c"
		}
#line 590 "../src/data/Runnable.vala"
		if (_data_->_tmp295_) {
#line 590 "../src/data/Runnable.vala"
			_data_->_tmp294_ = !GAME_HUB_DATA_SOURCES_GOG_GOG_GAME_IS_DLC (_data_->_data6_->runnable);
#line 6640 "Runnable.c"
		} else {
#line 590 "../src/data/Runnable.vala"
			_data_->_tmp294_ = FALSE;
#line 6644 "Runnable.c"
		}
#line 590 "../src/data/Runnable.vala"
		if (_data_->_tmp294_) {
#line 592 "../src/data/Runnable.vala"
			_data_->_tmp303_ = _data_->_data7_->game;
#line 592 "../src/data/Runnable.vala"
			if (_data_->_tmp303_ != NULL) {
#line 594 "../src/data/Runnable.vala"
				_data_->_tmp304_ = _data_->_data7_->game;
#line 594 "../src/data/Runnable.vala"
				_data_->_tmp305_ = game_hub_data_runnable_get_name ((GameHubDataRunnable*) _data_->_tmp304_);
#line 594 "../src/data/Runnable.vala"
				_data_->_tmp306_ = _data_->_tmp305_;
#line 594 "../src/data/Runnable.vala"
				_data_->_tmp307_ = g_strdup_printf (_ ("%s: cannot detect main executable"), _data_->_tmp306_);
#line 594 "../src/data/Runnable.vala"
				_data_->_tmp308_ = _data_->_tmp307_;
#line 594 "../src/data/Runnable.vala"
				game_hub_utils_notify (_data_->_tmp308_, _ ("Main executable file for this game cannot be detected automatically.\n" \
"Please set main executable in game's properties."), G_NOTIFICATION_PRIORITY_HIGH, ______lambda106__game_hub_utils_notification_configure_delegate, _data_->_data7_);
#line 594 "../src/data/Runnable.vala"
				_g_free0 (_data_->_tmp308_);
#line 6666 "Runnable.c"
			} else {
#line 615 "../src/data/Runnable.vala"
				game_hub_data_runnable_choose_executable (_data_->_data6_->runnable, TRUE);
#line 6670 "Runnable.c"
			}
		}
#line 619 "../src/data/Runnable.vala"
		_data_->_tmp310_ = _data_->_data7_->game;
#line 619 "../src/data/Runnable.vala"
		if (_data_->_tmp310_ != NULL) {
#line 619 "../src/data/Runnable.vala"
			_data_->_tmp311_ = _data_->self->priv->_version;
#line 619 "../src/data/Runnable.vala"
			_data_->_tmp309_ = _data_->_tmp311_ != NULL;
#line 6681 "Runnable.c"
		} else {
#line 619 "../src/data/Runnable.vala"
			_data_->_tmp309_ = FALSE;
#line 6685 "Runnable.c"
		}
#line 619 "../src/data/Runnable.vala"
		if (_data_->_tmp309_) {
#line 621 "../src/data/Runnable.vala"
			_data_->_tmp312_ = _data_->_data7_->game;
#line 621 "../src/data/Runnable.vala"
			_data_->_tmp313_ = _data_->self->priv->_version;
#line 621 "../src/data/Runnable.vala"
			game_hub_data_game_save_version (_data_->_tmp312_, _data_->_tmp313_);
#line 6695 "Runnable.c"
		}
#line 624 "../src/data/Runnable.vala"
		_data_->_tmp314_ = game_hub_data_runnable_get_install_dir (_data_->_data6_->runnable);
#line 624 "../src/data/Runnable.vala"
		_data_->_tmp315_ = _data_->_tmp314_;
#line 624 "../src/data/Runnable.vala"
		_data_->_tmp316_ = game_hub_data_runnable_get_id (_data_->_data6_->runnable);
#line 624 "../src/data/Runnable.vala"
		_data_->_tmp317_ = _data_->_tmp316_;
#line 624 "../src/data/Runnable.vala"
		_data_->_tmp318_ = g_strconcat (".gamehub_", _data_->_tmp317_, NULL);
#line 624 "../src/data/Runnable.vala"
		_data_->_tmp319_ = _data_->_tmp318_;
#line 624 "../src/data/Runnable.vala"
		_data_->_tmp320_ = g_file_get_child (_data_->_tmp315_, _data_->_tmp319_);
#line 624 "../src/data/Runnable.vala"
		_data_->_tmp321_ = _data_->_tmp320_;
#line 624 "../src/data/Runnable.vala"
		_g_free0 (_data_->_tmp319_);
#line 624 "../src/data/Runnable.vala"
		_data_->gh_marker = _data_->_tmp321_;
#line 625 "../src/data/Runnable.vala"
		_data_->_tmp322_ = _data_->gh_marker;
#line 625 "../src/data/Runnable.vala"
		if (_data_->_tmp322_ != NULL) {
#line 627 "../src/data/Runnable.vala"
			_data_->_tmp323_ = _data_->gh_marker;
#line 627 "../src/data/Runnable.vala"
			_data_->_tmp324_ = g_file_get_path (_data_->_tmp323_);
#line 627 "../src/data/Runnable.vala"
			_data_->_tmp325_ = _data_->_tmp324_;
#line 627 "../src/data/Runnable.vala"
			g_file_set_contents (_data_->_tmp325_, "", (gssize) -1, &_data_->_inner_error0_);
#line 627 "../src/data/Runnable.vala"
			_g_free0 (_data_->_tmp325_);
#line 627 "../src/data/Runnable.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 627 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->gh_marker);
#line 627 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->files);
#line 627 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->runnable_install_dir);
#line 627 "../src/data/Runnable.vala"
				_g_object_unref0 (_data_->_tmp6_);
#line 627 "../src/data/Runnable.vala"
				block7_data_unref (_data_->_data7_);
#line 627 "../src/data/Runnable.vala"
				_data_->_data7_ = NULL;
#line 627 "../src/data/Runnable.vala"
				if (g_error_matches (_data_->_inner_error0_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 6747 "Runnable.c"
					goto __catch5_g_io_error_cancelled;
				}
				goto __catch5_g_error;
			}
		}
#line 368 "../src/data/Runnable.vala"
		_g_object_unref0 (_data_->gh_marker);
#line 368 "../src/data/Runnable.vala"
		_g_object_unref0 (_data_->files);
#line 368 "../src/data/Runnable.vala"
		_g_object_unref0 (_data_->runnable_install_dir);
#line 368 "../src/data/Runnable.vala"
		_g_object_unref0 (_data_->_tmp6_);
#line 368 "../src/data/Runnable.vala"
		block7_data_unref (_data_->_data7_);
#line 368 "../src/data/Runnable.vala"
		_data_->_data7_ = NULL;
#line 6765 "Runnable.c"
	}
	goto __finally5;
	__catch5_g_io_error_cancelled:
	{
#line 368 "../src/data/Runnable.vala"
		_data_->_vala1_e = _data_->_inner_error0_;
#line 368 "../src/data/Runnable.vala"
		_data_->_inner_error0_ = NULL;
#line 368 "../src/data/Runnable.vala"
		_g_error_free0 (_data_->_vala1_e);
#line 6776 "Runnable.c"
	}
	goto __finally5;
	__catch5_g_error:
	{
#line 368 "../src/data/Runnable.vala"
		_data_->_vala2_e = _data_->_inner_error0_;
#line 368 "../src/data/Runnable.vala"
		_data_->_inner_error0_ = NULL;
#line 633 "../src/data/Runnable.vala"
		_data_->_tmp326_ = _data_->_vala2_e;
#line 633 "../src/data/Runnable.vala"
		_data_->_tmp327_ = _data_->_tmp326_->message;
#line 633 "../src/data/Runnable.vala"
		g_warning ("Runnable.vala:633: %s", _data_->_tmp327_);
#line 368 "../src/data/Runnable.vala"
		_g_error_free0 (_data_->_vala2_e);
#line 6793 "Runnable.c"
	}
	__finally5:
#line 368 "../src/data/Runnable.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 368 "../src/data/Runnable.vala"
		block6_data_unref (_data_->_data6_);
#line 368 "../src/data/Runnable.vala"
		_data_->_data6_ = NULL;
#line 368 "../src/data/Runnable.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 368 "../src/data/Runnable.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 368 "../src/data/Runnable.vala"
		g_object_unref (_data_->_async_result);
#line 368 "../src/data/Runnable.vala"
		return FALSE;
#line 6810 "Runnable.c"
	}
#line 635 "../src/data/Runnable.vala"
	game_hub_data_runnable_update_status (_data_->_data6_->runnable);
#line 366 "../src/data/Runnable.vala"
	block6_data_unref (_data_->_data6_);
#line 366 "../src/data/Runnable.vala"
	_data_->_data6_ = NULL;
#line 366 "../src/data/Runnable.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 366 "../src/data/Runnable.vala"
	if (_data_->_state_ != 0) {
#line 366 "../src/data/Runnable.vala"
		while (!_data_->_task_complete_) {
#line 366 "../src/data/Runnable.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 6826 "Runnable.c"
		}
	}
#line 366 "../src/data/Runnable.vala"
	g_object_unref (_data_->_async_result);
#line 366 "../src/data/Runnable.vala"
	return FALSE;
#line 6833 "Runnable.c"
}

static void
game_hub_data_runnable_installer_guess_type_data_free (gpointer _data)
{
	GameHubDataRunnableInstallerGuessTypeData* _data_;
	_data_ = _data;
#line 321 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->file);
#line 321 "../src/data/Runnable.vala"
	g_slice_free (GameHubDataRunnableInstallerGuessTypeData, _data_);
#line 6845 "Runnable.c"
}

static void
game_hub_data_runnable_installer_guess_type_async_ready_wrapper (GObject *source_object,
                                                                 GAsyncResult *res,
                                                                 void *user_data)
{
	GameHubDataRunnableInstallerGuessTypeData* _task_data_;
#line 321 "../src/data/Runnable.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 321 "../src/data/Runnable.vala"
	if (_task_data_->_callback_ != NULL) {
#line 321 "../src/data/Runnable.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 6860 "Runnable.c"
	}
#line 321 "../src/data/Runnable.vala"
	_task_data_->_task_complete_ = TRUE;
#line 6864 "Runnable.c"
}

void
game_hub_data_runnable_installer_guess_type (GFile* file,
                                             gboolean part,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_)
{
	GameHubDataRunnableInstallerGuessTypeData* _data_;
	GFile* _tmp0_;
#line 321 "../src/data/Runnable.vala"
	_data_ = g_slice_new0 (GameHubDataRunnableInstallerGuessTypeData);
#line 321 "../src/data/Runnable.vala"
	_data_->_callback_ = _callback_;
#line 321 "../src/data/Runnable.vala"
	_data_->_async_result = g_task_new (NULL, NULL, game_hub_data_runnable_installer_guess_type_async_ready_wrapper, _user_data_);
#line 321 "../src/data/Runnable.vala"
	if (_callback_ == NULL) {
#line 321 "../src/data/Runnable.vala"
		_data_->_task_complete_ = TRUE;
#line 6885 "Runnable.c"
	}
#line 321 "../src/data/Runnable.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_runnable_installer_guess_type_data_free);
#line 321 "../src/data/Runnable.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 321 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->file);
#line 321 "../src/data/Runnable.vala"
	_data_->file = _tmp0_;
#line 321 "../src/data/Runnable.vala"
	_data_->part = part;
#line 321 "../src/data/Runnable.vala"
	game_hub_data_runnable_installer_guess_type_co (_data_);
#line 6899 "Runnable.c"
}

GameHubDataRunnableInstallerInstallerType
game_hub_data_runnable_installer_guess_type_finish (GAsyncResult* _res_)
{
	GameHubDataRunnableInstallerInstallerType result;
	GameHubDataRunnableInstallerGuessTypeData* _data_;
#line 321 "../src/data/Runnable.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 321 "../src/data/Runnable.vala"
	result = _data_->result;
#line 321 "../src/data/Runnable.vala"
	return result;
#line 6913 "Runnable.c"
}

static void
game_hub_data_runnable_installer_guess_type_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_)
{
	GameHubDataRunnableInstallerGuessTypeData* _data_;
#line 645 "../src/data/Runnable.vala"
	_data_ = _user_data_;
#line 645 "../src/data/Runnable.vala"
	_data_->_source_object_ = source_object;
#line 645 "../src/data/Runnable.vala"
	_data_->_res_ = _res_;
#line 645 "../src/data/Runnable.vala"
	_data_->_task_complete_ = TRUE;
#line 645 "../src/data/Runnable.vala"
	game_hub_data_runnable_installer_guess_type_co (_data_);
#line 6932 "Runnable.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
#line 1516 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1517 "glib-2.0.vapi"
	result = self;
#line 1517 "glib-2.0.vapi"
	return result;
#line 6945 "Runnable.c"
}

static gboolean
game_hub_data_runnable_installer_guess_type_co (GameHubDataRunnableInstallerGuessTypeData* _data_)
{
#line 638 "../src/data/Runnable.vala"
	switch (_data_->_state_) {
#line 638 "../src/data/Runnable.vala"
		case 0:
#line 6955 "Runnable.c"
		goto _state_0;
#line 638 "../src/data/Runnable.vala"
		case 1:
#line 6959 "Runnable.c"
		goto _state_1;
#line 638 "../src/data/Runnable.vala"
		case 2:
#line 6963 "Runnable.c"
		goto _state_2;
		default:
#line 638 "../src/data/Runnable.vala"
		g_assert_not_reached ();
#line 6968 "Runnable.c"
	}
	_state_0:
#line 640 "../src/data/Runnable.vala"
	_data_->type = GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_UNKNOWN;
#line 641 "../src/data/Runnable.vala"
	if (_data_->file == NULL) {
#line 641 "../src/data/Runnable.vala"
		_data_->result = _data_->type;
#line 641 "../src/data/Runnable.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 641 "../src/data/Runnable.vala"
		if (_data_->_state_ != 0) {
#line 641 "../src/data/Runnable.vala"
			while (!_data_->_task_complete_) {
#line 641 "../src/data/Runnable.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 6985 "Runnable.c"
			}
		}
#line 641 "../src/data/Runnable.vala"
		g_object_unref (_data_->_async_result);
#line 641 "../src/data/Runnable.vala"
		return FALSE;
#line 6992 "Runnable.c"
	}
	{
#line 645 "../src/data/Runnable.vala"
		_data_->_state_ = 1;
#line 645 "../src/data/Runnable.vala"
		g_file_query_info_async (_data_->file, G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, G_FILE_QUERY_INFO_NONE, G_PRIORITY_DEFAULT, NULL, game_hub_data_runnable_installer_guess_type_ready, _data_);
#line 645 "../src/data/Runnable.vala"
		return FALSE;
#line 7001 "Runnable.c"
		_state_1:
#line 645 "../src/data/Runnable.vala"
		_data_->_tmp0_ = g_file_query_info_finish (_data_->file, _data_->_res_, &_data_->_inner_error0_);
#line 645 "../src/data/Runnable.vala"
		_data_->finfo = _data_->_tmp0_;
#line 645 "../src/data/Runnable.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 7009 "Runnable.c"
			goto __catch7_g_error;
		}
#line 646 "../src/data/Runnable.vala"
		_data_->_tmp1_ = _data_->finfo;
#line 646 "../src/data/Runnable.vala"
		_data_->_tmp2_ = g_file_info_get_content_type (_data_->_tmp1_);
#line 646 "../src/data/Runnable.vala"
		_data_->_tmp3_ = g_strdup (_data_->_tmp2_);
#line 646 "../src/data/Runnable.vala"
		_data_->mime = _data_->_tmp3_;
#line 647 "../src/data/Runnable.vala"
		_data_->_tmp4_ = _data_->mime;
#line 647 "../src/data/Runnable.vala"
		_data_->type = game_hub_data_runnable_installer_installer_type_from_mime (_data_->_tmp4_);
#line 649 "../src/data/Runnable.vala"
		_data_->_tmp5_ = _data_->type;
#line 649 "../src/data/Runnable.vala"
		if (_data_->_tmp5_ != GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_UNKNOWN) {
#line 649 "../src/data/Runnable.vala"
			_data_->result = _data_->type;
#line 649 "../src/data/Runnable.vala"
			_g_free0 (_data_->mime);
#line 649 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->finfo);
#line 649 "../src/data/Runnable.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 649 "../src/data/Runnable.vala"
			if (_data_->_state_ != 0) {
#line 649 "../src/data/Runnable.vala"
				while (!_data_->_task_complete_) {
#line 649 "../src/data/Runnable.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7042 "Runnable.c"
				}
			}
#line 649 "../src/data/Runnable.vala"
			g_object_unref (_data_->_async_result);
#line 649 "../src/data/Runnable.vala"
			return FALSE;
#line 7049 "Runnable.c"
		}
#line 651 "../src/data/Runnable.vala"
		_data_->_tmp6_ = g_strdup ("file");
#line 651 "../src/data/Runnable.vala"
		_data_->_tmp7_ = g_strdup ("-bi");
#line 651 "../src/data/Runnable.vala"
		_data_->_tmp8_ = g_file_get_path (_data_->file);
#line 651 "../src/data/Runnable.vala"
		_data_->_tmp9_ = g_new0 (gchar*, 3 + 1);
#line 651 "../src/data/Runnable.vala"
		_data_->_tmp9_[0] = _data_->_tmp6_;
#line 651 "../src/data/Runnable.vala"
		_data_->_tmp9_[1] = _data_->_tmp7_;
#line 651 "../src/data/Runnable.vala"
		_data_->_tmp9_[2] = _data_->_tmp8_;
#line 651 "../src/data/Runnable.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 651 "../src/data/Runnable.vala"
		_data_->_tmp10__length1 = 3;
#line 651 "../src/data/Runnable.vala"
		_data_->_state_ = 2;
#line 651 "../src/data/Runnable.vala"
		game_hub_utils_run_thread (_data_->_tmp10_, (gint) 3, NULL, NULL, (gint) 0, FALSE, FALSE, TRUE, game_hub_data_runnable_installer_guess_type_ready, _data_);
#line 651 "../src/data/Runnable.vala"
		return FALSE;
#line 7075 "Runnable.c"
		_state_2:
#line 651 "../src/data/Runnable.vala"
		_data_->_tmp11_ = game_hub_utils_run_thread_finish (_data_->_res_);
#line 651 "../src/data/Runnable.vala"
		_data_->_tmp12_ = _data_->_tmp11_;
#line 651 "../src/data/Runnable.vala"
		_data_->_tmp10_ = (_vala_array_free (_data_->_tmp10_, _data_->_tmp10__length1, (GDestroyNotify) g_free), NULL);
#line 651 "../src/data/Runnable.vala"
		_data_->info = _data_->_tmp12_;
#line 652 "../src/data/Runnable.vala"
		_data_->_tmp14_ = _data_->info;
#line 652 "../src/data/Runnable.vala"
		if (_data_->_tmp14_ != NULL) {
#line 652 "../src/data/Runnable.vala"
			_data_->_tmp15_ = _data_->info;
#line 652 "../src/data/Runnable.vala"
			_data_->_tmp16_ = strlen (_data_->_tmp15_);
#line 652 "../src/data/Runnable.vala"
			_data_->_tmp17_ = _data_->_tmp16_;
#line 652 "../src/data/Runnable.vala"
			_data_->_tmp13_ = _data_->_tmp17_ > 0;
#line 7097 "Runnable.c"
		} else {
#line 652 "../src/data/Runnable.vala"
			_data_->_tmp13_ = FALSE;
#line 7101 "Runnable.c"
		}
#line 652 "../src/data/Runnable.vala"
		if (_data_->_tmp13_) {
#line 654 "../src/data/Runnable.vala"
			_data_->_tmp18_ = _data_->info;
#line 654 "../src/data/Runnable.vala"
			_data_->_tmp20_ = _data_->_tmp19_ = g_strsplit (_data_->_tmp18_, ";", 0);
#line 654 "../src/data/Runnable.vala"
			_data_->_tmp21_ = _data_->_tmp20_;
#line 654 "../src/data/Runnable.vala"
			_data_->_tmp21__length1 = _vala_array_length (_data_->_tmp19_);
#line 654 "../src/data/Runnable.vala"
			_data_->_tmp22_ = _data_->_tmp21_[0];
#line 654 "../src/data/Runnable.vala"
			_data_->_tmp23_ = g_strdup (_data_->_tmp22_);
#line 654 "../src/data/Runnable.vala"
			_g_free0 (_data_->mime);
#line 654 "../src/data/Runnable.vala"
			_data_->mime = _data_->_tmp23_;
#line 654 "../src/data/Runnable.vala"
			_data_->_tmp21_ = (_vala_array_free (_data_->_tmp21_, _data_->_tmp21__length1, (GDestroyNotify) g_free), NULL);
#line 655 "../src/data/Runnable.vala"
			_data_->_tmp25_ = _data_->mime;
#line 655 "../src/data/Runnable.vala"
			if (_data_->_tmp25_ != NULL) {
#line 655 "../src/data/Runnable.vala"
				_data_->_tmp26_ = _data_->mime;
#line 655 "../src/data/Runnable.vala"
				_data_->_tmp27_ = strlen (_data_->_tmp26_);
#line 655 "../src/data/Runnable.vala"
				_data_->_tmp28_ = _data_->_tmp27_;
#line 655 "../src/data/Runnable.vala"
				_data_->_tmp24_ = _data_->_tmp28_ > 0;
#line 7135 "Runnable.c"
			} else {
#line 655 "../src/data/Runnable.vala"
				_data_->_tmp24_ = FALSE;
#line 7139 "Runnable.c"
			}
#line 655 "../src/data/Runnable.vala"
			if (_data_->_tmp24_) {
#line 657 "../src/data/Runnable.vala"
				_data_->_tmp29_ = _data_->mime;
#line 657 "../src/data/Runnable.vala"
				_data_->type = game_hub_data_runnable_installer_installer_type_from_mime (_data_->_tmp29_);
#line 7147 "Runnable.c"
			}
		}
#line 661 "../src/data/Runnable.vala"
		_data_->_tmp30_ = _data_->type;
#line 661 "../src/data/Runnable.vala"
		if (_data_->_tmp30_ != GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_UNKNOWN) {
#line 661 "../src/data/Runnable.vala"
			_data_->result = _data_->type;
#line 661 "../src/data/Runnable.vala"
			_g_free0 (_data_->info);
#line 661 "../src/data/Runnable.vala"
			_g_free0 (_data_->mime);
#line 661 "../src/data/Runnable.vala"
			_g_object_unref0 (_data_->finfo);
#line 661 "../src/data/Runnable.vala"
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 661 "../src/data/Runnable.vala"
			if (_data_->_state_ != 0) {
#line 661 "../src/data/Runnable.vala"
				while (!_data_->_task_complete_) {
#line 661 "../src/data/Runnable.vala"
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7170 "Runnable.c"
				}
			}
#line 661 "../src/data/Runnable.vala"
			g_object_unref (_data_->_async_result);
#line 661 "../src/data/Runnable.vala"
			return FALSE;
#line 7177 "Runnable.c"
		}
#line 663 "../src/data/Runnable.vala"
		_data_->_tmp31_ = g_strdup ("bin");
#line 663 "../src/data/Runnable.vala"
		_data_->_tmp32_ = g_new0 (gchar*, 1 + 1);
#line 663 "../src/data/Runnable.vala"
		_data_->_tmp32_[0] = _data_->_tmp31_;
#line 663 "../src/data/Runnable.vala"
		_data_->gog_part_ext = _data_->_tmp32_;
#line 663 "../src/data/Runnable.vala"
		_data_->gog_part_ext_length1 = 1;
#line 663 "../src/data/Runnable.vala"
		_data_->_gog_part_ext_size_ = _data_->gog_part_ext_length1;
#line 664 "../src/data/Runnable.vala"
		_data_->_tmp33_ = g_strdup ("sh");
#line 664 "../src/data/Runnable.vala"
		_data_->_tmp34_ = g_strdup ("elf");
#line 664 "../src/data/Runnable.vala"
		_data_->_tmp35_ = g_strdup ("bin");
#line 664 "../src/data/Runnable.vala"
		_data_->_tmp36_ = g_strdup ("run");
#line 664 "../src/data/Runnable.vala"
		_data_->_tmp37_ = g_new0 (gchar*, 4 + 1);
#line 664 "../src/data/Runnable.vala"
		_data_->_tmp37_[0] = _data_->_tmp33_;
#line 664 "../src/data/Runnable.vala"
		_data_->_tmp37_[1] = _data_->_tmp34_;
#line 664 "../src/data/Runnable.vala"
		_data_->_tmp37_[2] = _data_->_tmp35_;
#line 664 "../src/data/Runnable.vala"
		_data_->_tmp37_[3] = _data_->_tmp36_;
#line 664 "../src/data/Runnable.vala"
		_data_->exe_ext = _data_->_tmp37_;
#line 664 "../src/data/Runnable.vala"
		_data_->exe_ext_length1 = 4;
#line 664 "../src/data/Runnable.vala"
		_data_->_exe_ext_size_ = _data_->exe_ext_length1;
#line 665 "../src/data/Runnable.vala"
		_data_->_tmp38_ = g_strdup ("exe");
#line 665 "../src/data/Runnable.vala"
		_data_->_tmp39_ = g_strdup ("msi");
#line 665 "../src/data/Runnable.vala"
		_data_->_tmp40_ = g_new0 (gchar*, 2 + 1);
#line 665 "../src/data/Runnable.vala"
		_data_->_tmp40_[0] = _data_->_tmp38_;
#line 665 "../src/data/Runnable.vala"
		_data_->_tmp40_[1] = _data_->_tmp39_;
#line 665 "../src/data/Runnable.vala"
		_data_->win_exe_ext = _data_->_tmp40_;
#line 665 "../src/data/Runnable.vala"
		_data_->win_exe_ext_length1 = 2;
#line 665 "../src/data/Runnable.vala"
		_data_->_win_exe_ext_size_ = _data_->win_exe_ext_length1;
#line 666 "../src/data/Runnable.vala"
		_data_->_tmp41_ = g_strdup ("zip");
#line 666 "../src/data/Runnable.vala"
		_data_->_tmp42_ = g_strdup ("tar");
#line 666 "../src/data/Runnable.vala"
		_data_->_tmp43_ = g_strdup ("cpio");
#line 666 "../src/data/Runnable.vala"
		_data_->_tmp44_ = g_strdup ("bz2");
#line 666 "../src/data/Runnable.vala"
		_data_->_tmp45_ = g_strdup ("gz");
#line 666 "../src/data/Runnable.vala"
		_data_->_tmp46_ = g_strdup ("lz");
#line 666 "../src/data/Runnable.vala"
		_data_->_tmp47_ = g_strdup ("lzma");
#line 666 "../src/data/Runnable.vala"
		_data_->_tmp48_ = g_strdup ("7z");
#line 666 "../src/data/Runnable.vala"
		_data_->_tmp49_ = g_strdup ("rar");
#line 666 "../src/data/Runnable.vala"
		_data_->_tmp50_ = g_new0 (gchar*, 9 + 1);
#line 666 "../src/data/Runnable.vala"
		_data_->_tmp50_[0] = _data_->_tmp41_;
#line 666 "../src/data/Runnable.vala"
		_data_->_tmp50_[1] = _data_->_tmp42_;
#line 666 "../src/data/Runnable.vala"
		_data_->_tmp50_[2] = _data_->_tmp43_;
#line 666 "../src/data/Runnable.vala"
		_data_->_tmp50_[3] = _data_->_tmp44_;
#line 666 "../src/data/Runnable.vala"
		_data_->_tmp50_[4] = _data_->_tmp45_;
#line 666 "../src/data/Runnable.vala"
		_data_->_tmp50_[5] = _data_->_tmp46_;
#line 666 "../src/data/Runnable.vala"
		_data_->_tmp50_[6] = _data_->_tmp47_;
#line 666 "../src/data/Runnable.vala"
		_data_->_tmp50_[7] = _data_->_tmp48_;
#line 666 "../src/data/Runnable.vala"
		_data_->_tmp50_[8] = _data_->_tmp49_;
#line 666 "../src/data/Runnable.vala"
		_data_->arc_ext = _data_->_tmp50_;
#line 666 "../src/data/Runnable.vala"
		_data_->arc_ext_length1 = 9;
#line 666 "../src/data/Runnable.vala"
		_data_->_arc_ext_size_ = _data_->arc_ext_length1;
#line 668 "../src/data/Runnable.vala"
		if (_data_->part) {
#line 670 "../src/data/Runnable.vala"
			_data_->_tmp51_ = _data_->gog_part_ext;
#line 670 "../src/data/Runnable.vala"
			_data_->_tmp51__length1 = _data_->gog_part_ext_length1;
#line 7281 "Runnable.c"
			{
#line 670 "../src/data/Runnable.vala"
				_data_->ext_collection_length1 = 0;
#line 670 "../src/data/Runnable.vala"
				_data_->_ext_collection_size_ = 0;
#line 670 "../src/data/Runnable.vala"
				_data_->ext_collection = _data_->_tmp51_;
#line 670 "../src/data/Runnable.vala"
				_data_->ext_collection_length1 = _data_->_tmp51__length1;
#line 670 "../src/data/Runnable.vala"
				for (_data_->ext_it = 0; _data_->ext_it < _data_->ext_collection_length1; _data_->ext_it = _data_->ext_it + 1) {
#line 670 "../src/data/Runnable.vala"
					_data_->_tmp52_ = g_strdup (_data_->ext_collection[_data_->ext_it]);
#line 670 "../src/data/Runnable.vala"
					_data_->ext = _data_->_tmp52_;
#line 7297 "Runnable.c"
					{
#line 672 "../src/data/Runnable.vala"
						_data_->_tmp53_ = g_file_get_basename (_data_->file);
#line 672 "../src/data/Runnable.vala"
						_data_->_tmp54_ = _data_->_tmp53_;
#line 672 "../src/data/Runnable.vala"
						_data_->_tmp55_ = g_utf8_strdown (_data_->_tmp54_, (gssize) -1);
#line 672 "../src/data/Runnable.vala"
						_data_->_tmp56_ = _data_->_tmp55_;
#line 672 "../src/data/Runnable.vala"
						_data_->_tmp57_ = _data_->ext;
#line 672 "../src/data/Runnable.vala"
						_data_->_tmp58_ = string_to_string (_data_->_tmp57_);
#line 672 "../src/data/Runnable.vala"
						_data_->_tmp59_ = g_strconcat (".", _data_->_tmp58_, NULL);
#line 672 "../src/data/Runnable.vala"
						_data_->_tmp60_ = _data_->_tmp59_;
#line 672 "../src/data/Runnable.vala"
						_data_->_tmp61_ = g_str_has_suffix (_data_->_tmp56_, _data_->_tmp60_);
#line 672 "../src/data/Runnable.vala"
						_g_free0 (_data_->_tmp60_);
#line 672 "../src/data/Runnable.vala"
						_g_free0 (_data_->_tmp56_);
#line 672 "../src/data/Runnable.vala"
						_g_free0 (_data_->_tmp54_);
#line 672 "../src/data/Runnable.vala"
						if (_data_->_tmp61_) {
#line 672 "../src/data/Runnable.vala"
							_data_->result = GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_GOG_PART;
#line 672 "../src/data/Runnable.vala"
							_g_free0 (_data_->ext);
#line 672 "../src/data/Runnable.vala"
							_data_->arc_ext = (_vala_array_free (_data_->arc_ext, _data_->arc_ext_length1, (GDestroyNotify) g_free), NULL);
#line 672 "../src/data/Runnable.vala"
							_data_->win_exe_ext = (_vala_array_free (_data_->win_exe_ext, _data_->win_exe_ext_length1, (GDestroyNotify) g_free), NULL);
#line 672 "../src/data/Runnable.vala"
							_data_->exe_ext = (_vala_array_free (_data_->exe_ext, _data_->exe_ext_length1, (GDestroyNotify) g_free), NULL);
#line 672 "../src/data/Runnable.vala"
							_data_->gog_part_ext = (_vala_array_free (_data_->gog_part_ext, _data_->gog_part_ext_length1, (GDestroyNotify) g_free), NULL);
#line 672 "../src/data/Runnable.vala"
							_g_free0 (_data_->info);
#line 672 "../src/data/Runnable.vala"
							_g_free0 (_data_->mime);
#line 672 "../src/data/Runnable.vala"
							_g_object_unref0 (_data_->finfo);
#line 672 "../src/data/Runnable.vala"
							g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 672 "../src/data/Runnable.vala"
							if (_data_->_state_ != 0) {
#line 672 "../src/data/Runnable.vala"
								while (!_data_->_task_complete_) {
#line 672 "../src/data/Runnable.vala"
									g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7351 "Runnable.c"
								}
							}
#line 672 "../src/data/Runnable.vala"
							g_object_unref (_data_->_async_result);
#line 672 "../src/data/Runnable.vala"
							return FALSE;
#line 7358 "Runnable.c"
						}
#line 670 "../src/data/Runnable.vala"
						_g_free0 (_data_->ext);
#line 7362 "Runnable.c"
					}
				}
			}
		}
#line 676 "../src/data/Runnable.vala"
		_data_->_tmp62_ = _data_->exe_ext;
#line 676 "../src/data/Runnable.vala"
		_data_->_tmp62__length1 = _data_->exe_ext_length1;
#line 7371 "Runnable.c"
		{
#line 676 "../src/data/Runnable.vala"
			_data_->_vala1_ext_collection_length1 = 0;
#line 676 "../src/data/Runnable.vala"
			_data_->__vala1_ext_collection_size_ = 0;
#line 676 "../src/data/Runnable.vala"
			_data_->_vala1_ext_collection = _data_->_tmp62_;
#line 676 "../src/data/Runnable.vala"
			_data_->_vala1_ext_collection_length1 = _data_->_tmp62__length1;
#line 676 "../src/data/Runnable.vala"
			for (_data_->_vala1_ext_it = 0; _data_->_vala1_ext_it < _data_->_vala1_ext_collection_length1; _data_->_vala1_ext_it = _data_->_vala1_ext_it + 1) {
#line 676 "../src/data/Runnable.vala"
				_data_->_tmp63_ = g_strdup (_data_->_vala1_ext_collection[_data_->_vala1_ext_it]);
#line 676 "../src/data/Runnable.vala"
				_data_->_vala1_ext = _data_->_tmp63_;
#line 7387 "Runnable.c"
				{
#line 678 "../src/data/Runnable.vala"
					_data_->_tmp64_ = g_file_get_basename (_data_->file);
#line 678 "../src/data/Runnable.vala"
					_data_->_tmp65_ = _data_->_tmp64_;
#line 678 "../src/data/Runnable.vala"
					_data_->_tmp66_ = g_utf8_strdown (_data_->_tmp65_, (gssize) -1);
#line 678 "../src/data/Runnable.vala"
					_data_->_tmp67_ = _data_->_tmp66_;
#line 678 "../src/data/Runnable.vala"
					_data_->_tmp68_ = _data_->_vala1_ext;
#line 678 "../src/data/Runnable.vala"
					_data_->_tmp69_ = string_to_string (_data_->_tmp68_);
#line 678 "../src/data/Runnable.vala"
					_data_->_tmp70_ = g_strconcat (".", _data_->_tmp69_, NULL);
#line 678 "../src/data/Runnable.vala"
					_data_->_tmp71_ = _data_->_tmp70_;
#line 678 "../src/data/Runnable.vala"
					_data_->_tmp72_ = g_str_has_suffix (_data_->_tmp67_, _data_->_tmp71_);
#line 678 "../src/data/Runnable.vala"
					_g_free0 (_data_->_tmp71_);
#line 678 "../src/data/Runnable.vala"
					_g_free0 (_data_->_tmp67_);
#line 678 "../src/data/Runnable.vala"
					_g_free0 (_data_->_tmp65_);
#line 678 "../src/data/Runnable.vala"
					if (_data_->_tmp72_) {
#line 678 "../src/data/Runnable.vala"
						_data_->result = GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_EXECUTABLE;
#line 678 "../src/data/Runnable.vala"
						_g_free0 (_data_->_vala1_ext);
#line 678 "../src/data/Runnable.vala"
						_data_->arc_ext = (_vala_array_free (_data_->arc_ext, _data_->arc_ext_length1, (GDestroyNotify) g_free), NULL);
#line 678 "../src/data/Runnable.vala"
						_data_->win_exe_ext = (_vala_array_free (_data_->win_exe_ext, _data_->win_exe_ext_length1, (GDestroyNotify) g_free), NULL);
#line 678 "../src/data/Runnable.vala"
						_data_->exe_ext = (_vala_array_free (_data_->exe_ext, _data_->exe_ext_length1, (GDestroyNotify) g_free), NULL);
#line 678 "../src/data/Runnable.vala"
						_data_->gog_part_ext = (_vala_array_free (_data_->gog_part_ext, _data_->gog_part_ext_length1, (GDestroyNotify) g_free), NULL);
#line 678 "../src/data/Runnable.vala"
						_g_free0 (_data_->info);
#line 678 "../src/data/Runnable.vala"
						_g_free0 (_data_->mime);
#line 678 "../src/data/Runnable.vala"
						_g_object_unref0 (_data_->finfo);
#line 678 "../src/data/Runnable.vala"
						g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 678 "../src/data/Runnable.vala"
						if (_data_->_state_ != 0) {
#line 678 "../src/data/Runnable.vala"
							while (!_data_->_task_complete_) {
#line 678 "../src/data/Runnable.vala"
								g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7441 "Runnable.c"
							}
						}
#line 678 "../src/data/Runnable.vala"
						g_object_unref (_data_->_async_result);
#line 678 "../src/data/Runnable.vala"
						return FALSE;
#line 7448 "Runnable.c"
					}
#line 676 "../src/data/Runnable.vala"
					_g_free0 (_data_->_vala1_ext);
#line 7452 "Runnable.c"
				}
			}
		}
#line 680 "../src/data/Runnable.vala"
		_data_->_tmp73_ = _data_->win_exe_ext;
#line 680 "../src/data/Runnable.vala"
		_data_->_tmp73__length1 = _data_->win_exe_ext_length1;
#line 7460 "Runnable.c"
		{
#line 680 "../src/data/Runnable.vala"
			_data_->_vala2_ext_collection_length1 = 0;
#line 680 "../src/data/Runnable.vala"
			_data_->__vala2_ext_collection_size_ = 0;
#line 680 "../src/data/Runnable.vala"
			_data_->_vala2_ext_collection = _data_->_tmp73_;
#line 680 "../src/data/Runnable.vala"
			_data_->_vala2_ext_collection_length1 = _data_->_tmp73__length1;
#line 680 "../src/data/Runnable.vala"
			for (_data_->_vala2_ext_it = 0; _data_->_vala2_ext_it < _data_->_vala2_ext_collection_length1; _data_->_vala2_ext_it = _data_->_vala2_ext_it + 1) {
#line 680 "../src/data/Runnable.vala"
				_data_->_tmp74_ = g_strdup (_data_->_vala2_ext_collection[_data_->_vala2_ext_it]);
#line 680 "../src/data/Runnable.vala"
				_data_->_vala2_ext = _data_->_tmp74_;
#line 7476 "Runnable.c"
				{
#line 682 "../src/data/Runnable.vala"
					_data_->_tmp75_ = g_file_get_basename (_data_->file);
#line 682 "../src/data/Runnable.vala"
					_data_->_tmp76_ = _data_->_tmp75_;
#line 682 "../src/data/Runnable.vala"
					_data_->_tmp77_ = g_utf8_strdown (_data_->_tmp76_, (gssize) -1);
#line 682 "../src/data/Runnable.vala"
					_data_->_tmp78_ = _data_->_tmp77_;
#line 682 "../src/data/Runnable.vala"
					_data_->_tmp79_ = _data_->_vala2_ext;
#line 682 "../src/data/Runnable.vala"
					_data_->_tmp80_ = string_to_string (_data_->_tmp79_);
#line 682 "../src/data/Runnable.vala"
					_data_->_tmp81_ = g_strconcat (".", _data_->_tmp80_, NULL);
#line 682 "../src/data/Runnable.vala"
					_data_->_tmp82_ = _data_->_tmp81_;
#line 682 "../src/data/Runnable.vala"
					_data_->_tmp83_ = g_str_has_suffix (_data_->_tmp78_, _data_->_tmp82_);
#line 682 "../src/data/Runnable.vala"
					_g_free0 (_data_->_tmp82_);
#line 682 "../src/data/Runnable.vala"
					_g_free0 (_data_->_tmp78_);
#line 682 "../src/data/Runnable.vala"
					_g_free0 (_data_->_tmp76_);
#line 682 "../src/data/Runnable.vala"
					if (_data_->_tmp83_) {
#line 682 "../src/data/Runnable.vala"
						_data_->result = GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_EXECUTABLE;
#line 682 "../src/data/Runnable.vala"
						_g_free0 (_data_->_vala2_ext);
#line 682 "../src/data/Runnable.vala"
						_data_->arc_ext = (_vala_array_free (_data_->arc_ext, _data_->arc_ext_length1, (GDestroyNotify) g_free), NULL);
#line 682 "../src/data/Runnable.vala"
						_data_->win_exe_ext = (_vala_array_free (_data_->win_exe_ext, _data_->win_exe_ext_length1, (GDestroyNotify) g_free), NULL);
#line 682 "../src/data/Runnable.vala"
						_data_->exe_ext = (_vala_array_free (_data_->exe_ext, _data_->exe_ext_length1, (GDestroyNotify) g_free), NULL);
#line 682 "../src/data/Runnable.vala"
						_data_->gog_part_ext = (_vala_array_free (_data_->gog_part_ext, _data_->gog_part_ext_length1, (GDestroyNotify) g_free), NULL);
#line 682 "../src/data/Runnable.vala"
						_g_free0 (_data_->info);
#line 682 "../src/data/Runnable.vala"
						_g_free0 (_data_->mime);
#line 682 "../src/data/Runnable.vala"
						_g_object_unref0 (_data_->finfo);
#line 682 "../src/data/Runnable.vala"
						g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 682 "../src/data/Runnable.vala"
						if (_data_->_state_ != 0) {
#line 682 "../src/data/Runnable.vala"
							while (!_data_->_task_complete_) {
#line 682 "../src/data/Runnable.vala"
								g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7530 "Runnable.c"
							}
						}
#line 682 "../src/data/Runnable.vala"
						g_object_unref (_data_->_async_result);
#line 682 "../src/data/Runnable.vala"
						return FALSE;
#line 7537 "Runnable.c"
					}
#line 680 "../src/data/Runnable.vala"
					_g_free0 (_data_->_vala2_ext);
#line 7541 "Runnable.c"
				}
			}
		}
#line 684 "../src/data/Runnable.vala"
		_data_->_tmp84_ = _data_->arc_ext;
#line 684 "../src/data/Runnable.vala"
		_data_->_tmp84__length1 = _data_->arc_ext_length1;
#line 7549 "Runnable.c"
		{
#line 684 "../src/data/Runnable.vala"
			_data_->_vala3_ext_collection_length1 = 0;
#line 684 "../src/data/Runnable.vala"
			_data_->__vala3_ext_collection_size_ = 0;
#line 684 "../src/data/Runnable.vala"
			_data_->_vala3_ext_collection = _data_->_tmp84_;
#line 684 "../src/data/Runnable.vala"
			_data_->_vala3_ext_collection_length1 = _data_->_tmp84__length1;
#line 684 "../src/data/Runnable.vala"
			for (_data_->_vala3_ext_it = 0; _data_->_vala3_ext_it < _data_->_vala3_ext_collection_length1; _data_->_vala3_ext_it = _data_->_vala3_ext_it + 1) {
#line 684 "../src/data/Runnable.vala"
				_data_->_tmp85_ = g_strdup (_data_->_vala3_ext_collection[_data_->_vala3_ext_it]);
#line 684 "../src/data/Runnable.vala"
				_data_->_vala3_ext = _data_->_tmp85_;
#line 7565 "Runnable.c"
				{
#line 686 "../src/data/Runnable.vala"
					_data_->_tmp86_ = g_file_get_basename (_data_->file);
#line 686 "../src/data/Runnable.vala"
					_data_->_tmp87_ = _data_->_tmp86_;
#line 686 "../src/data/Runnable.vala"
					_data_->_tmp88_ = g_utf8_strdown (_data_->_tmp87_, (gssize) -1);
#line 686 "../src/data/Runnable.vala"
					_data_->_tmp89_ = _data_->_tmp88_;
#line 686 "../src/data/Runnable.vala"
					_data_->_tmp90_ = _data_->_vala3_ext;
#line 686 "../src/data/Runnable.vala"
					_data_->_tmp91_ = string_to_string (_data_->_tmp90_);
#line 686 "../src/data/Runnable.vala"
					_data_->_tmp92_ = g_strconcat (".", _data_->_tmp91_, NULL);
#line 686 "../src/data/Runnable.vala"
					_data_->_tmp93_ = _data_->_tmp92_;
#line 686 "../src/data/Runnable.vala"
					_data_->_tmp94_ = g_str_has_suffix (_data_->_tmp89_, _data_->_tmp93_);
#line 686 "../src/data/Runnable.vala"
					_g_free0 (_data_->_tmp93_);
#line 686 "../src/data/Runnable.vala"
					_g_free0 (_data_->_tmp89_);
#line 686 "../src/data/Runnable.vala"
					_g_free0 (_data_->_tmp87_);
#line 686 "../src/data/Runnable.vala"
					if (_data_->_tmp94_) {
#line 686 "../src/data/Runnable.vala"
						_data_->result = GAME_HUB_DATA_RUNNABLE_INSTALLER_INSTALLER_TYPE_ARCHIVE;
#line 686 "../src/data/Runnable.vala"
						_g_free0 (_data_->_vala3_ext);
#line 686 "../src/data/Runnable.vala"
						_data_->arc_ext = (_vala_array_free (_data_->arc_ext, _data_->arc_ext_length1, (GDestroyNotify) g_free), NULL);
#line 686 "../src/data/Runnable.vala"
						_data_->win_exe_ext = (_vala_array_free (_data_->win_exe_ext, _data_->win_exe_ext_length1, (GDestroyNotify) g_free), NULL);
#line 686 "../src/data/Runnable.vala"
						_data_->exe_ext = (_vala_array_free (_data_->exe_ext, _data_->exe_ext_length1, (GDestroyNotify) g_free), NULL);
#line 686 "../src/data/Runnable.vala"
						_data_->gog_part_ext = (_vala_array_free (_data_->gog_part_ext, _data_->gog_part_ext_length1, (GDestroyNotify) g_free), NULL);
#line 686 "../src/data/Runnable.vala"
						_g_free0 (_data_->info);
#line 686 "../src/data/Runnable.vala"
						_g_free0 (_data_->mime);
#line 686 "../src/data/Runnable.vala"
						_g_object_unref0 (_data_->finfo);
#line 686 "../src/data/Runnable.vala"
						g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 686 "../src/data/Runnable.vala"
						if (_data_->_state_ != 0) {
#line 686 "../src/data/Runnable.vala"
							while (!_data_->_task_complete_) {
#line 686 "../src/data/Runnable.vala"
								g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7619 "Runnable.c"
							}
						}
#line 686 "../src/data/Runnable.vala"
						g_object_unref (_data_->_async_result);
#line 686 "../src/data/Runnable.vala"
						return FALSE;
#line 7626 "Runnable.c"
					}
#line 684 "../src/data/Runnable.vala"
					_g_free0 (_data_->_vala3_ext);
#line 7630 "Runnable.c"
				}
			}
		}
#line 643 "../src/data/Runnable.vala"
		_data_->arc_ext = (_vala_array_free (_data_->arc_ext, _data_->arc_ext_length1, (GDestroyNotify) g_free), NULL);
#line 643 "../src/data/Runnable.vala"
		_data_->win_exe_ext = (_vala_array_free (_data_->win_exe_ext, _data_->win_exe_ext_length1, (GDestroyNotify) g_free), NULL);
#line 643 "../src/data/Runnable.vala"
		_data_->exe_ext = (_vala_array_free (_data_->exe_ext, _data_->exe_ext_length1, (GDestroyNotify) g_free), NULL);
#line 643 "../src/data/Runnable.vala"
		_data_->gog_part_ext = (_vala_array_free (_data_->gog_part_ext, _data_->gog_part_ext_length1, (GDestroyNotify) g_free), NULL);
#line 643 "../src/data/Runnable.vala"
		_g_free0 (_data_->info);
#line 643 "../src/data/Runnable.vala"
		_g_free0 (_data_->mime);
#line 643 "../src/data/Runnable.vala"
		_g_object_unref0 (_data_->finfo);
#line 7648 "Runnable.c"
	}
	goto __finally7;
	__catch7_g_error:
	{
#line 643 "../src/data/Runnable.vala"
		_data_->e = _data_->_inner_error0_;
#line 643 "../src/data/Runnable.vala"
		_data_->_inner_error0_ = NULL;
#line 643 "../src/data/Runnable.vala"
		_g_error_free0 (_data_->e);
#line 7659 "Runnable.c"
	}
	__finally7:
#line 643 "../src/data/Runnable.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 643 "../src/data/Runnable.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 643 "../src/data/Runnable.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 643 "../src/data/Runnable.vala"
		g_object_unref (_data_->_async_result);
#line 643 "../src/data/Runnable.vala"
		return FALSE;
#line 7672 "Runnable.c"
	}
#line 691 "../src/data/Runnable.vala"
	_data_->result = _data_->type;
#line 691 "../src/data/Runnable.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 691 "../src/data/Runnable.vala"
	if (_data_->_state_ != 0) {
#line 691 "../src/data/Runnable.vala"
		while (!_data_->_task_complete_) {
#line 691 "../src/data/Runnable.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7684 "Runnable.c"
		}
	}
#line 691 "../src/data/Runnable.vala"
	g_object_unref (_data_->_async_result);
#line 691 "../src/data/Runnable.vala"
	return FALSE;
#line 7691 "Runnable.c"
}

GameHubDataRunnableInstaller*
game_hub_data_runnable_installer_construct (GType object_type)
{
	GameHubDataRunnableInstaller* self = NULL;
#line 321 "../src/data/Runnable.vala"
	self = (GameHubDataRunnableInstaller*) g_type_create_instance (object_type);
#line 321 "../src/data/Runnable.vala"
	return self;
#line 7702 "Runnable.c"
}

const gchar*
game_hub_data_runnable_installer_get_id (GameHubDataRunnableInstaller* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 356 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 356 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_id;
#line 356 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 356 "../src/data/Runnable.vala"
	return result;
#line 7718 "Runnable.c"
}

void
game_hub_data_runnable_installer_set_id (GameHubDataRunnableInstaller* self,
                                         const gchar* value)
{
	gchar* _tmp0_;
#line 356 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 356 "../src/data/Runnable.vala"
	_tmp0_ = g_strdup (value);
#line 356 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_id);
#line 356 "../src/data/Runnable.vala"
	self->priv->_id = _tmp0_;
#line 7734 "Runnable.c"
}

GameHubDataPlatform
game_hub_data_runnable_installer_get_platform (GameHubDataRunnableInstaller* self)
{
	GameHubDataPlatform result;
	GameHubDataPlatform _tmp0_;
#line 357 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 357 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_platform;
#line 357 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 357 "../src/data/Runnable.vala"
	return result;
#line 7750 "Runnable.c"
}

void
game_hub_data_runnable_installer_set_platform (GameHubDataRunnableInstaller* self,
                                               GameHubDataPlatform value)
{
#line 357 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 357 "../src/data/Runnable.vala"
	self->priv->_platform = value;
#line 7761 "Runnable.c"
}

GeeArrayList*
game_hub_data_runnable_installer_get_parts (GameHubDataRunnableInstaller* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 358 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 358 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_parts;
#line 358 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 358 "../src/data/Runnable.vala"
	return result;
#line 7777 "Runnable.c"
}

void
game_hub_data_runnable_installer_set_parts (GameHubDataRunnableInstaller* self,
                                            GeeArrayList* value)
{
	GeeArrayList* _tmp0_;
#line 358 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 358 "../src/data/Runnable.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 358 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_parts);
#line 358 "../src/data/Runnable.vala"
	self->priv->_parts = _tmp0_;
#line 7793 "Runnable.c"
}

gint64
game_hub_data_runnable_installer_get_full_size (GameHubDataRunnableInstaller* self)
{
	gint64 result;
#line 359 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 359 "../src/data/Runnable.vala"
	result = self->priv->_full_size;
#line 359 "../src/data/Runnable.vala"
	return result;
#line 7806 "Runnable.c"
}

void
game_hub_data_runnable_installer_set_full_size (GameHubDataRunnableInstaller* self,
                                                gint64 value)
{
#line 359 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 359 "../src/data/Runnable.vala"
	self->priv->_full_size = value;
#line 7817 "Runnable.c"
}

const gchar*
game_hub_data_runnable_installer_get_version (GameHubDataRunnableInstaller* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 360 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 360 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_version;
#line 360 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 360 "../src/data/Runnable.vala"
	return result;
#line 7833 "Runnable.c"
}

void
game_hub_data_runnable_installer_set_version (GameHubDataRunnableInstaller* self,
                                              const gchar* value)
{
	gchar* _tmp0_;
#line 360 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 360 "../src/data/Runnable.vala"
	_tmp0_ = g_strdup (value);
#line 360 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_version);
#line 360 "../src/data/Runnable.vala"
	self->priv->_version = _tmp0_;
#line 7849 "Runnable.c"
}

gchar*
game_hub_data_runnable_installer_get_name (GameHubDataRunnableInstaller* self)
{
#line 362 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 362 "../src/data/Runnable.vala"
	return GAME_HUB_DATA_RUNNABLE_INSTALLER_GET_CLASS (self)->get_name (self);
#line 7859 "Runnable.c"
}

static gchar*
game_hub_data_runnable_installer_real_get_name (GameHubDataRunnableInstaller* base)
{
	gchar* result;
	GameHubDataRunnableInstaller* self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 362 "../src/data/Runnable.vala"
	self = base;
#line 362 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_id;
#line 362 "../src/data/Runnable.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 362 "../src/data/Runnable.vala"
	result = _tmp1_;
#line 362 "../src/data/Runnable.vala"
	return result;
#line 7879 "Runnable.c"
}

static inline gpointer
game_hub_data_runnable_installer_part_get_instance_private (GameHubDataRunnableInstallerPart* self)
{
	return G_STRUCT_MEMBER_P (self, GameHubDataRunnableInstallerPart_private_offset);
}

GameHubDataRunnableInstallerPart*
game_hub_data_runnable_installer_part_construct (GType object_type,
                                                 const gchar* id,
                                                 const gchar* url,
                                                 gint64 size,
                                                 GFile* remote,
                                                 GFile* local,
                                                 const gchar* checksum,
                                                 GChecksumType checksum_type)
{
	GameHubDataRunnableInstallerPart * self = NULL;
#line 334 "../src/data/Runnable.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 334 "../src/data/Runnable.vala"
	g_return_val_if_fail (url != NULL, NULL);
#line 334 "../src/data/Runnable.vala"
	g_return_val_if_fail (remote != NULL, NULL);
#line 334 "../src/data/Runnable.vala"
	g_return_val_if_fail (local != NULL, NULL);
#line 336 "../src/data/Runnable.vala"
	self = (GameHubDataRunnableInstallerPart*) g_object_new (object_type, "id", id, "url", url, "size", size, "remote", remote, "local", local, "checksum", checksum, "checksum-type", checksum_type, NULL);
#line 334 "../src/data/Runnable.vala"
	return self;
#line 7911 "Runnable.c"
}

GameHubDataRunnableInstallerPart*
game_hub_data_runnable_installer_part_new (const gchar* id,
                                           const gchar* url,
                                           gint64 size,
                                           GFile* remote,
                                           GFile* local,
                                           const gchar* checksum,
                                           GChecksumType checksum_type)
{
#line 334 "../src/data/Runnable.vala"
	return game_hub_data_runnable_installer_part_construct (GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_PART, id, url, size, remote, local, checksum, checksum_type);
#line 7925 "Runnable.c"
}

const gchar*
game_hub_data_runnable_installer_part_get_id (GameHubDataRunnableInstallerPart* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 327 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 327 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_id;
#line 327 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 327 "../src/data/Runnable.vala"
	return result;
#line 7941 "Runnable.c"
}

void
game_hub_data_runnable_installer_part_set_id (GameHubDataRunnableInstallerPart* self,
                                              const gchar* value)
{
#line 327 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 327 "../src/data/Runnable.vala"
	if (g_strcmp0 (value, game_hub_data_runnable_installer_part_get_id (self)) != 0) {
#line 7952 "Runnable.c"
		gchar* _tmp0_;
#line 327 "../src/data/Runnable.vala"
		_tmp0_ = g_strdup (value);
#line 327 "../src/data/Runnable.vala"
		_g_free0 (self->priv->_id);
#line 327 "../src/data/Runnable.vala"
		self->priv->_id = _tmp0_;
#line 327 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_ID_PROPERTY]);
#line 7962 "Runnable.c"
	}
}

const gchar*
game_hub_data_runnable_installer_part_get_url (GameHubDataRunnableInstallerPart* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 328 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 328 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_url;
#line 328 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 328 "../src/data/Runnable.vala"
	return result;
#line 7979 "Runnable.c"
}

void
game_hub_data_runnable_installer_part_set_url (GameHubDataRunnableInstallerPart* self,
                                               const gchar* value)
{
#line 328 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 328 "../src/data/Runnable.vala"
	if (g_strcmp0 (value, game_hub_data_runnable_installer_part_get_url (self)) != 0) {
#line 7990 "Runnable.c"
		gchar* _tmp0_;
#line 328 "../src/data/Runnable.vala"
		_tmp0_ = g_strdup (value);
#line 328 "../src/data/Runnable.vala"
		_g_free0 (self->priv->_url);
#line 328 "../src/data/Runnable.vala"
		self->priv->_url = _tmp0_;
#line 328 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_URL_PROPERTY]);
#line 8000 "Runnable.c"
	}
}

gint64
game_hub_data_runnable_installer_part_get_size (GameHubDataRunnableInstallerPart* self)
{
	gint64 result;
#line 329 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 329 "../src/data/Runnable.vala"
	result = self->priv->_size;
#line 329 "../src/data/Runnable.vala"
	return result;
#line 8014 "Runnable.c"
}

void
game_hub_data_runnable_installer_part_set_size (GameHubDataRunnableInstallerPart* self,
                                                gint64 value)
{
#line 329 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 329 "../src/data/Runnable.vala"
	if (game_hub_data_runnable_installer_part_get_size (self) != value) {
#line 329 "../src/data/Runnable.vala"
		self->priv->_size = value;
#line 329 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_SIZE_PROPERTY]);
#line 8029 "Runnable.c"
	}
}

GFile*
game_hub_data_runnable_installer_part_get_remote (GameHubDataRunnableInstallerPart* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 330 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 330 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_remote;
#line 330 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 330 "../src/data/Runnable.vala"
	return result;
#line 8046 "Runnable.c"
}

void
game_hub_data_runnable_installer_part_set_remote (GameHubDataRunnableInstallerPart* self,
                                                  GFile* value)
{
#line 330 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 330 "../src/data/Runnable.vala"
	if (game_hub_data_runnable_installer_part_get_remote (self) != value) {
#line 8057 "Runnable.c"
		GFile* _tmp0_;
#line 330 "../src/data/Runnable.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 330 "../src/data/Runnable.vala"
		_g_object_unref0 (self->priv->_remote);
#line 330 "../src/data/Runnable.vala"
		self->priv->_remote = _tmp0_;
#line 330 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_REMOTE_PROPERTY]);
#line 8067 "Runnable.c"
	}
}

GFile*
game_hub_data_runnable_installer_part_get_local (GameHubDataRunnableInstallerPart* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 331 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 331 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_local;
#line 331 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 331 "../src/data/Runnable.vala"
	return result;
#line 8084 "Runnable.c"
}

void
game_hub_data_runnable_installer_part_set_local (GameHubDataRunnableInstallerPart* self,
                                                 GFile* value)
{
#line 331 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 331 "../src/data/Runnable.vala"
	if (game_hub_data_runnable_installer_part_get_local (self) != value) {
#line 8095 "Runnable.c"
		GFile* _tmp0_;
#line 331 "../src/data/Runnable.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 331 "../src/data/Runnable.vala"
		_g_object_unref0 (self->priv->_local);
#line 331 "../src/data/Runnable.vala"
		self->priv->_local = _tmp0_;
#line 331 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_LOCAL_PROPERTY]);
#line 8105 "Runnable.c"
	}
}

const gchar*
game_hub_data_runnable_installer_part_get_checksum (GameHubDataRunnableInstallerPart* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 332 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 332 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_checksum;
#line 332 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 332 "../src/data/Runnable.vala"
	return result;
#line 8122 "Runnable.c"
}

void
game_hub_data_runnable_installer_part_set_checksum (GameHubDataRunnableInstallerPart* self,
                                                    const gchar* value)
{
#line 332 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 332 "../src/data/Runnable.vala"
	if (g_strcmp0 (value, game_hub_data_runnable_installer_part_get_checksum (self)) != 0) {
#line 8133 "Runnable.c"
		gchar* _tmp0_;
#line 332 "../src/data/Runnable.vala"
		_tmp0_ = g_strdup (value);
#line 332 "../src/data/Runnable.vala"
		_g_free0 (self->priv->_checksum);
#line 332 "../src/data/Runnable.vala"
		self->priv->_checksum = _tmp0_;
#line 332 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_CHECKSUM_PROPERTY]);
#line 8143 "Runnable.c"
	}
}

GChecksumType
game_hub_data_runnable_installer_part_get_checksum_type (GameHubDataRunnableInstallerPart* self)
{
	GChecksumType result;
	GChecksumType _tmp0_;
#line 333 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 333 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_checksum_type;
#line 333 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 333 "../src/data/Runnable.vala"
	return result;
#line 8160 "Runnable.c"
}

void
game_hub_data_runnable_installer_part_set_checksum_type (GameHubDataRunnableInstallerPart* self,
                                                         GChecksumType value)
{
#line 333 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 333 "../src/data/Runnable.vala"
	if (game_hub_data_runnable_installer_part_get_checksum_type (self) != value) {
#line 333 "../src/data/Runnable.vala"
		self->priv->_checksum_type = value;
#line 333 "../src/data/Runnable.vala"
		g_object_notify_by_pspec ((GObject *) self, game_hub_data_runnable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_CHECKSUM_TYPE_PROPERTY]);
#line 8175 "Runnable.c"
	}
}

const gchar*
game_hub_data_runnable_installer_part_get_checksum_type_string (GameHubDataRunnableInstallerPart* self)
{
	const gchar* result;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	GChecksumType _tmp5_;
#line 340 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 342 "../src/data/Runnable.vala"
	_tmp1_ = self->priv->_checksum;
#line 342 "../src/data/Runnable.vala"
	if (_tmp1_ == NULL) {
#line 342 "../src/data/Runnable.vala"
		_tmp0_ = TRUE;
#line 8194 "Runnable.c"
	} else {
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 342 "../src/data/Runnable.vala"
		_tmp2_ = self->priv->_checksum;
#line 342 "../src/data/Runnable.vala"
		_tmp3_ = strlen (_tmp2_);
#line 342 "../src/data/Runnable.vala"
		_tmp4_ = _tmp3_;
#line 342 "../src/data/Runnable.vala"
		_tmp0_ = _tmp4_ == 0;
#line 8207 "Runnable.c"
	}
#line 342 "../src/data/Runnable.vala"
	if (_tmp0_) {
#line 342 "../src/data/Runnable.vala"
		result = NULL;
#line 342 "../src/data/Runnable.vala"
		return result;
#line 8215 "Runnable.c"
	}
#line 343 "../src/data/Runnable.vala"
	_tmp5_ = self->priv->_checksum_type;
#line 343 "../src/data/Runnable.vala"
	switch (_tmp5_) {
#line 343 "../src/data/Runnable.vala"
		case G_CHECKSUM_MD5:
#line 8223 "Runnable.c"
		{
#line 345 "../src/data/Runnable.vala"
			result = "md5";
#line 345 "../src/data/Runnable.vala"
			return result;
#line 8229 "Runnable.c"
		}
#line 343 "../src/data/Runnable.vala"
		case G_CHECKSUM_SHA1:
#line 8233 "Runnable.c"
		{
#line 346 "../src/data/Runnable.vala"
			result = "sha1";
#line 346 "../src/data/Runnable.vala"
			return result;
#line 8239 "Runnable.c"
		}
#line 343 "../src/data/Runnable.vala"
		case G_CHECKSUM_SHA256:
#line 8243 "Runnable.c"
		{
#line 347 "../src/data/Runnable.vala"
			result = "sha256";
#line 347 "../src/data/Runnable.vala"
			return result;
#line 8249 "Runnable.c"
		}
#line 343 "../src/data/Runnable.vala"
		case G_CHECKSUM_SHA384:
#line 8253 "Runnable.c"
		{
#line 348 "../src/data/Runnable.vala"
			result = "sha384";
#line 348 "../src/data/Runnable.vala"
			return result;
#line 8259 "Runnable.c"
		}
#line 343 "../src/data/Runnable.vala"
		case G_CHECKSUM_SHA512:
#line 8263 "Runnable.c"
		{
#line 349 "../src/data/Runnable.vala"
			result = "sha512";
#line 349 "../src/data/Runnable.vala"
			return result;
#line 8269 "Runnable.c"
		}
		default:
#line 343 "../src/data/Runnable.vala"
		break;
#line 8274 "Runnable.c"
	}
#line 351 "../src/data/Runnable.vala"
	result = NULL;
#line 351 "../src/data/Runnable.vala"
	return result;
#line 8280 "Runnable.c"
}

static void
game_hub_data_runnable_installer_part_class_init (GameHubDataRunnableInstallerPartClass * klass,
                                                  gpointer klass_data)
{
#line 325 "../src/data/Runnable.vala"
	game_hub_data_runnable_installer_part_parent_class = g_type_class_peek_parent (klass);
#line 325 "../src/data/Runnable.vala"
	g_type_class_adjust_private_offset (klass, &GameHubDataRunnableInstallerPart_private_offset);
#line 325 "../src/data/Runnable.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_hub_data_runnable_installer_part_get_property;
#line 325 "../src/data/Runnable.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_hub_data_runnable_installer_part_set_property;
#line 325 "../src/data/Runnable.vala"
	G_OBJECT_CLASS (klass)->finalize = game_hub_data_runnable_installer_part_finalize;
#line 325 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_ID_PROPERTY, game_hub_data_runnable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 325 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_URL_PROPERTY, game_hub_data_runnable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_URL_PROPERTY] = g_param_spec_string ("url", "url", "url", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 325 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_SIZE_PROPERTY, game_hub_data_runnable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_SIZE_PROPERTY] = g_param_spec_int64 ("size", "size", "size", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 325 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_REMOTE_PROPERTY, game_hub_data_runnable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_REMOTE_PROPERTY] = g_param_spec_object ("remote", "remote", "remote", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 325 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_LOCAL_PROPERTY, game_hub_data_runnable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_LOCAL_PROPERTY] = g_param_spec_object ("local", "local", "local", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 325 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_CHECKSUM_PROPERTY, game_hub_data_runnable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_CHECKSUM_PROPERTY] = g_param_spec_string ("checksum", "checksum", "checksum", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 325 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_CHECKSUM_TYPE_PROPERTY, game_hub_data_runnable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_CHECKSUM_TYPE_PROPERTY] = g_param_spec_int ("checksum-type", "checksum-type", "checksum-type", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 325 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_CHECKSUM_TYPE_STRING_PROPERTY, game_hub_data_runnable_installer_part_properties[GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_CHECKSUM_TYPE_STRING_PROPERTY] = g_param_spec_string ("checksum-type-string", "checksum-type-string", "checksum-type-string", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8313 "Runnable.c"
}

static void
game_hub_data_runnable_installer_part_instance_init (GameHubDataRunnableInstallerPart * self,
                                                     gpointer klass)
{
#line 325 "../src/data/Runnable.vala"
	self->priv = game_hub_data_runnable_installer_part_get_instance_private (self);
#line 8322 "Runnable.c"
}

static void
game_hub_data_runnable_installer_part_finalize (GObject * obj)
{
	GameHubDataRunnableInstallerPart * self;
#line 325 "../src/data/Runnable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_PART, GameHubDataRunnableInstallerPart);
#line 327 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_id);
#line 328 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_url);
#line 330 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_remote);
#line 331 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_local);
#line 332 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_checksum);
#line 325 "../src/data/Runnable.vala"
	G_OBJECT_CLASS (game_hub_data_runnable_installer_part_parent_class)->finalize (obj);
#line 8343 "Runnable.c"
}

GType
game_hub_data_runnable_installer_part_get_type (void)
{
	static volatile gsize game_hub_data_runnable_installer_part_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_runnable_installer_part_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameHubDataRunnableInstallerPartClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_runnable_installer_part_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataRunnableInstallerPart), 0, (GInstanceInitFunc) game_hub_data_runnable_installer_part_instance_init, NULL };
		GType game_hub_data_runnable_installer_part_type_id;
		game_hub_data_runnable_installer_part_type_id = g_type_register_static (G_TYPE_OBJECT, "GameHubDataRunnableInstallerPart", &g_define_type_info, 0);
		GameHubDataRunnableInstallerPart_private_offset = g_type_add_instance_private (game_hub_data_runnable_installer_part_type_id, sizeof (GameHubDataRunnableInstallerPartPrivate));
		g_once_init_leave (&game_hub_data_runnable_installer_part_type_id__volatile, game_hub_data_runnable_installer_part_type_id);
	}
	return game_hub_data_runnable_installer_part_type_id__volatile;
}

static void
_vala_game_hub_data_runnable_installer_part_get_property (GObject * object,
                                                          guint property_id,
                                                          GValue * value,
                                                          GParamSpec * pspec)
{
	GameHubDataRunnableInstallerPart * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_PART, GameHubDataRunnableInstallerPart);
#line 325 "../src/data/Runnable.vala"
	switch (property_id) {
#line 325 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_ID_PROPERTY:
#line 325 "../src/data/Runnable.vala"
		g_value_set_string (value, game_hub_data_runnable_installer_part_get_id (self));
#line 325 "../src/data/Runnable.vala"
		break;
#line 325 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_URL_PROPERTY:
#line 325 "../src/data/Runnable.vala"
		g_value_set_string (value, game_hub_data_runnable_installer_part_get_url (self));
#line 325 "../src/data/Runnable.vala"
		break;
#line 325 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_SIZE_PROPERTY:
#line 325 "../src/data/Runnable.vala"
		g_value_set_int64 (value, game_hub_data_runnable_installer_part_get_size (self));
#line 325 "../src/data/Runnable.vala"
		break;
#line 325 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_REMOTE_PROPERTY:
#line 325 "../src/data/Runnable.vala"
		g_value_set_object (value, game_hub_data_runnable_installer_part_get_remote (self));
#line 325 "../src/data/Runnable.vala"
		break;
#line 325 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_LOCAL_PROPERTY:
#line 325 "../src/data/Runnable.vala"
		g_value_set_object (value, game_hub_data_runnable_installer_part_get_local (self));
#line 325 "../src/data/Runnable.vala"
		break;
#line 325 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_CHECKSUM_PROPERTY:
#line 325 "../src/data/Runnable.vala"
		g_value_set_string (value, game_hub_data_runnable_installer_part_get_checksum (self));
#line 325 "../src/data/Runnable.vala"
		break;
#line 325 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_CHECKSUM_TYPE_PROPERTY:
#line 325 "../src/data/Runnable.vala"
		g_value_set_int (value, game_hub_data_runnable_installer_part_get_checksum_type (self));
#line 325 "../src/data/Runnable.vala"
		break;
#line 325 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_CHECKSUM_TYPE_STRING_PROPERTY:
#line 325 "../src/data/Runnable.vala"
		g_value_set_string (value, game_hub_data_runnable_installer_part_get_checksum_type_string (self));
#line 325 "../src/data/Runnable.vala"
		break;
#line 8418 "Runnable.c"
		default:
#line 325 "../src/data/Runnable.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 325 "../src/data/Runnable.vala"
		break;
#line 8424 "Runnable.c"
	}
}

static void
_vala_game_hub_data_runnable_installer_part_set_property (GObject * object,
                                                          guint property_id,
                                                          const GValue * value,
                                                          GParamSpec * pspec)
{
	GameHubDataRunnableInstallerPart * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_PART, GameHubDataRunnableInstallerPart);
#line 325 "../src/data/Runnable.vala"
	switch (property_id) {
#line 325 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_ID_PROPERTY:
#line 325 "../src/data/Runnable.vala"
		game_hub_data_runnable_installer_part_set_id (self, g_value_get_string (value));
#line 325 "../src/data/Runnable.vala"
		break;
#line 325 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_URL_PROPERTY:
#line 325 "../src/data/Runnable.vala"
		game_hub_data_runnable_installer_part_set_url (self, g_value_get_string (value));
#line 325 "../src/data/Runnable.vala"
		break;
#line 325 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_SIZE_PROPERTY:
#line 325 "../src/data/Runnable.vala"
		game_hub_data_runnable_installer_part_set_size (self, g_value_get_int64 (value));
#line 325 "../src/data/Runnable.vala"
		break;
#line 325 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_REMOTE_PROPERTY:
#line 325 "../src/data/Runnable.vala"
		game_hub_data_runnable_installer_part_set_remote (self, g_value_get_object (value));
#line 325 "../src/data/Runnable.vala"
		break;
#line 325 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_LOCAL_PROPERTY:
#line 325 "../src/data/Runnable.vala"
		game_hub_data_runnable_installer_part_set_local (self, g_value_get_object (value));
#line 325 "../src/data/Runnable.vala"
		break;
#line 325 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_CHECKSUM_PROPERTY:
#line 325 "../src/data/Runnable.vala"
		game_hub_data_runnable_installer_part_set_checksum (self, g_value_get_string (value));
#line 325 "../src/data/Runnable.vala"
		break;
#line 325 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_INSTALLER_PART_CHECKSUM_TYPE_PROPERTY:
#line 325 "../src/data/Runnable.vala"
		game_hub_data_runnable_installer_part_set_checksum_type (self, g_value_get_int (value));
#line 325 "../src/data/Runnable.vala"
		break;
#line 8480 "Runnable.c"
		default:
#line 325 "../src/data/Runnable.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 325 "../src/data/Runnable.vala"
		break;
#line 8486 "Runnable.c"
	}
}

static void
game_hub_data_runnable_value_installer_init (GValue* value)
{
#line 321 "../src/data/Runnable.vala"
	value->data[0].v_pointer = NULL;
#line 8495 "Runnable.c"
}

static void
game_hub_data_runnable_value_installer_free_value (GValue* value)
{
#line 321 "../src/data/Runnable.vala"
	if (value->data[0].v_pointer) {
#line 321 "../src/data/Runnable.vala"
		game_hub_data_runnable_installer_unref (value->data[0].v_pointer);
#line 8505 "Runnable.c"
	}
}

static void
game_hub_data_runnable_value_installer_copy_value (const GValue* src_value,
                                                   GValue* dest_value)
{
#line 321 "../src/data/Runnable.vala"
	if (src_value->data[0].v_pointer) {
#line 321 "../src/data/Runnable.vala"
		dest_value->data[0].v_pointer = game_hub_data_runnable_installer_ref (src_value->data[0].v_pointer);
#line 8517 "Runnable.c"
	} else {
#line 321 "../src/data/Runnable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 8521 "Runnable.c"
	}
}

static gpointer
game_hub_data_runnable_value_installer_peek_pointer (const GValue* value)
{
#line 321 "../src/data/Runnable.vala"
	return value->data[0].v_pointer;
#line 8530 "Runnable.c"
}

static gchar*
game_hub_data_runnable_value_installer_collect_value (GValue* value,
                                                      guint n_collect_values,
                                                      GTypeCValue* collect_values,
                                                      guint collect_flags)
{
#line 321 "../src/data/Runnable.vala"
	if (collect_values[0].v_pointer) {
#line 8541 "Runnable.c"
		GameHubDataRunnableInstaller * object;
		object = collect_values[0].v_pointer;
#line 321 "../src/data/Runnable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 321 "../src/data/Runnable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8548 "Runnable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 321 "../src/data/Runnable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8552 "Runnable.c"
		}
#line 321 "../src/data/Runnable.vala"
		value->data[0].v_pointer = game_hub_data_runnable_installer_ref (object);
#line 8556 "Runnable.c"
	} else {
#line 321 "../src/data/Runnable.vala"
		value->data[0].v_pointer = NULL;
#line 8560 "Runnable.c"
	}
#line 321 "../src/data/Runnable.vala"
	return NULL;
#line 8564 "Runnable.c"
}

static gchar*
game_hub_data_runnable_value_installer_lcopy_value (const GValue* value,
                                                    guint n_collect_values,
                                                    GTypeCValue* collect_values,
                                                    guint collect_flags)
{
	GameHubDataRunnableInstaller ** object_p;
	object_p = collect_values[0].v_pointer;
#line 321 "../src/data/Runnable.vala"
	if (!object_p) {
#line 321 "../src/data/Runnable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 8579 "Runnable.c"
	}
#line 321 "../src/data/Runnable.vala"
	if (!value->data[0].v_pointer) {
#line 321 "../src/data/Runnable.vala"
		*object_p = NULL;
#line 8585 "Runnable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 321 "../src/data/Runnable.vala"
		*object_p = value->data[0].v_pointer;
#line 8589 "Runnable.c"
	} else {
#line 321 "../src/data/Runnable.vala"
		*object_p = game_hub_data_runnable_installer_ref (value->data[0].v_pointer);
#line 8593 "Runnable.c"
	}
#line 321 "../src/data/Runnable.vala"
	return NULL;
#line 8597 "Runnable.c"
}

GParamSpec*
game_hub_data_runnable_param_spec_installer (const gchar* name,
                                             const gchar* nick,
                                             const gchar* blurb,
                                             GType object_type,
                                             GParamFlags flags)
{
	GameHubDataRunnableParamSpecInstaller* spec;
#line 321 "../src/data/Runnable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER), NULL);
#line 321 "../src/data/Runnable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 321 "../src/data/Runnable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 321 "../src/data/Runnable.vala"
	return G_PARAM_SPEC (spec);
#line 8616 "Runnable.c"
}

gpointer
game_hub_data_runnable_value_get_installer (const GValue* value)
{
#line 321 "../src/data/Runnable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER), NULL);
#line 321 "../src/data/Runnable.vala"
	return value->data[0].v_pointer;
#line 8626 "Runnable.c"
}

void
game_hub_data_runnable_value_set_installer (GValue* value,
                                            gpointer v_object)
{
	GameHubDataRunnableInstaller * old;
#line 321 "../src/data/Runnable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER));
#line 321 "../src/data/Runnable.vala"
	old = value->data[0].v_pointer;
#line 321 "../src/data/Runnable.vala"
	if (v_object) {
#line 321 "../src/data/Runnable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER));
#line 321 "../src/data/Runnable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 321 "../src/data/Runnable.vala"
		value->data[0].v_pointer = v_object;
#line 321 "../src/data/Runnable.vala"
		game_hub_data_runnable_installer_ref (value->data[0].v_pointer);
#line 8648 "Runnable.c"
	} else {
#line 321 "../src/data/Runnable.vala"
		value->data[0].v_pointer = NULL;
#line 8652 "Runnable.c"
	}
#line 321 "../src/data/Runnable.vala"
	if (old) {
#line 321 "../src/data/Runnable.vala"
		game_hub_data_runnable_installer_unref (old);
#line 8658 "Runnable.c"
	}
}

void
game_hub_data_runnable_value_take_installer (GValue* value,
                                             gpointer v_object)
{
	GameHubDataRunnableInstaller * old;
#line 321 "../src/data/Runnable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER));
#line 321 "../src/data/Runnable.vala"
	old = value->data[0].v_pointer;
#line 321 "../src/data/Runnable.vala"
	if (v_object) {
#line 321 "../src/data/Runnable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER));
#line 321 "../src/data/Runnable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 321 "../src/data/Runnable.vala"
		value->data[0].v_pointer = v_object;
#line 8679 "Runnable.c"
	} else {
#line 321 "../src/data/Runnable.vala"
		value->data[0].v_pointer = NULL;
#line 8683 "Runnable.c"
	}
#line 321 "../src/data/Runnable.vala"
	if (old) {
#line 321 "../src/data/Runnable.vala"
		game_hub_data_runnable_installer_unref (old);
#line 8689 "Runnable.c"
	}
}

static void
game_hub_data_runnable_installer_class_init (GameHubDataRunnableInstallerClass * klass,
                                             gpointer klass_data)
{
	gchar* _tmp0_;
#line 321 "../src/data/Runnable.vala"
	game_hub_data_runnable_installer_parent_class = g_type_class_peek_parent (klass);
#line 321 "../src/data/Runnable.vala"
	((GameHubDataRunnableInstallerClass *) klass)->finalize = game_hub_data_runnable_installer_finalize;
#line 321 "../src/data/Runnable.vala"
	g_type_class_adjust_private_offset (klass, &GameHubDataRunnableInstaller_private_offset);
#line 321 "../src/data/Runnable.vala"
	((GameHubDataRunnableInstallerClass *) klass)->fetch_parts = (void (*) (GameHubDataRunnableInstaller*, GAsyncReadyCallback, gpointer)) game_hub_data_runnable_installer_real_fetch_parts;
#line 321 "../src/data/Runnable.vala"
	((GameHubDataRunnableInstallerClass *) klass)->fetch_parts_finish = (void (*) (GameHubDataRunnableInstaller*, GAsyncResult*)) game_hub_data_runnable_installer_real_fetch_parts_finish;
#line 321 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_INSTALLER_CLASS (klass)->get_name = game_hub_data_runnable_installer_real_get_name;
#line 323 "../src/data/Runnable.vala"
	_tmp0_ = g_strdup ("Nullsoft Installer");
#line 323 "../src/data/Runnable.vala"
	game_hub_data_runnable_installer_NSIS_INSTALLER_DESCRIPTION = _tmp0_;
#line 8714 "Runnable.c"
}

static void
game_hub_data_runnable_installer_instance_init (GameHubDataRunnableInstaller * self,
                                                gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 321 "../src/data/Runnable.vala"
	self->priv = game_hub_data_runnable_installer_get_instance_private (self);
#line 357 "../src/data/Runnable.vala"
	self->priv->_platform = GAME_HUB_DATA_PLATFORM_CURRENT;
#line 358 "../src/data/Runnable.vala"
	_tmp0_ = gee_array_list_new (GAME_HUB_DATA_RUNNABLE_INSTALLER_TYPE_PART, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 358 "../src/data/Runnable.vala"
	self->priv->_parts = _tmp0_;
#line 359 "../src/data/Runnable.vala"
	self->priv->_full_size = (gint64) 0;
#line 321 "../src/data/Runnable.vala"
	self->ref_count = 1;
#line 8734 "Runnable.c"
}

static void
game_hub_data_runnable_installer_finalize (GameHubDataRunnableInstaller * obj)
{
	GameHubDataRunnableInstaller * self;
#line 321 "../src/data/Runnable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_RUNNABLE_TYPE_INSTALLER, GameHubDataRunnableInstaller);
#line 321 "../src/data/Runnable.vala"
	g_signal_handlers_destroy (self);
#line 356 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_id);
#line 358 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_parts);
#line 360 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_version);
#line 8751 "Runnable.c"
}

GType
game_hub_data_runnable_installer_get_type (void)
{
	static volatile gsize game_hub_data_runnable_installer_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_runnable_installer_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { game_hub_data_runnable_value_installer_init, game_hub_data_runnable_value_installer_free_value, game_hub_data_runnable_value_installer_copy_value, game_hub_data_runnable_value_installer_peek_pointer, "p", game_hub_data_runnable_value_installer_collect_value, "p", game_hub_data_runnable_value_installer_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GameHubDataRunnableInstallerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_runnable_installer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataRunnableInstaller), 0, (GInstanceInitFunc) game_hub_data_runnable_installer_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType game_hub_data_runnable_installer_type_id;
		game_hub_data_runnable_installer_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GameHubDataRunnableInstaller", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		GameHubDataRunnableInstaller_private_offset = g_type_add_instance_private (game_hub_data_runnable_installer_type_id, sizeof (GameHubDataRunnableInstallerPrivate));
		g_once_init_leave (&game_hub_data_runnable_installer_type_id__volatile, game_hub_data_runnable_installer_type_id);
	}
	return game_hub_data_runnable_installer_type_id__volatile;
}

gpointer
game_hub_data_runnable_installer_ref (gpointer instance)
{
	GameHubDataRunnableInstaller * self;
	self = instance;
#line 321 "../src/data/Runnable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 321 "../src/data/Runnable.vala"
	return instance;
#line 8779 "Runnable.c"
}

void
game_hub_data_runnable_installer_unref (gpointer instance)
{
	GameHubDataRunnableInstaller * self;
	self = instance;
#line 321 "../src/data/Runnable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 321 "../src/data/Runnable.vala"
		GAME_HUB_DATA_RUNNABLE_INSTALLER_GET_CLASS (self)->finalize (self);
#line 321 "../src/data/Runnable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 8793 "Runnable.c"
	}
}

static inline gpointer
game_hub_data_runnable_runnable_action_get_instance_private (GameHubDataRunnableRunnableAction* self)
{
	return G_STRUCT_MEMBER_P (self, GameHubDataRunnableRunnableAction_private_offset);
}

static GType*
_g_type_dup (GType* self)
{
	GType* dup;
#line 772 "../src/data/Runnable.vala"
	dup = g_new0 (GType, 1);
#line 772 "../src/data/Runnable.vala"
	memcpy (dup, self, sizeof (GType));
#line 772 "../src/data/Runnable.vala"
	return dup;
#line 8813 "Runnable.c"
}

static gpointer
__g_type_dup0 (gpointer self)
{
#line 772 "../src/data/Runnable.vala"
	return self ? _g_type_dup (self) : NULL;
#line 8821 "Runnable.c"
}

gboolean
game_hub_data_runnable_runnable_action_is_available (GameHubDataRunnableRunnableAction* self,
                                                     GameHubDataCompatTool* tool)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
	GType t = 0UL;
	GType** _tmp9_;
	gint _tmp9__length1;
	GType** _tmp10_;
	gint _tmp10__length1;
#line 758 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 760 "../src/data/Runnable.vala"
	_tmp1_ = self->priv->_file;
#line 760 "../src/data/Runnable.vala"
	if (_tmp1_ == NULL) {
#line 8842 "Runnable.c"
		const gchar* _tmp2_;
#line 760 "../src/data/Runnable.vala"
		_tmp2_ = self->priv->_uri;
#line 760 "../src/data/Runnable.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 8848 "Runnable.c"
	} else {
#line 760 "../src/data/Runnable.vala"
		_tmp0_ = FALSE;
#line 8852 "Runnable.c"
	}
#line 760 "../src/data/Runnable.vala"
	if (_tmp0_) {
#line 762 "../src/data/Runnable.vala"
		result = TRUE;
#line 762 "../src/data/Runnable.vala"
		return result;
#line 8860 "Runnable.c"
	}
#line 765 "../src/data/Runnable.vala"
	if (tool == NULL) {
#line 8864 "Runnable.c"
		gboolean _tmp3_ = FALSE;
		GType** _tmp4_;
		gint _tmp4__length1;
		GType** _tmp5_;
		gint _tmp5__length1;
#line 767 "../src/data/Runnable.vala"
		_tmp4_ = game_hub_data_runnable_runnable_action_get_compat_tools (self, &_tmp4__length1);
#line 767 "../src/data/Runnable.vala"
		_tmp5_ = _tmp4_;
#line 767 "../src/data/Runnable.vala"
		_tmp5__length1 = _tmp4__length1;
#line 767 "../src/data/Runnable.vala"
		if (_tmp5__length1 == 0) {
#line 767 "../src/data/Runnable.vala"
			_tmp3_ = TRUE;
#line 8880 "Runnable.c"
		} else {
			GType** _tmp6_;
			gint _tmp6__length1;
			GType** _tmp7_;
			gint _tmp7__length1;
			GType* _tmp8_;
#line 767 "../src/data/Runnable.vala"
			_tmp6_ = game_hub_data_runnable_runnable_action_get_compat_tools (self, &_tmp6__length1);
#line 767 "../src/data/Runnable.vala"
			_tmp7_ = _tmp6_;
#line 767 "../src/data/Runnable.vala"
			_tmp7__length1 = _tmp6__length1;
#line 767 "../src/data/Runnable.vala"
			_tmp8_ = _tmp7_[0];
#line 767 "../src/data/Runnable.vala"
			_tmp3_ = _tmp8_ == NULL;
#line 8897 "Runnable.c"
		}
#line 767 "../src/data/Runnable.vala"
		result = _tmp3_;
#line 767 "../src/data/Runnable.vala"
		return result;
#line 8903 "Runnable.c"
	}
#line 770 "../src/data/Runnable.vala"
	t = G_TYPE_FROM_INSTANCE ((GObject*) tool);
#line 772 "../src/data/Runnable.vala"
	_tmp9_ = game_hub_data_runnable_runnable_action_get_compat_tools (self, &_tmp9__length1);
#line 772 "../src/data/Runnable.vala"
	_tmp10_ = _tmp9_;
#line 772 "../src/data/Runnable.vala"
	_tmp10__length1 = _tmp9__length1;
#line 8913 "Runnable.c"
	{
		GType** type_collection = NULL;
		gint type_collection_length1 = 0;
		gint _type_collection_size_ = 0;
		gint type_it = 0;
#line 772 "../src/data/Runnable.vala"
		type_collection = _tmp10_;
#line 772 "../src/data/Runnable.vala"
		type_collection_length1 = _tmp10__length1;
#line 772 "../src/data/Runnable.vala"
		for (type_it = 0; type_it < type_collection_length1; type_it = type_it + 1) {
#line 8925 "Runnable.c"
			GType* _tmp11_;
			GType* type = NULL;
#line 772 "../src/data/Runnable.vala"
			_tmp11_ = __g_type_dup0 (type_collection[type_it]);
#line 772 "../src/data/Runnable.vala"
			type = _tmp11_;
#line 8932 "Runnable.c"
			{
				gboolean _tmp12_ = FALSE;
				GType* _tmp13_;
#line 774 "../src/data/Runnable.vala"
				_tmp13_ = type;
#line 774 "../src/data/Runnable.vala"
				if (_tmp13_ != NULL) {
#line 8940 "Runnable.c"
					GType* _tmp14_;
#line 774 "../src/data/Runnable.vala"
					_tmp14_ = type;
#line 774 "../src/data/Runnable.vala"
					_tmp12_ = g_type_is_a (t, *_tmp14_);
#line 8946 "Runnable.c"
				} else {
#line 774 "../src/data/Runnable.vala"
					_tmp12_ = FALSE;
#line 8950 "Runnable.c"
				}
#line 774 "../src/data/Runnable.vala"
				if (_tmp12_) {
#line 776 "../src/data/Runnable.vala"
					result = TRUE;
#line 776 "../src/data/Runnable.vala"
					_g_free0 (type);
#line 776 "../src/data/Runnable.vala"
					return result;
#line 8960 "Runnable.c"
				}
#line 772 "../src/data/Runnable.vala"
				_g_free0 (type);
#line 8964 "Runnable.c"
			}
		}
	}
#line 780 "../src/data/Runnable.vala"
	result = FALSE;
#line 780 "../src/data/Runnable.vala"
	return result;
#line 8972 "Runnable.c"
}

static void
game_hub_data_runnable_runnable_action_invoke_data_free (gpointer _data)
{
	GameHubDataRunnableRunnableActionInvokeData* _data_;
	_data_ = _data;
#line 745 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->tool);
#line 745 "../src/data/Runnable.vala"
	_game_hub_data_runnable_runnable_action_unref0 (_data_->self);
#line 745 "../src/data/Runnable.vala"
	g_slice_free (GameHubDataRunnableRunnableActionInvokeData, _data_);
#line 8986 "Runnable.c"
}

static void
game_hub_data_runnable_runnable_action_invoke_async_ready_wrapper (GObject *source_object,
                                                                   GAsyncResult *res,
                                                                   void *user_data)
{
	GameHubDataRunnableRunnableActionInvokeData* _task_data_;
#line 745 "../src/data/Runnable.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 745 "../src/data/Runnable.vala"
	if (_task_data_->_callback_ != NULL) {
#line 745 "../src/data/Runnable.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 9001 "Runnable.c"
	}
#line 745 "../src/data/Runnable.vala"
	_task_data_->_task_complete_ = TRUE;
#line 9005 "Runnable.c"
}

static gpointer
_game_hub_data_runnable_runnable_action_ref0 (gpointer self)
{
#line 745 "../src/data/Runnable.vala"
	return self ? game_hub_data_runnable_runnable_action_ref (self) : NULL;
#line 9013 "Runnable.c"
}

void
game_hub_data_runnable_runnable_action_invoke (GameHubDataRunnableRunnableAction* self,
                                               GameHubDataCompatTool* tool,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
	GameHubDataRunnableRunnableActionInvokeData* _data_;
	GameHubDataRunnableRunnableAction* _tmp0_;
	GameHubDataCompatTool* _tmp1_;
#line 745 "../src/data/Runnable.vala"
	_data_ = g_slice_new0 (GameHubDataRunnableRunnableActionInvokeData);
#line 745 "../src/data/Runnable.vala"
	_data_->_callback_ = _callback_;
#line 745 "../src/data/Runnable.vala"
	_data_->_async_result = g_task_new (NULL, NULL, game_hub_data_runnable_runnable_action_invoke_async_ready_wrapper, _user_data_);
#line 745 "../src/data/Runnable.vala"
	if (_callback_ == NULL) {
#line 745 "../src/data/Runnable.vala"
		_data_->_task_complete_ = TRUE;
#line 9035 "Runnable.c"
	}
#line 745 "../src/data/Runnable.vala"
	g_task_set_task_data (_data_->_async_result, _data_, game_hub_data_runnable_runnable_action_invoke_data_free);
#line 745 "../src/data/Runnable.vala"
	_tmp0_ = _game_hub_data_runnable_runnable_action_ref0 (self);
#line 745 "../src/data/Runnable.vala"
	_data_->self = _tmp0_;
#line 745 "../src/data/Runnable.vala"
	_tmp1_ = _g_object_ref0 (tool);
#line 745 "../src/data/Runnable.vala"
	_g_object_unref0 (_data_->tool);
#line 745 "../src/data/Runnable.vala"
	_data_->tool = _tmp1_;
#line 745 "../src/data/Runnable.vala"
	game_hub_data_runnable_runnable_action_invoke_co (_data_);
#line 9051 "Runnable.c"
}

void
game_hub_data_runnable_runnable_action_invoke_finish (GameHubDataRunnableRunnableAction* self,
                                                      GAsyncResult* _res_)
{
	GameHubDataRunnableRunnableActionInvokeData* _data_;
#line 745 "../src/data/Runnable.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 9061 "Runnable.c"
}

static void
game_hub_data_runnable_runnable_action_invoke_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_)
{
	GameHubDataRunnableRunnableActionInvokeData* _data_;
#line 793 "../src/data/Runnable.vala"
	_data_ = _user_data_;
#line 793 "../src/data/Runnable.vala"
	_data_->_source_object_ = source_object;
#line 793 "../src/data/Runnable.vala"
	_data_->_res_ = _res_;
#line 793 "../src/data/Runnable.vala"
	_data_->_task_complete_ = TRUE;
#line 793 "../src/data/Runnable.vala"
	game_hub_data_runnable_runnable_action_invoke_co (_data_);
#line 9080 "Runnable.c"
}

static gboolean
game_hub_data_runnable_runnable_action_invoke_co (GameHubDataRunnableRunnableActionInvokeData* _data_)
{
#line 783 "../src/data/Runnable.vala"
	switch (_data_->_state_) {
#line 783 "../src/data/Runnable.vala"
		case 0:
#line 9090 "Runnable.c"
		goto _state_0;
#line 783 "../src/data/Runnable.vala"
		case 1:
#line 9094 "Runnable.c"
		goto _state_1;
		default:
#line 783 "../src/data/Runnable.vala"
		g_assert_not_reached ();
#line 9099 "Runnable.c"
	}
	_state_0:
#line 785 "../src/data/Runnable.vala"
	_data_->_tmp1_ = _data_->self->priv->_file;
#line 785 "../src/data/Runnable.vala"
	if (_data_->_tmp1_ == NULL) {
#line 785 "../src/data/Runnable.vala"
		_data_->_tmp2_ = _data_->self->priv->_uri;
#line 785 "../src/data/Runnable.vala"
		_data_->_tmp0_ = _data_->_tmp2_ != NULL;
#line 9110 "Runnable.c"
	} else {
#line 785 "../src/data/Runnable.vala"
		_data_->_tmp0_ = FALSE;
#line 9114 "Runnable.c"
	}
#line 785 "../src/data/Runnable.vala"
	if (_data_->_tmp0_) {
#line 787 "../src/data/Runnable.vala"
		_data_->_tmp3_ = _data_->self->priv->_uri;
#line 787 "../src/data/Runnable.vala"
		game_hub_utils_open_uri (_data_->_tmp3_);
#line 788 "../src/data/Runnable.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 788 "../src/data/Runnable.vala"
		if (_data_->_state_ != 0) {
#line 788 "../src/data/Runnable.vala"
			while (!_data_->_task_complete_) {
#line 788 "../src/data/Runnable.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 9130 "Runnable.c"
			}
		}
#line 788 "../src/data/Runnable.vala"
		g_object_unref (_data_->_async_result);
#line 788 "../src/data/Runnable.vala"
		return FALSE;
#line 9137 "Runnable.c"
	}
#line 791 "../src/data/Runnable.vala"
	if (game_hub_data_runnable_runnable_action_is_available (_data_->self, _data_->tool)) {
#line 791 "../src/data/Runnable.vala"
		_data_->_tmp5_ = _data_->self->priv->_runnable;
#line 791 "../src/data/Runnable.vala"
		_data_->_tmp4_ = game_hub_data_compat_tool_can_run_action (_data_->tool, _data_->_tmp5_, _data_->self);
#line 9145 "Runnable.c"
	} else {
#line 791 "../src/data/Runnable.vala"
		_data_->_tmp4_ = FALSE;
#line 9149 "Runnable.c"
	}
#line 791 "../src/data/Runnable.vala"
	if (_data_->_tmp4_) {
#line 793 "../src/data/Runnable.vala"
		_data_->_tmp6_ = _data_->self->priv->_runnable;
#line 793 "../src/data/Runnable.vala"
		_data_->_state_ = 1;
#line 793 "../src/data/Runnable.vala"
		game_hub_data_compat_tool_run_action (_data_->tool, _data_->_tmp6_, _data_->self, game_hub_data_runnable_runnable_action_invoke_ready, _data_);
#line 793 "../src/data/Runnable.vala"
		return FALSE;
#line 9161 "Runnable.c"
		_state_1:
#line 793 "../src/data/Runnable.vala"
		game_hub_data_compat_tool_run_action_finish (_data_->tool, _data_->_res_);
#line 9165 "Runnable.c"
	}
#line 783 "../src/data/Runnable.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 783 "../src/data/Runnable.vala"
	if (_data_->_state_ != 0) {
#line 783 "../src/data/Runnable.vala"
		while (!_data_->_task_complete_) {
#line 783 "../src/data/Runnable.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 9175 "Runnable.c"
		}
	}
#line 783 "../src/data/Runnable.vala"
	g_object_unref (_data_->_async_result);
#line 783 "../src/data/Runnable.vala"
	return FALSE;
#line 9182 "Runnable.c"
}

GameHubDataRunnableRunnableAction*
game_hub_data_runnable_runnable_action_construct (GType object_type)
{
	GameHubDataRunnableRunnableAction* self = NULL;
#line 745 "../src/data/Runnable.vala"
	self = (GameHubDataRunnableRunnableAction*) g_type_create_instance (object_type);
#line 745 "../src/data/Runnable.vala"
	return self;
#line 9193 "Runnable.c"
}

GameHubDataRunnable*
game_hub_data_runnable_runnable_action_get_runnable (GameHubDataRunnableRunnableAction* self)
{
	GameHubDataRunnable* result;
	GameHubDataRunnable* _tmp0_;
#line 747 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 747 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_runnable;
#line 747 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 747 "../src/data/Runnable.vala"
	return result;
#line 9209 "Runnable.c"
}

void
game_hub_data_runnable_runnable_action_set_runnable (GameHubDataRunnableRunnableAction* self,
                                                     GameHubDataRunnable* value)
{
	GameHubDataRunnable* _tmp0_;
#line 747 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 747 "../src/data/Runnable.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 747 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_runnable);
#line 747 "../src/data/Runnable.vala"
	self->priv->_runnable = _tmp0_;
#line 9225 "Runnable.c"
}

gboolean
game_hub_data_runnable_runnable_action_get_is_primary (GameHubDataRunnableRunnableAction* self)
{
	gboolean result;
#line 749 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 749 "../src/data/Runnable.vala"
	result = self->priv->_is_primary;
#line 749 "../src/data/Runnable.vala"
	return result;
#line 9238 "Runnable.c"
}

void
game_hub_data_runnable_runnable_action_set_is_primary (GameHubDataRunnableRunnableAction* self,
                                                       gboolean value)
{
#line 749 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 749 "../src/data/Runnable.vala"
	self->priv->_is_primary = value;
#line 9249 "Runnable.c"
}

gboolean
game_hub_data_runnable_runnable_action_get_is_hidden (GameHubDataRunnableRunnableAction* self)
{
	gboolean result;
#line 750 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 750 "../src/data/Runnable.vala"
	result = self->priv->_is_hidden;
#line 750 "../src/data/Runnable.vala"
	return result;
#line 9262 "Runnable.c"
}

void
game_hub_data_runnable_runnable_action_set_is_hidden (GameHubDataRunnableRunnableAction* self,
                                                      gboolean value)
{
#line 750 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 750 "../src/data/Runnable.vala"
	self->priv->_is_hidden = value;
#line 9273 "Runnable.c"
}

const gchar*
game_hub_data_runnable_runnable_action_get_name (GameHubDataRunnableRunnableAction* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 751 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 751 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_name;
#line 751 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 751 "../src/data/Runnable.vala"
	return result;
#line 9289 "Runnable.c"
}

void
game_hub_data_runnable_runnable_action_set_name (GameHubDataRunnableRunnableAction* self,
                                                 const gchar* value)
{
	gchar* _tmp0_;
#line 751 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 751 "../src/data/Runnable.vala"
	_tmp0_ = g_strdup (value);
#line 751 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_name);
#line 751 "../src/data/Runnable.vala"
	self->priv->_name = _tmp0_;
#line 9305 "Runnable.c"
}

GFile*
game_hub_data_runnable_runnable_action_get_file (GameHubDataRunnableRunnableAction* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 752 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 752 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_file;
#line 752 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 752 "../src/data/Runnable.vala"
	return result;
#line 9321 "Runnable.c"
}

void
game_hub_data_runnable_runnable_action_set_file (GameHubDataRunnableRunnableAction* self,
                                                 GFile* value)
{
	GFile* _tmp0_;
#line 752 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 752 "../src/data/Runnable.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 752 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_file);
#line 752 "../src/data/Runnable.vala"
	self->priv->_file = _tmp0_;
#line 9337 "Runnable.c"
}

GFile*
game_hub_data_runnable_runnable_action_get_workdir (GameHubDataRunnableRunnableAction* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 753 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 753 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_workdir;
#line 753 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 753 "../src/data/Runnable.vala"
	return result;
#line 9353 "Runnable.c"
}

void
game_hub_data_runnable_runnable_action_set_workdir (GameHubDataRunnableRunnableAction* self,
                                                    GFile* value)
{
	GFile* _tmp0_;
#line 753 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 753 "../src/data/Runnable.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 753 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_workdir);
#line 753 "../src/data/Runnable.vala"
	self->priv->_workdir = _tmp0_;
#line 9369 "Runnable.c"
}

const gchar*
game_hub_data_runnable_runnable_action_get_args (GameHubDataRunnableRunnableAction* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 754 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 754 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_args;
#line 754 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 754 "../src/data/Runnable.vala"
	return result;
#line 9385 "Runnable.c"
}

void
game_hub_data_runnable_runnable_action_set_args (GameHubDataRunnableRunnableAction* self,
                                                 const gchar* value)
{
	gchar* _tmp0_;
#line 754 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 754 "../src/data/Runnable.vala"
	_tmp0_ = g_strdup (value);
#line 754 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_args);
#line 754 "../src/data/Runnable.vala"
	self->priv->_args = _tmp0_;
#line 9401 "Runnable.c"
}

GType**
game_hub_data_runnable_runnable_action_get_compat_tools (GameHubDataRunnableRunnableAction* self,
                                                         gint* result_length1)
{
	GType** result;
	GType** _tmp0_;
	gint _tmp0__length1;
	GType** _tmp1_;
	gint _tmp1__length1;
#line 755 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 755 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_compat_tools;
#line 755 "../src/data/Runnable.vala"
	_tmp0__length1 = self->priv->_compat_tools_length1;
#line 755 "../src/data/Runnable.vala"
	_tmp1_ = _tmp0_;
#line 755 "../src/data/Runnable.vala"
	_tmp1__length1 = _tmp0__length1;
#line 755 "../src/data/Runnable.vala"
	if (result_length1) {
#line 755 "../src/data/Runnable.vala"
		*result_length1 = _tmp1__length1;
#line 9427 "Runnable.c"
	}
#line 755 "../src/data/Runnable.vala"
	result = _tmp1_;
#line 755 "../src/data/Runnable.vala"
	return result;
#line 9433 "Runnable.c"
}

static GType**
_vala_array_dup4 (GType** self,
                  int length)
{
	GType** result;
	int i;
#line 755 "../src/data/Runnable.vala"
	result = g_new0 (GType*, length);
#line 755 "../src/data/Runnable.vala"
	for (i = 0; i < length; i++) {
#line 9446 "Runnable.c"
		GType* _tmp0_;
#line 755 "../src/data/Runnable.vala"
		_tmp0_ = __g_type_dup0 (self[i]);
#line 755 "../src/data/Runnable.vala"
		result[i] = _tmp0_;
#line 9452 "Runnable.c"
	}
#line 755 "../src/data/Runnable.vala"
	return result;
#line 9456 "Runnable.c"
}

void
game_hub_data_runnable_runnable_action_set_compat_tools (GameHubDataRunnableRunnableAction* self,
                                                         GType** value,
                                                         gint value_length1)
{
	GType** _tmp0_;
	gint _tmp0__length1;
#line 755 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 755 "../src/data/Runnable.vala"
	_tmp0_ = (value != NULL) ? _vala_array_dup4 (value, value_length1) : ((gpointer) value);
#line 755 "../src/data/Runnable.vala"
	_tmp0__length1 = value_length1;
#line 755 "../src/data/Runnable.vala"
	self->priv->_compat_tools = (_vala_array_free (self->priv->_compat_tools, self->priv->_compat_tools_length1, (GDestroyNotify) g_free), NULL);
#line 755 "../src/data/Runnable.vala"
	self->priv->_compat_tools = _tmp0_;
#line 755 "../src/data/Runnable.vala"
	self->priv->_compat_tools_length1 = _tmp0__length1;
#line 755 "../src/data/Runnable.vala"
	self->priv->__compat_tools_size_ = self->priv->_compat_tools_length1;
#line 9480 "Runnable.c"
}

const gchar*
game_hub_data_runnable_runnable_action_get_uri (GameHubDataRunnableRunnableAction* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 756 "../src/data/Runnable.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 756 "../src/data/Runnable.vala"
	_tmp0_ = self->priv->_uri;
#line 756 "../src/data/Runnable.vala"
	result = _tmp0_;
#line 756 "../src/data/Runnable.vala"
	return result;
#line 9496 "Runnable.c"
}

void
game_hub_data_runnable_runnable_action_set_uri (GameHubDataRunnableRunnableAction* self,
                                                const gchar* value)
{
	gchar* _tmp0_;
#line 756 "../src/data/Runnable.vala"
	g_return_if_fail (self != NULL);
#line 756 "../src/data/Runnable.vala"
	_tmp0_ = g_strdup (value);
#line 756 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_uri);
#line 756 "../src/data/Runnable.vala"
	self->priv->_uri = _tmp0_;
#line 9512 "Runnable.c"
}

static void
game_hub_data_runnable_value_runnable_action_init (GValue* value)
{
#line 745 "../src/data/Runnable.vala"
	value->data[0].v_pointer = NULL;
#line 9520 "Runnable.c"
}

static void
game_hub_data_runnable_value_runnable_action_free_value (GValue* value)
{
#line 745 "../src/data/Runnable.vala"
	if (value->data[0].v_pointer) {
#line 745 "../src/data/Runnable.vala"
		game_hub_data_runnable_runnable_action_unref (value->data[0].v_pointer);
#line 9530 "Runnable.c"
	}
}

static void
game_hub_data_runnable_value_runnable_action_copy_value (const GValue* src_value,
                                                         GValue* dest_value)
{
#line 745 "../src/data/Runnable.vala"
	if (src_value->data[0].v_pointer) {
#line 745 "../src/data/Runnable.vala"
		dest_value->data[0].v_pointer = game_hub_data_runnable_runnable_action_ref (src_value->data[0].v_pointer);
#line 9542 "Runnable.c"
	} else {
#line 745 "../src/data/Runnable.vala"
		dest_value->data[0].v_pointer = NULL;
#line 9546 "Runnable.c"
	}
}

static gpointer
game_hub_data_runnable_value_runnable_action_peek_pointer (const GValue* value)
{
#line 745 "../src/data/Runnable.vala"
	return value->data[0].v_pointer;
#line 9555 "Runnable.c"
}

static gchar*
game_hub_data_runnable_value_runnable_action_collect_value (GValue* value,
                                                            guint n_collect_values,
                                                            GTypeCValue* collect_values,
                                                            guint collect_flags)
{
#line 745 "../src/data/Runnable.vala"
	if (collect_values[0].v_pointer) {
#line 9566 "Runnable.c"
		GameHubDataRunnableRunnableAction * object;
		object = collect_values[0].v_pointer;
#line 745 "../src/data/Runnable.vala"
		if (object->parent_instance.g_class == NULL) {
#line 745 "../src/data/Runnable.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 9573 "Runnable.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 745 "../src/data/Runnable.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 9577 "Runnable.c"
		}
#line 745 "../src/data/Runnable.vala"
		value->data[0].v_pointer = game_hub_data_runnable_runnable_action_ref (object);
#line 9581 "Runnable.c"
	} else {
#line 745 "../src/data/Runnable.vala"
		value->data[0].v_pointer = NULL;
#line 9585 "Runnable.c"
	}
#line 745 "../src/data/Runnable.vala"
	return NULL;
#line 9589 "Runnable.c"
}

static gchar*
game_hub_data_runnable_value_runnable_action_lcopy_value (const GValue* value,
                                                          guint n_collect_values,
                                                          GTypeCValue* collect_values,
                                                          guint collect_flags)
{
	GameHubDataRunnableRunnableAction ** object_p;
	object_p = collect_values[0].v_pointer;
#line 745 "../src/data/Runnable.vala"
	if (!object_p) {
#line 745 "../src/data/Runnable.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 9604 "Runnable.c"
	}
#line 745 "../src/data/Runnable.vala"
	if (!value->data[0].v_pointer) {
#line 745 "../src/data/Runnable.vala"
		*object_p = NULL;
#line 9610 "Runnable.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 745 "../src/data/Runnable.vala"
		*object_p = value->data[0].v_pointer;
#line 9614 "Runnable.c"
	} else {
#line 745 "../src/data/Runnable.vala"
		*object_p = game_hub_data_runnable_runnable_action_ref (value->data[0].v_pointer);
#line 9618 "Runnable.c"
	}
#line 745 "../src/data/Runnable.vala"
	return NULL;
#line 9622 "Runnable.c"
}

GParamSpec*
game_hub_data_runnable_param_spec_runnable_action (const gchar* name,
                                                   const gchar* nick,
                                                   const gchar* blurb,
                                                   GType object_type,
                                                   GParamFlags flags)
{
	GameHubDataRunnableParamSpecRunnableAction* spec;
#line 745 "../src/data/Runnable.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION), NULL);
#line 745 "../src/data/Runnable.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 745 "../src/data/Runnable.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 745 "../src/data/Runnable.vala"
	return G_PARAM_SPEC (spec);
#line 9641 "Runnable.c"
}

gpointer
game_hub_data_runnable_value_get_runnable_action (const GValue* value)
{
#line 745 "../src/data/Runnable.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION), NULL);
#line 745 "../src/data/Runnable.vala"
	return value->data[0].v_pointer;
#line 9651 "Runnable.c"
}

void
game_hub_data_runnable_value_set_runnable_action (GValue* value,
                                                  gpointer v_object)
{
	GameHubDataRunnableRunnableAction * old;
#line 745 "../src/data/Runnable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION));
#line 745 "../src/data/Runnable.vala"
	old = value->data[0].v_pointer;
#line 745 "../src/data/Runnable.vala"
	if (v_object) {
#line 745 "../src/data/Runnable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION));
#line 745 "../src/data/Runnable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 745 "../src/data/Runnable.vala"
		value->data[0].v_pointer = v_object;
#line 745 "../src/data/Runnable.vala"
		game_hub_data_runnable_runnable_action_ref (value->data[0].v_pointer);
#line 9673 "Runnable.c"
	} else {
#line 745 "../src/data/Runnable.vala"
		value->data[0].v_pointer = NULL;
#line 9677 "Runnable.c"
	}
#line 745 "../src/data/Runnable.vala"
	if (old) {
#line 745 "../src/data/Runnable.vala"
		game_hub_data_runnable_runnable_action_unref (old);
#line 9683 "Runnable.c"
	}
}

void
game_hub_data_runnable_value_take_runnable_action (GValue* value,
                                                   gpointer v_object)
{
	GameHubDataRunnableRunnableAction * old;
#line 745 "../src/data/Runnable.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION));
#line 745 "../src/data/Runnable.vala"
	old = value->data[0].v_pointer;
#line 745 "../src/data/Runnable.vala"
	if (v_object) {
#line 745 "../src/data/Runnable.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION));
#line 745 "../src/data/Runnable.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 745 "../src/data/Runnable.vala"
		value->data[0].v_pointer = v_object;
#line 9704 "Runnable.c"
	} else {
#line 745 "../src/data/Runnable.vala"
		value->data[0].v_pointer = NULL;
#line 9708 "Runnable.c"
	}
#line 745 "../src/data/Runnable.vala"
	if (old) {
#line 745 "../src/data/Runnable.vala"
		game_hub_data_runnable_runnable_action_unref (old);
#line 9714 "Runnable.c"
	}
}

static void
game_hub_data_runnable_runnable_action_class_init (GameHubDataRunnableRunnableActionClass * klass,
                                                   gpointer klass_data)
{
#line 745 "../src/data/Runnable.vala"
	game_hub_data_runnable_runnable_action_parent_class = g_type_class_peek_parent (klass);
#line 745 "../src/data/Runnable.vala"
	((GameHubDataRunnableRunnableActionClass *) klass)->finalize = game_hub_data_runnable_runnable_action_finalize;
#line 745 "../src/data/Runnable.vala"
	g_type_class_adjust_private_offset (klass, &GameHubDataRunnableRunnableAction_private_offset);
#line 9728 "Runnable.c"
}

static void
game_hub_data_runnable_runnable_action_instance_init (GameHubDataRunnableRunnableAction * self,
                                                      gpointer klass)
{
	GType** _tmp0_;
#line 745 "../src/data/Runnable.vala"
	self->priv = game_hub_data_runnable_runnable_action_get_instance_private (self);
#line 749 "../src/data/Runnable.vala"
	self->priv->_is_primary = FALSE;
#line 750 "../src/data/Runnable.vala"
	self->priv->_is_hidden = FALSE;
#line 755 "../src/data/Runnable.vala"
	_tmp0_ = g_new0 (GType*, 1);
#line 755 "../src/data/Runnable.vala"
	_tmp0_[0] = NULL;
#line 755 "../src/data/Runnable.vala"
	self->priv->_compat_tools = _tmp0_;
#line 755 "../src/data/Runnable.vala"
	self->priv->_compat_tools_length1 = 1;
#line 755 "../src/data/Runnable.vala"
	self->priv->__compat_tools_size_ = self->priv->_compat_tools_length1;
#line 745 "../src/data/Runnable.vala"
	self->ref_count = 1;
#line 9754 "Runnable.c"
}

static void
game_hub_data_runnable_runnable_action_finalize (GameHubDataRunnableRunnableAction * obj)
{
	GameHubDataRunnableRunnableAction * self;
#line 745 "../src/data/Runnable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION, GameHubDataRunnableRunnableAction);
#line 745 "../src/data/Runnable.vala"
	g_signal_handlers_destroy (self);
#line 747 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_runnable);
#line 751 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_name);
#line 752 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_file);
#line 753 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_workdir);
#line 754 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_args);
#line 755 "../src/data/Runnable.vala"
	self->priv->_compat_tools = (_vala_array_free (self->priv->_compat_tools, self->priv->_compat_tools_length1, (GDestroyNotify) g_free), NULL);
#line 756 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_uri);
#line 9779 "Runnable.c"
}

GType
game_hub_data_runnable_runnable_action_get_type (void)
{
	static volatile gsize game_hub_data_runnable_runnable_action_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_runnable_runnable_action_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { game_hub_data_runnable_value_runnable_action_init, game_hub_data_runnable_value_runnable_action_free_value, game_hub_data_runnable_value_runnable_action_copy_value, game_hub_data_runnable_value_runnable_action_peek_pointer, "p", game_hub_data_runnable_value_runnable_action_collect_value, "p", game_hub_data_runnable_value_runnable_action_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GameHubDataRunnableRunnableActionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_runnable_runnable_action_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataRunnableRunnableAction), 0, (GInstanceInitFunc) game_hub_data_runnable_runnable_action_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType game_hub_data_runnable_runnable_action_type_id;
		game_hub_data_runnable_runnable_action_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GameHubDataRunnableRunnableAction", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		GameHubDataRunnableRunnableAction_private_offset = g_type_add_instance_private (game_hub_data_runnable_runnable_action_type_id, sizeof (GameHubDataRunnableRunnableActionPrivate));
		g_once_init_leave (&game_hub_data_runnable_runnable_action_type_id__volatile, game_hub_data_runnable_runnable_action_type_id);
	}
	return game_hub_data_runnable_runnable_action_type_id__volatile;
}

gpointer
game_hub_data_runnable_runnable_action_ref (gpointer instance)
{
	GameHubDataRunnableRunnableAction * self;
	self = instance;
#line 745 "../src/data/Runnable.vala"
	g_atomic_int_inc (&self->ref_count);
#line 745 "../src/data/Runnable.vala"
	return instance;
#line 9807 "Runnable.c"
}

void
game_hub_data_runnable_runnable_action_unref (gpointer instance)
{
	GameHubDataRunnableRunnableAction * self;
	self = instance;
#line 745 "../src/data/Runnable.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 745 "../src/data/Runnable.vala"
		GAME_HUB_DATA_RUNNABLE_RUNNABLE_ACTION_GET_CLASS (self)->finalize (self);
#line 745 "../src/data/Runnable.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 9821 "Runnable.c"
	}
}

static void
game_hub_data_runnable_class_init (GameHubDataRunnableClass * klass,
                                   gpointer klass_data)
{
#line 27 "../src/data/Runnable.vala"
	game_hub_data_runnable_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/data/Runnable.vala"
	g_type_class_adjust_private_offset (klass, &GameHubDataRunnable_private_offset);
#line 27 "../src/data/Runnable.vala"
	((GameHubDataRunnableClass *) klass)->is_supported = (gboolean (*) (GameHubDataRunnable*, GameHubDataPlatform*, gboolean)) game_hub_data_runnable_real_is_supported;
#line 27 "../src/data/Runnable.vala"
	((GameHubDataRunnableClass *) klass)->run_with_compat = (void (*) (GameHubDataRunnable*, gboolean, GAsyncReadyCallback, gpointer)) game_hub_data_runnable_real_run_with_compat;
#line 27 "../src/data/Runnable.vala"
	((GameHubDataRunnableClass *) klass)->run_with_compat_finish = (void (*) (GameHubDataRunnable*, GAsyncResult*)) game_hub_data_runnable_real_run_with_compat_finish;
#line 27 "../src/data/Runnable.vala"
	((GameHubDataRunnableClass *) klass)->setup_executable_chooser = (GtkFileChooser* (*) (GameHubDataRunnable*)) game_hub_data_runnable_real_setup_executable_chooser;
#line 27 "../src/data/Runnable.vala"
	((GameHubDataRunnableClass *) klass)->choose_executable = (void (*) (GameHubDataRunnable*, gboolean)) game_hub_data_runnable_real_choose_executable;
#line 27 "../src/data/Runnable.vala"
	((GameHubDataRunnableClass *) klass)->set_chosen_executable = (void (*) (GameHubDataRunnable*, GFile*, gboolean)) game_hub_data_runnable_real_set_chosen_executable;
#line 27 "../src/data/Runnable.vala"
	((GameHubDataRunnableClass *) klass)->save = (void (*) (GameHubDataRunnable*)) game_hub_data_runnable_real_save;
#line 27 "../src/data/Runnable.vala"
	((GameHubDataRunnableClass *) klass)->update_status = (void (*) (GameHubDataRunnable*)) game_hub_data_runnable_real_update_status;
#line 27 "../src/data/Runnable.vala"
	((GameHubDataRunnableClass *) klass)->import = (void (*) (GameHubDataRunnable*, gboolean)) game_hub_data_runnable_real_import;
#line 27 "../src/data/Runnable.vala"
	GAME_HUB_DATA_RUNNABLE_CLASS (klass)->get_default_install_dir = game_hub_data_runnable_real_get_default_install_dir;
#line 27 "../src/data/Runnable.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_hub_data_runnable_get_property;
#line 27 "../src/data/Runnable.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_hub_data_runnable_set_property;
#line 27 "../src/data/Runnable.vala"
	G_OBJECT_CLASS (klass)->finalize = game_hub_data_runnable_finalize;
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_ID_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_ID_PROPERTY] = g_param_spec_string ("id", "id", "id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_ESCAPED_NAME_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_ESCAPED_NAME_PROPERTY] = g_param_spec_string ("escaped-name", "escaped-name", "escaped-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_NORMALIZED_NAME_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_NORMALIZED_NAME_PROPERTY] = g_param_spec_string ("normalized-name", "normalized-name", "normalized-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_NAME_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_COMPAT_TOOL_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_COMPAT_TOOL_PROPERTY] = g_param_spec_string ("compat-tool", "compat-tool", "compat-tool", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_COMPAT_TOOL_SETTINGS_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_COMPAT_TOOL_SETTINGS_PROPERTY] = g_param_spec_string ("compat-tool-settings", "compat-tool-settings", "compat-tool-settings", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_ARGUMENTS_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_ARGUMENTS_PROPERTY] = g_param_spec_string ("arguments", "arguments", "arguments", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_IS_RUNNING_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_IS_RUNNING_PROPERTY] = g_param_spec_boolean ("is-running", "is-running", "is-running", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_PLATFORMS_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_PLATFORMS_PROPERTY] = g_param_spec_object ("platforms", "platforms", "platforms", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_EXECUTABLE_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_EXECUTABLE_PROPERTY] = g_param_spec_object ("executable", "executable", "executable", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_INSTALL_DIR_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_INSTALL_DIR_PROPERTY] = g_param_spec_object ("install-dir", "install-dir", "install-dir", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_DEFAULT_INSTALL_DIR_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_DEFAULT_INSTALL_DIR_PROPERTY] = g_param_spec_object ("default-install-dir", "default-install-dir", "default-install-dir", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_ACTIONS_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_ACTIONS_PROPERTY] = g_param_spec_object ("actions", "actions", "actions", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_USE_COMPAT_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_USE_COMPAT_PROPERTY] = g_param_spec_boolean ("use-compat", "use-compat", "use-compat", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_NEEDS_COMPAT_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_NEEDS_COMPAT_PROPERTY] = g_param_spec_boolean ("needs-compat", "needs-compat", "needs-compat", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_FORCE_COMPAT_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_FORCE_COMPAT_PROPERTY] = g_param_spec_boolean ("force-compat", "force-compat", "force-compat", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 27 "../src/data/Runnable.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_HUB_DATA_RUNNABLE_COMPAT_OPTIONS_SAVED_PROPERTY, game_hub_data_runnable_properties[GAME_HUB_DATA_RUNNABLE_COMPAT_OPTIONS_SAVED_PROPERTY] = g_param_spec_boolean ("compat-options-saved", "compat-options-saved", "compat-options-saved", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 9893 "Runnable.c"
}

static void
game_hub_data_runnable_instance_init (GameHubDataRunnable * self,
                                      gpointer klass)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
#line 27 "../src/data/Runnable.vala"
	self->priv = game_hub_data_runnable_get_instance_private (self);
#line 54 "../src/data/Runnable.vala"
	self->priv->_is_running = FALSE;
#line 56 "../src/data/Runnable.vala"
	_tmp0_ = gee_array_list_new (GAME_HUB_DATA_TYPE_PLATFORM, NULL, NULL, NULL, NULL, NULL);
#line 56 "../src/data/Runnable.vala"
	self->priv->_platforms = _tmp0_;
#line 73 "../src/data/Runnable.vala"
	_tmp1_ = gee_array_list_new (GAME_HUB_DATA_RUNNABLE_TYPE_RUNNABLE_ACTION, (GBoxedCopyFunc) game_hub_data_runnable_runnable_action_ref, (GDestroyNotify) game_hub_data_runnable_runnable_action_unref, NULL, NULL, NULL);
#line 73 "../src/data/Runnable.vala"
	self->priv->_actions = _tmp1_;
#line 9914 "Runnable.c"
}

static void
game_hub_data_runnable_finalize (GObject * obj)
{
	GameHubDataRunnable * self;
#line 27 "../src/data/Runnable.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnable);
#line 29 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_id);
#line 31 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_name);
#line 32 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_escaped_name);
#line 33 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_normalized_name);
#line 49 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_compat_tool);
#line 50 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_compat_tool_settings);
#line 52 "../src/data/Runnable.vala"
	_g_free0 (self->priv->_arguments);
#line 56 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_platforms);
#line 70 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_install_dir);
#line 73 "../src/data/Runnable.vala"
	_g_object_unref0 (self->priv->_actions);
#line 27 "../src/data/Runnable.vala"
	G_OBJECT_CLASS (game_hub_data_runnable_parent_class)->finalize (obj);
#line 9945 "Runnable.c"
}

GType
game_hub_data_runnable_get_type (void)
{
	static volatile gsize game_hub_data_runnable_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_runnable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameHubDataRunnableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_hub_data_runnable_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GameHubDataRunnable), 0, (GInstanceInitFunc) game_hub_data_runnable_instance_init, NULL };
		GType game_hub_data_runnable_type_id;
		game_hub_data_runnable_type_id = g_type_register_static (G_TYPE_OBJECT, "GameHubDataRunnable", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		GameHubDataRunnable_private_offset = g_type_add_instance_private (game_hub_data_runnable_type_id, sizeof (GameHubDataRunnablePrivate));
		g_once_init_leave (&game_hub_data_runnable_type_id__volatile, game_hub_data_runnable_type_id);
	}
	return game_hub_data_runnable_type_id__volatile;
}

static void
_vala_game_hub_data_runnable_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	GameHubDataRunnable * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnable);
#line 27 "../src/data/Runnable.vala"
	switch (property_id) {
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_ID_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_string (value, game_hub_data_runnable_get_id (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_ESCAPED_NAME_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_string (value, game_hub_data_runnable_get_escaped_name (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_NORMALIZED_NAME_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_string (value, game_hub_data_runnable_get_normalized_name (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_NAME_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_string (value, game_hub_data_runnable_get_name (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_COMPAT_TOOL_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_string (value, game_hub_data_runnable_get_compat_tool (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_COMPAT_TOOL_SETTINGS_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_string (value, game_hub_data_runnable_get_compat_tool_settings (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_ARGUMENTS_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_string (value, game_hub_data_runnable_get_arguments (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_IS_RUNNING_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_boolean (value, game_hub_data_runnable_get_is_running (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_PLATFORMS_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_object (value, game_hub_data_runnable_get_platforms (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_INSTALL_DIR_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_object (value, game_hub_data_runnable_get_install_dir (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_DEFAULT_INSTALL_DIR_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_take_object (value, game_hub_data_runnable_get_default_install_dir (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_ACTIONS_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_object (value, game_hub_data_runnable_get_actions (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_USE_COMPAT_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_boolean (value, game_hub_data_runnable_get_use_compat (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_NEEDS_COMPAT_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_boolean (value, game_hub_data_runnable_get_needs_compat (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_FORCE_COMPAT_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_boolean (value, game_hub_data_runnable_get_force_compat (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_COMPAT_OPTIONS_SAVED_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		g_value_set_boolean (value, game_hub_data_runnable_get_compat_options_saved (self));
#line 27 "../src/data/Runnable.vala"
		break;
#line 10068 "Runnable.c"
		default:
#line 27 "../src/data/Runnable.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/data/Runnable.vala"
		break;
#line 10074 "Runnable.c"
	}
}

static void
_vala_game_hub_data_runnable_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	GameHubDataRunnable * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GAME_HUB_DATA_TYPE_RUNNABLE, GameHubDataRunnable);
#line 27 "../src/data/Runnable.vala"
	switch (property_id) {
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_ID_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_id (self, g_value_get_string (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_ESCAPED_NAME_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_escaped_name (self, g_value_get_string (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_NORMALIZED_NAME_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_normalized_name (self, g_value_get_string (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_NAME_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_name (self, g_value_get_string (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_COMPAT_TOOL_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_compat_tool (self, g_value_get_string (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_COMPAT_TOOL_SETTINGS_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_compat_tool_settings (self, g_value_get_string (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_ARGUMENTS_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_arguments (self, g_value_get_string (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_IS_RUNNING_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_is_running (self, g_value_get_boolean (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_PLATFORMS_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_platforms (self, g_value_get_object (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_INSTALL_DIR_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_install_dir (self, g_value_get_object (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_ACTIONS_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_actions (self, g_value_get_object (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_FORCE_COMPAT_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_force_compat (self, g_value_get_boolean (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 27 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_RUNNABLE_COMPAT_OPTIONS_SAVED_PROPERTY:
#line 27 "../src/data/Runnable.vala"
		game_hub_data_runnable_set_compat_options_saved (self, g_value_get_boolean (value));
#line 27 "../src/data/Runnable.vala"
		break;
#line 10166 "Runnable.c"
		default:
#line 27 "../src/data/Runnable.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/data/Runnable.vala"
		break;
#line 10172 "Runnable.c"
	}
}

gchar*
game_hub_data_platform_id (GameHubDataPlatform self)
{
	gchar* result = NULL;
#line 808 "../src/data/Runnable.vala"
	switch (self) {
#line 808 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_PLATFORM_LINUX:
#line 10184 "Runnable.c"
		{
			gchar* _tmp0_;
#line 810 "../src/data/Runnable.vala"
			_tmp0_ = g_strdup ("linux");
#line 810 "../src/data/Runnable.vala"
			result = _tmp0_;
#line 810 "../src/data/Runnable.vala"
			return result;
#line 10193 "Runnable.c"
		}
#line 808 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_PLATFORM_WINDOWS:
#line 10197 "Runnable.c"
		{
			gchar* _tmp1_;
#line 811 "../src/data/Runnable.vala"
			_tmp1_ = g_strdup ("windows");
#line 811 "../src/data/Runnable.vala"
			result = _tmp1_;
#line 811 "../src/data/Runnable.vala"
			return result;
#line 10206 "Runnable.c"
		}
#line 808 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_PLATFORM_MACOS:
#line 10210 "Runnable.c"
		{
			gchar* _tmp2_;
#line 812 "../src/data/Runnable.vala"
			_tmp2_ = g_strdup ("mac");
#line 812 "../src/data/Runnable.vala"
			result = _tmp2_;
#line 812 "../src/data/Runnable.vala"
			return result;
#line 10219 "Runnable.c"
		}
#line 808 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_PLATFORM_EMULATED:
#line 10223 "Runnable.c"
		{
			gchar* _tmp3_;
#line 813 "../src/data/Runnable.vala"
			_tmp3_ = g_strdup ("emulated");
#line 813 "../src/data/Runnable.vala"
			result = _tmp3_;
#line 813 "../src/data/Runnable.vala"
			return result;
#line 10232 "Runnable.c"
		}
		default:
#line 808 "../src/data/Runnable.vala"
		break;
#line 10237 "Runnable.c"
	}
#line 815 "../src/data/Runnable.vala"
	g_assert_not_reached ();
#line 10241 "Runnable.c"
}

gchar*
game_hub_data_platform_name (GameHubDataPlatform self)
{
	gchar* result = NULL;
#line 820 "../src/data/Runnable.vala"
	switch (self) {
#line 820 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_PLATFORM_LINUX:
#line 10252 "Runnable.c"
		{
			gchar* _tmp0_;
#line 822 "../src/data/Runnable.vala"
			_tmp0_ = g_strdup ("Linux");
#line 822 "../src/data/Runnable.vala"
			result = _tmp0_;
#line 822 "../src/data/Runnable.vala"
			return result;
#line 10261 "Runnable.c"
		}
#line 820 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_PLATFORM_WINDOWS:
#line 10265 "Runnable.c"
		{
			gchar* _tmp1_;
#line 823 "../src/data/Runnable.vala"
			_tmp1_ = g_strdup ("Windows");
#line 823 "../src/data/Runnable.vala"
			result = _tmp1_;
#line 823 "../src/data/Runnable.vala"
			return result;
#line 10274 "Runnable.c"
		}
#line 820 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_PLATFORM_MACOS:
#line 10278 "Runnable.c"
		{
			gchar* _tmp2_;
#line 824 "../src/data/Runnable.vala"
			_tmp2_ = g_strdup ("macOS");
#line 824 "../src/data/Runnable.vala"
			result = _tmp2_;
#line 824 "../src/data/Runnable.vala"
			return result;
#line 10287 "Runnable.c"
		}
#line 820 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_PLATFORM_EMULATED:
#line 10291 "Runnable.c"
		{
			gchar* _tmp3_;
#line 825 "../src/data/Runnable.vala"
			_tmp3_ = g_strdup (C_ ("platform", "Emulated"));
#line 825 "../src/data/Runnable.vala"
			result = _tmp3_;
#line 825 "../src/data/Runnable.vala"
			return result;
#line 10300 "Runnable.c"
		}
		default:
#line 820 "../src/data/Runnable.vala"
		break;
#line 10305 "Runnable.c"
	}
#line 827 "../src/data/Runnable.vala"
	g_assert_not_reached ();
#line 10309 "Runnable.c"
}

gchar*
game_hub_data_platform_icon (GameHubDataPlatform self)
{
	gchar* result = NULL;
#line 832 "../src/data/Runnable.vala"
	switch (self) {
#line 832 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_PLATFORM_LINUX:
#line 10320 "Runnable.c"
		{
			gchar* _tmp0_;
#line 834 "../src/data/Runnable.vala"
			_tmp0_ = g_strdup ("platform-linux-symbolic");
#line 834 "../src/data/Runnable.vala"
			result = _tmp0_;
#line 834 "../src/data/Runnable.vala"
			return result;
#line 10329 "Runnable.c"
		}
#line 832 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_PLATFORM_WINDOWS:
#line 10333 "Runnable.c"
		{
			gchar* _tmp1_;
#line 835 "../src/data/Runnable.vala"
			_tmp1_ = g_strdup ("platform-windows-symbolic");
#line 835 "../src/data/Runnable.vala"
			result = _tmp1_;
#line 835 "../src/data/Runnable.vala"
			return result;
#line 10342 "Runnable.c"
		}
#line 832 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_PLATFORM_MACOS:
#line 10346 "Runnable.c"
		{
			gchar* _tmp2_;
#line 836 "../src/data/Runnable.vala"
			_tmp2_ = g_strdup ("platform-macos-symbolic");
#line 836 "../src/data/Runnable.vala"
			result = _tmp2_;
#line 836 "../src/data/Runnable.vala"
			return result;
#line 10355 "Runnable.c"
		}
#line 832 "../src/data/Runnable.vala"
		case GAME_HUB_DATA_PLATFORM_EMULATED:
#line 10359 "Runnable.c"
		{
			gchar* _tmp3_;
#line 837 "../src/data/Runnable.vala"
			_tmp3_ = g_strdup ("gamehub-symbolic");
#line 837 "../src/data/Runnable.vala"
			result = _tmp3_;
#line 837 "../src/data/Runnable.vala"
			return result;
#line 10368 "Runnable.c"
		}
		default:
#line 832 "../src/data/Runnable.vala"
		break;
#line 10373 "Runnable.c"
	}
#line 839 "../src/data/Runnable.vala"
	g_assert_not_reached ();
#line 10377 "Runnable.c"
}

GType
game_hub_data_platform_get_type (void)
{
	static volatile gsize game_hub_data_platform_type_id__volatile = 0;
	if (g_once_init_enter (&game_hub_data_platform_type_id__volatile)) {
		static const GEnumValue values[] = {{GAME_HUB_DATA_PLATFORM_LINUX, "GAME_HUB_DATA_PLATFORM_LINUX", "linux"}, {GAME_HUB_DATA_PLATFORM_WINDOWS, "GAME_HUB_DATA_PLATFORM_WINDOWS", "windows"}, {GAME_HUB_DATA_PLATFORM_MACOS, "GAME_HUB_DATA_PLATFORM_MACOS", "macos"}, {GAME_HUB_DATA_PLATFORM_EMULATED, "GAME_HUB_DATA_PLATFORM_EMULATED", "emulated"}, {0, NULL, NULL}};
		GType game_hub_data_platform_type_id;
		game_hub_data_platform_type_id = g_enum_register_static ("GameHubDataPlatform", values);
		g_once_init_leave (&game_hub_data_platform_type_id__volatile, game_hub_data_platform_type_id);
	}
	return game_hub_data_platform_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

